
Import "hardwiredlib.cpp"

Extern

	' Wrapper functions...

	Function InitDLL:Int ()
	Function FreeDLL:Void ()

	' C-string hack by Pharmhaus!

	Function NativeCString:CStringNative(S:String)
		Class CStringNative Abstract
	End

	' Hardwired functions...

	Function dxCountGfxDrivers:Int ()
	Function dxGraphics3D:Int (width:Int, height:Int, depth:Int, mode:Int)
	Function dxEndGraphics:Void ()
	Function dxShowMouse:Void ()
	Function dxHideMouse:Void ()
	Function dxKeyDown:Int (key:Int)
	Function dxMouseDown:Int (button:Int)
	Function dxGetMouse:Int ()
	Function dxMouseHit:Int (button:Int)
	Function dxWaitMouse:Void ()
	Function dxMouseX:Int ()
	Function dxMouseY:Int ()
	Function dxMouseZ:Int ()
	Function dxMoveMouse:Void (x:Int, y:Int)
	Function dxFlushMouse:Void ()
	Function dxMouseXSpeed:Int ()
	Function dxMouseYSpeed:Int ()
	Function dxMouseZSpeed:Int ()
	Function dxKeyHit:Int (key:Int)
	Function dxFlushKeys:Void ()
	Function dxWaitKey:Void ()
	Function dxLoadFont:Int (filename:CStringNative, height:Int, bold:Int, italic:Int, underline:Int)
	Function dxCls:Void ()
	Function dxClsColor:Void (red:Float, green:Float, blue:Float)
	Function dxFlip:Void (vsync:Int)
	Function dxFrontBuffer:Int ()
	Function dxBackBuffer:Int ()
	Function dxColor:Void (red:Int, green:Int, blue:Int)
	Function dxPlot:Void (x:Int, y:Int)
	Function dxCreateMesh:Int (parent:Int)
	Function dxCreateCamera:Int (parent:Int)
	Function dxPositionEntity:Void (entity:Int, x:Float, y:Float, z:Float, _global:Int)
	Function dxCreateTeapot:Int (parent:Int)
	Function dxRenderWorld:Void (tween:Int)
	Function dxAddVertex:Int (surface:Int, x:Float, y:Float, z:Float, u:Float, v:Float, w:Float)
	Function dxCreateSurface:Int (mesh:Int)
	Function dxCountVertices:Int (surface:Int)
	Function dxVertexColor:Void (surface:Int, index:Int, red:Float, green:Float, blue:Float, alpha:Float)
	Function dxVertexRed:Int (surface:Int, index:Int)
	Function dxVertexGreen:Int (surface:Int, index:Int)
	Function dxVertexBlue:Int (surface:Int, index:Int)
	Function dxVertexAlpha:Float (surface:Int, index:Int)
	Function dxVertexTexCoords:Void (surface:Int, index:Int, texture_u:Float, texture_v:Float, texture_w:Float, coord_set:Int)
	Function dxVertexNormal:Void (surface:Int, index:Int, x_normal:Float, y_normal:Float, z_normal:Float)
	Function dxVertexX:Float (surface:Int, index:Int)
	Function dxVertexY:Float (surface:Int, index:Int)
	Function dxVertexZ:Float (surface:Int, index:Int)
	Function dxVertexNX:Float (surface:Int, index:Int)
	Function dxVertexNY:Float (surface:Int, index:Int)
	Function dxVertexNZ:Float (surface:Int, index:Int)
	Function dxVertexU:Float (surface:Int, index:Int)
	Function dxVertexV:Float (surface:Int, index:Int)
	Function dxVertexW:Float (surface:Int, index:Int)
	Function dxCountSurfaces:Int (mesh:Int)
	Function dxClearSurface:Void (surface:Int, vertices:Int, triangles:Int)
	Function dxAddTriangle:Int (surface:Int, vertex_1:Int, vertex_2:Int, vertex_3:Int)
	Function dxCountTriangles:Int (surface:Int)
	Function dxTriangleVertex:Int (surface:Int, triangle_index:Int, corner:Int)
	Function dxAmbientLight:Void (red:Int, green:Int, blue:Int)
	Function dxCameraViewport:Int (camera:Int, x:Int, y:Int, width:Int, height:Int)
	Function dxCameraClsColor:Void (camera:Int, red:Int, green:Int, blue:Int)
	Function dxCameraProjMode:Void (camera:Int, projection_mode:Int)
	Function dxCameraRange:Void (camera:Int, near:Float, far:Float)
	Function dxCameraClsMode:Void (camera:Int, cls_color:Int, z_buffer:Int)
	Function dxCameraAspect:Void (camera:Int, aspect_ratio:Float)
	Function dxAutoCameraAspect:Void (camera:Int)
	Function dxCameraFOV:Void (camera:Int, focus:Float)
	Function dxGetCameraFOV:Float (camera:Int)
	Function dxGetCameraAspect:Float (camera:Int)
	Function dxCreateTorus:Int (inner_radius:Float, outer_radius:Float, sides:Int, rings:Int)
	Function dxCreateCube:Int (parent:Int)
	Function dxCreateCylinder:Int (radius1:Float, radius2:Float, length:Float, slices:Int, stacks:Int)
	Function dxCreateSphere:Int (segments:Int, parent:Int)
	Function dxFreeEntity:Void (entity:Int)
	Function dxEntityParent:Void (entity:Int, parent:Int)
	Function dxCountChildren:Int (entity:Int)
	Function dxGetChild:Int (entity:Int, index:Int)
	Function dxEntityClass:CStringNative (entity:Int)
	Function dxGetParent:Int (entity:Int)
	Function dxNameEntity:Void (entity:Int, name:CStringNative)
	Function dxEntityName:CStringNative (entity:Int)
	Function dxEntityX:Float (entity:Int, _global:Int)
	Function dxEntityY:Float (entity:Int, _global:Int)
	Function dxEntityZ:Float (entity:Int, _global:Int)
	Function dxRotateEntity:Void (entity:Int, pitch:Float, yaw:Float, roll:Float, _global:Int)
	Function dxGetMatElement:Float (entity:Int, row:Int, column:Int)
	Function dxUpdateNormals:Void (mesh:Int)
	Function dxCreateTexture:Int (width:Int, height:Int, flags:Int, frames:Int)
	Function dxTurnEntity:Void (entity:Int, pitch:Float, yaw:Float, roll:Float, _global:Int)
	Function dxMoveEntity:Void (entity:Int, x:Float, y:Float, z:Float)
	Function dxTranslateEntity:Void (entity:Int, x:Float, y:Float, z:Float, _global:Int)
	Function dxEntityRed:Int (entity:Int)
	Function dxEntityGreen:Int (entity:Int)
	Function dxEntityBlue:Int (entity:Int)
	Function dxEntityColor:Void (entity:Int, red:Int, green:Int, blue:Int)
	Function dxEntityFX:Void (entity:Int, fx:Int)
	Function dxGetEntityFX:Void (entity:Int)
	Function dxDither:Void (state:Int)
	Function dxCameraFogMode:Void (camera:Int, state:Int)
	Function dxCameraFogColor:Void (camera:Int, red:Int, green:Int, blue:Int)
	Function dxCameraFogRange:Void (camera:Int, near:Float, far:Float)
	Function dxLoadTexture:Int (file:CStringNative, flags:Int)
	Function dxEntityTexture:Void (entity:Int, texture:Int, frame:Int, index:Int)
	Function dxCountGfxModes3D:Int ()
	Function dxGfxModeWidth:Int (adapter:Int)
	Function dxGfxModeHeight:Int (adapter:Int)
	Function dxGfxModeDepth:Int (adapter:Int)
	Function dxGfxModeRefreshRate:Int (adapter:Int)
	Function dxWireframe:Void (enable:Int)
	Function dxEntityWireframe:Void (entity:Int, enable:Int)
	Function dxPointframe:Void (enable:Int)
	Function dxEntityPointframe:Void (entity:Int, enable:Int)
	Function dxScaleEntity:Void (entity:Int, scale_x:Float, scale_y:Float, scale_z:Float, _global:Int)
	Function dxEntityScaleX:Float (entity:Int)
	Function dxEntityScaleY:Float (entity:Int)
	Function dxEntityScaleZ:Float (entity:Int)
	Function dxCreateLight:Int (_type:Int, parent:Int)
	Function dxColorRed:Int ()
	Function dxColorGreen:Int ()
	Function dxColorBlue:Int ()
	Function dxGraphicsBuffer:Int ()
	Function dxSetBuffer:Int (buffer:Int)
	Function dxCreateText:Int (text:CStringNative, extrusion:Float)
	Function dx3DFont:Int (font:CStringNative, bold:Int, italic:Int, underline:Int, strikeout:Int)
	Function dxRect:Void (x:Int, y:Int, width:Int, height:Int, solid:Int)
	Function dxTextureBuffer:Int (texture:Int)
	Function dxGraphicsWidth:Int ()
	Function dxGraphicsHeight:Int ()
	Function dxGraphicsDepth:Int ()
	Function dxGetColor:Void (x:Int, y:Int)
	Function dxReadPixel:Int (x:Int, y:Int, buffer:Int)
	Function dxLightColor:Void (light:Int, red:Int, green:Int, blue:Int)
	Function dxLightRange:Void (light:Int, range:Float)
	Function dxLightConeAngles:Void (light:Int, inner_angle:Float, outer_angle:Float)
	Function dxHideEntity:Void (entity:Int)
	Function dxShowEntity:Void (entity:Int)
	Function dxEntityOrder:Void (entity:Int, order:Int)
	Function dxOval:Void (x:Int, y:Int, width:Int, height:Int, solid:Int)
	Function dxLine:Void (x1:Int, y1:Int, x2:Int, y2:Int)
	Function dxText:Void (x:Int, y:Int, text:CStringNative, center_x:Int, center_y:Int)
	Function dxSetFont:Void (font:Int)
	Function dxFreeFont:Void (font:Int)
	Function dxUpdateSurfaceNormals:Void (surface:Int)
	Function dxWBuffer:Void (enable:Int)
	Function dxPixelShaderVersion:Int ()
	Function dxVertexShaderVersion:Int ()
	Function dxCreatePixelShader:Int (operation:CStringNative, file:CStringNative, entry_point:CStringNative, version:CStringNative)
	Function dxFreePixelShader:Void (pixel_shader:Int)
	Function dxCreateVertexShader:Int (operation:CStringNative, file:CStringNative, entry_point:CStringNative, version:CStringNative)
	Function dxFreeVertexShader:Void (vertex_shader:Int)
	Function dxEntityPixelShader:Void (entity:Int, pixel_shader:Int)
	Function dxEntityVertexShader:Void (entity:Int, vertex_shader:Int)
	Function dxGetLastShaderError:CStringNative ()
	Function dxVertexCoords:Void (surface:Int, vertex:Int, x:Float, y:Float, z:Float)
	Function dxFlipMesh:Void (mesh:Int)
	Function dxApptitle:Void (title:CStringNative)
	Function dxCountEntities:Int ()
	Function dxGetSurface:Int (mesh:Int, surface:Int)
	Function dxFirstEntity:Int ()
	Function dxNextEntity:Int (present_entity:Int)
	Function dxPreviousEntity:Int (present_entity:Int)
	Function dxEntityBlend:Void (entity:Int, blend:Int)
	Function dxCopyEntity:Int (entity:Int, parent:Int)
	Function dxFreeSurface:Void (surface:Int)
	Function dxTextureBlend:Void (texture:Int, blend:Int)
	Function dxGetVersion:Float ()
	Function dxStringWidth:Int (_string:CStringNative)
	Function dxStringHeight:Int (_string:CStringNative)
	Function dxCreateBrush:Int (red:Float, green:Float, blue:Float)
	Function dxFreeBrush:Void (brush:Int)
	Function dxBrushColor:Void (brush:Int, red:Float, green:Float, blue:Float)
	Function dxBrushAlpha:Void (brush:Int, alpha:Float)
	Function dxBrushShininess:Void (brush:Int, shininess:Float)
	Function dxBrushFX:Void (brush:Int, fx:Int)
	Function dxBrushTexture:Void (brush:Int, texture:Int, frame:Int, index:Int)
	Function dxBrushBlend:Void (brush:Int, blend:Int)
	Function dxGetEntityBrush:Int (entity:Int)
	Function dxNameTexture:Void (texture:Int, name:CStringNative)
	Function dxTextureName:CStringNative (texture:Int)
	Function dxTextureCoords:Void (texture:Int, coord_set:Int)
	Function dxTextureWidth:Int (texture:Int)
	Function dxTextureHeight:Int (texture:Int)
	Function dxGetDebugFloat:Float ()
	Function dxScaleTexture:Void (texture:Int, u_scale:Float, v_scale:Float)
	Function dxPositionTexture:Void (texture:Int, u_position:Float, v_position:Float)
	Function dxRotateTexture:Void (texture:Int, angle:Float)
	Function dxEntityAlpha:Void (entity:Int, alpha:Float)
	Function dxGetEntityAlpha:Float (entity:Int)
	Function dxPositionMesh:Void (mesh:Int, x:Float, y:Float, z:Float)
	Function dxMeshWidth:Float (mesh:Int)
	Function dxMeshHeight:Float (mesh:Int)
	Function dxMeshDepth:Float (mesh:Int)
	Function dxEntityPitch:Float (entity:Int, _global:Int)
	Function dxEntityYaw:Float (entity:Int, _global:Int)
	Function dxEntityRoll:Float (entity:Int, _global:Int)
	Function dxFreeSurfaceAttribs:Void (surface:Int)
	Function dxSurfaceFx:Void (surface:Int, fx:Int)
	Function dxSurfaceBlend:Void (surface:Int, blend:Int)
	Function dxSurfaceAlpha:Void (surface:Int, alpha:Float)
	Function dxSurfaceWireframe:Void (surface:Int, enable:Int)
	Function dxSurfacePointframe:Void (surface:Int, enable:Int)
	Function dxSurfacePixelShader:Void (surface:Int, pixel_shader:Int)
	Function dxSurfaceVertexShader:Void (surface:Int, vertex_shader:Int)
	Function dxSurfaceColor:Void (surface:Int, red:Int, green:Int, blue:Int)
	Function dxGetSurfaceBrush:Int (surface:Int)
	Function dxPaintEntity:Void (entity:Int, brush:Int)
	Function dxPaintSurface:Void (surface:Int, brush:Int)
	Function dxSurfaceTexture:Void (surf:Int, texture:Int, frame:Int, index:Int)
	Function dxWritePixel:Void (x:Int, y:Int, argb:Int, buffer:Int)
	Function dxLockBuffer:Void (buffer:Int)
	Function dxUnLockBuffer:Void (buffer:Int)
	Function dxWritePixelFast:Void (x:Int, y:Int, argb:Int, buffer:Int)
	Function dxReadPixelFast:Int (x:Int, y:Int, buffer:Int)
	Function dxTextureSave:Void (texture:Int, filename:CStringNative, _type:Int)
	Function dxCopySurface:Int (surface:Int, parent_entity:Int)
	Function dxCopyMesh:Int (entity:Int, parent:Int)
	Function dxCreateImage:Int (width:Int, height:Int, frames:Int)
	Function dxFreeImage:Void (image:Int)
	Function dxImageWidth:Int (image:Int)
	Function dxImageHeight:Int (image:Int)
	Function dxImageBuffer:Int (image:Int)
	Function dxCopyImage:Int (image:Int)
	Function dxCopyRect:Int (src_x:Int, src_y:Int, src_width:Int, src_height:Int, dest_x:Int, dest_y:Int, src_buffer:Int, dest_buffer:Int)
	Function dxSetFilters:Void (_max:Int, _min:Int, mip:Int)
	Function dxRenderToTexture:Void (texture:Int)
	Function dxRenderToScreen:Void ()
	Function dxCreateSprite:Int (parent:Int)
	Function dxSpriteViewMode:Void (sprite:Int, view_mode:Int)
	Function dxScaleSprite:Void (sprite:Int, x_scale:Float, y_scale:Float)
	Function dxHandleSprite:Void (sprite:Int, x:Float, y:Float)
	Function dxUseDirectX11:Int (enable:Int)
	Function dxDirectX11Used:Int ()
	Function dxSeedRnd:Void (seed:Int)
	Function dxRnd:Float (low:Float, high:Float)
	Function dxRand:Int (low:Int, high:Int)
	Function dxCreatePivot:Int (parent:Int)
	Function dxBufferNoise:Void (buffer:Int, x:Int, y:Int, w:Int, h:Int, red_filter:Float, green_filter:Float, blue_filter:Float, alpha_filter:Float)
	Function dxBufferInvert:Void (buffer:Int, x:Int, y:Int, w:Int, h:Int)
	Function dxSetCubeFace:Void (texture:Int, face:Int)
	Function dxGetSurfaceBoundingRadius:Float (surface:Int)
	Function dxTrisRendered:Int ()
	Function dxEntityInView:Int (entity:Int, camera:Int)
	Function dxMaxLights:Int ()
	Function dxCreateTerrain:Int (grid_size:Int, parent:Int)
	Function dxModifyTerrain:Void (terrain:Int, grid_x:Int, grid_z:Int, height:Float, realtime:Int)
	Function dxTerrainSize:Int (terrain:Int)
	Function dxLoadTerrain:Int (file:CStringNative, parent:Int)
	Function dxTerrainHeight:Float (terrain:Int, grid_x:Float, grid_z:Float)
	Function dxFitMesh:Void (mesh:Int, x:Float, y:Float, z:Float, w:Float, h:Float, d:Float, uniform:Int)
	Function dxScaleMesh:Void (mesh:Int, width:Float, height:Float, depth:Float)
	Function dxGetConstantTableSize:Int (shader:Int)
	Function dxConstantCount:Int (shader:Int)
	Function dxDeclareVertexShaderWorldConstant:Void (shader:Int, constant_name:CStringNative)
	Function dxDeclareVertexShaderViewConstant:Void (shader:Int, constant_name:CStringNative)
	Function dxDeclareVertexShaderProjConstant:Void (shader:Int, constant_name:CStringNative)
	Function dxDeclareVertexShaderWorldViewProjConstant:Void (shader:Int, constant_name:CStringNative)
	Function dxEntityRadius:Void (entity:Int, radius_x:Float, radius_y:Float)
	Function dxEntityBox:Void (entity:Int, x:Float, y:Float, z:Float, width:Float, height:Float, depth:Float)
	Function dxEntityType:Void (entity:Int, collision_type:Int, recursive:Int)
	Function dxEntityPickMode:Void (entity:Int, pick_geometry:Int, obscurer:Int)
	Function dxGetEntityType:Int (entity:Int)
	Function dxGetFPS:Int ()
	Function dxPointEntity:Void (entity:Int, target:Int, roll:Float)
	Function dxAlignToVector:Void (entity:Int, vector_x:Float, vector_y:Float, vector_z:Float, axis:Int, rate:Float)
	Function dxFramesRendered:Int ()
	Function dxTFormPoint:Void (x:Float, y:Float, z:Float, source_entity:Int, dest_entity:Int)
	Function dxTFormedX:Float ()
	Function dxTFormedY:Float ()
	Function dxTFormedZ:Float ()
	Function dxEntityDistance:Float (src_entity:Int, dest_entity:Int)
	Function dxVectorYaw:Float (x:Float, y:Float, z:Float)
	Function dxVectorPitch:Float (x:Float, y:Float, z:Float)
	Function dxCameraProject:Void (camera:Int, x:Float, y:Float, z:Float)
	Function dxProjectedX:Float ()
	Function dxProjectedY:Float ()
	Function dxProjectedZ:Float ()
	Function dxDeltaPitch:Float (src_entity:Int, dest_entity:Int)
	Function dxDeltaYaw:Float (src_entity:Int, dest_entity:Int)
	Function dxCameraPick:Int (camera:Int, viewport_x:Int, viewport_y:Int)
	Function dxPickedX:Float ()
	Function dxPickedY:Float ()
	Function dxPickedZ:Float ()
	Function dxPickedNX:Float ()
	Function dxPickedNY:Float ()
	Function dxPickedNZ:Float ()
	Function dxPickedTime:Int ()
	Function dxPickedEntity:Int ()
	Function dxPickedSurface:Int ()
	Function dxPickedTriangle:Int ()
	Function dxEntityPick:Int (entity:Int, range:Float)
	Function dxLinePick:Int (x:Float, y:Float, z:Float, dx:Float, dy:Float, dz:Float, radius:Float)
	Function dxHideWindow:Void (enable:Int)
	Function dxIsWindowMinimized:Int ()
	Function dxRotateMesh:Void (entity:Int, pitch:Float, yaw:Float, roll:Float)
	Function dxCreateEmitter:Int (elements:Int, base_entity:Int, parent:Int)
	Function dxEmitterCountElements:Int (emitter:Int)
	Function dxEmitterSetElementCount:Void (emitter:Int, count:Int)
	Function dxEmitterDeleteElement:Void (emitter:Int, element:Int)
	Function dxGetWinVersion:CStringNative ()
	Function dxCameraZoom:Void (camera:Int, zoom:Float)
	Function dxSurfaceShininess:Void (surface:Int, shininess:Float)
	Function dxEntityShininess:Void (entity:Int, shininess:Float)
	Function dxCreateMaze:Int (width:Int, height:Int, halls:Int)
	Function dxFreeMaze:Int (maze:Int)
	Function dxReadMaze:Int (maze:Int, x:Int, z:Int)
	Function dxLoadMesh:Int (file:CStringNative, parent:Int)
	Function dxSaveMesh:Int (file:CStringNative, entity:Int)
	Function dxLoadMeshXFromBank:Int (bank:Int, parent:Int)
	Function dxLoadTextureFromBank:Int (bank:Int, flags:Int)
	Function dxBankSize:Int (bank:Int)
	Function dxPeekMemInt:Int (address:Int)
	Function dxPokeMemInt:Void (address:Int, value:Int)
	Function dxLocate:Void (x:Int, y:Int)
	Function dxPrint:Void (_string:CStringNative)
	Function dxLoadAnimTexture:Int (file:CStringNative, flags:Int, frame_width:Int, frame_height:Int, first_frame:Int, frame_count:Int)
	Function dxLoadAnimTextureFromBank:Int (bank:Int, flags:Int, frame_width:Int, frame_height:Int, first_frame:Int, frame_count:Int)
	Function dxMeshesIntersect:Int (mesh_a:Int, mesh_b:Int)
	Function dxRotateSprite:Void (sprite:Int, angle:Float)
	Function dxUpdateWorld:Void (anim_speed:Float)
	Function dxCreateCone:Int (segments:Int, solid:Int, parent:Int)
	Function dxLightCaster:Void (light:Int, enable:Int)
	Function dxEntityCaster:Void (entity:Int, enable:Int)
	Function dxEnityShadowDetail:Void (entity:Int, triangles:Int, detail_percent:Float)
	Function dxEnityShadowColor:Void (entity:Int, red:Int, green:Int, blue:Int)
	Function dxEnityShadowIntensity:Void (entity:Int, intensity_percent:Float)
	Function dxEnableShadows:Void (enable:Int)
	Function dxEnityShadowCutoff:Void (entity:Int, minimum:Float, maximum:Float, fadein:Float)
	Function dxSetVSync:Void (enable:Int)
	Function dxSetWindowDefaults:Void (borderless:Int, minimize_button:Int, maximize_button:Int, close_button:Int, autoclose:Int)
	Function dxWinClose:Int ()
	Function dxClearWorld:Int (entities:Int, brushes:Int, textures:Int)
	Function dxClearCollisions:Void ()
	Function dxCollisions:Void (src_type:Int, dest_type:Int, _method:Int, response:Int)
	Function dxTextureFilter:Void (match_text:CStringNative, flags:Int)
	Function dxClearTextureFilters:Void ()
	Function dxScreenWidth:Int ()
	Function dxScreenHeight:Int ()
	Function dxWindowWidth:Int ()
	Function dxWindowHeight:Int ()
	Function dxWindowX:Int ()
	Function dxWindowY:Int ()
	Function dxWindowResized:Int ()
	Function dxWindowMoved:Int ()
	Function dxMeshSimplify:Int (mesh:Int, vertex_count:Int, triangle_count:Int, vertex_percent:Float, triangle_percent:Float)
	Function dxVlcPresent:Int ()
	Function dxFreeVid:Void (video:Int)
	Function dxVidLoad:Int (file:CStringNative)
	Function dxVidDownload:Int (path:Int)
	Function dxVidTrackCount:Int (video:Int)
	Function dxVidTrackType:Int (video:Int, track:Int)
	Function dxVidWidth:Int (video:Int)
	Function dxVidHeight:Int (video:Int)
	Function dxVidDuration:Int (video:Int)
	Function dxVidTexture:Void (video:Int, texture:Int)
	Function dxGetVidTexture:Int (video:Int)
	Function dxVidPlay:Void (video:Int)
	Function dxVidPlaying:Int (video:Int)
	Function dxVidStop:Void (video:Int)
	Function dxVidPause:Void (video:Int)
	Function dxVidGetPosition:Int (video:Int)
	Function dxVidSetPosition:Int (video:Int, millisecs:Int)
	Function dxVidMuted:Int (video:Int)
	Function dxVidMute:Void (video:Int)
	Function dxVidUnMute:Void (video:Int)
	Function dxVidGetVolume:Int (video:Int)
	Function dxVidSetVolume:Void (video:Int)
	Function dxVidGetSubtitleCount:Int (video:Int)
	Function dxVidGetAudioTrackCount:Int (video:Int)
	Function dxVidGetAudioTrackDescription:CStringNative (video:Int, track:Int)
	Function dxVidSetAudioTrack:Void (video:Int, track:Int)
	Function dxVidGetSubtitleDescription:CStringNative (video:Int, track:Int)
	Function dxVidSetSubtitle:Void (video:Int, track:Int)
	Function dxRequestFile:CStringNative (title:CStringNative, default_folder:CStringNative, filter:CStringNative)
	Function dxVidGetPlayRate:Float (video:Int)
	Function dxVidSetPlayRate:Void (video:Int, rate:Float)
	Function dxDx11Present:Int ()
	Function dxBeginScene:Void ()
	Function dxEndScene:Void ()
	Function dxRenderEntity:Void (entity:Int, camera:Int)
	Function dxRenderCls:Void (camera:Int)
	Function dx11GetMaxFeatureLevel:CStringNative ()
	Function dx11SoftwareEmulation:Void ()
	Function dx11NoSoftwareEmulation:Void ()
	Function dxDebugSilent:Void ()
	Function dxDebugLoud:Void ()
	Function dxDebugHarsh:Void ()
	Function dxDebugLoudAndHarsh:Void ()
	Function dxLoadAnimMesh:Int (file:CStringNative, parent:Int)
	Function dxAnimate:Void (entity:Int, mode:Int, speed:Float, sequence:Int, transition:Float)
	Function dxSetAnimTime:Void (entity:Int, time:Float, anim_sequence:Int)
	Function dxAnimTime:Float (entity:Int)
	Function dxAnimating:Int (entity:Int)
	Function dxCountBones:Int (entity:Int)
	Function dxBoneName:CStringNative (entity:Int, bone:Int)
	Function dxBoneX:Float (entity:Int, bone:Int, _global:Int, initial_position:Int)
	Function dxBoneY:Float (entity:Int, bone:Int, _global:Int, initial_position:Int)
	Function dxBoneZ:Float (entity:Int, bone:Int, _global:Int, initial_position:Int)
	Function dxBonePitch:Float (entity:Int, bone:Int, _global:Int)
	Function dxBoneYaw:Float (entity:Int, bone:Int, _global:Int)
	Function dxBoneRoll:Float (entity:Int, bone:Int, _global:Int)
	Function dxMoveBone:Void (entity:Int, bone:Int, x:Float, y:Float, z:Float)
	Function dxTurnBone:Void (entity:Int, bone:Int, pitch:Float, yaw:Float, roll:Float)
	Function dxGetBoneParent:Int (entity:Int, bone:Int)
	Function dxGetRootBone:Int (entity:Int, bone:Int)
	Function dxCountBoneChildren:Int (entity:Int, bone:Int)
	Function dxGetBoneChild:Int (entity:Int, bone:Int, child_index:Int)
	Function dxCountBoneSiblings:Int (entity:Int, bone:Int)
	Function dxGetBoneSibling:Int (entity:Int, bone:Int, sibling_index:Int)
	Function dxScaleBone:Void (entity:Int, bone:Int, scale_x:Float, scale_y:Float, scale_z:Float, _global:Int)
	Function dxBoneScaleX:Float (entity:Int, bone:Int, _global:Int)
	Function dxBoneScaleY:Float (entity:Int, bone:Int, _global:Int)
	Function dxBoneScaleZ:Float (entity:Int, bone:Int, _global:Int)
	Function dxCountBoneInfluences:Int (entity:Int, bone:Int)
	Function dxGetBoneInfluenceVertex:Int (entity:Int, bone:Int, influence_index:Int)
	Function dxGetBoneInfluenceSurface:Int (entity:Int, bone:Int, influence_index:Int)
	Function dxGetBoneInfluenceWeight:Float (entity:Int, bone:Int, influence_index:Int)
	Function dxFindBone:Int (entity:Int, name:CStringNative)
	Function dxRenameBone:Int (entity:Int, bone:Int, name:CStringNative)
	Function dxCountVertexInfluences:Int (surface:Int, vertex:Int)
	Function dxGetVertexInfluenceBone:Int (surface:Int, vertex:Int, influence_index:Int)
	Function dxGetVertexInfluenceWeight:Float (surface:Int, vertex:Int, influence_index:Int)
	Function dxSetBoneInfluenceWeight:Void (entity:Int, bone:Int, influence_index:Int, weight:Float)
	Function dxFreeBoneInfluence:Void (entity:Int, bone:Int, influence_index:Int)
	Function dxBoneParent:Void (entity:Int, bone:Int, parent_bone:Int)
	Function dxFreeBone:Void (entity:Int, bone:Int)
	Function dxCountCaptureDevices:Int ()
	Function dxCaptureName:CStringNative (capture_device_number:Int)
	Function dxOpenCaptureDevice:Int (capture_device_number:Int)
	Function dxCaptureWidth:Int (capture_device_number:Int)
	Function dxCaptureHeight:Int (capture_device_number:Int)
	Function dxUpnpSearch:Void ()
	Function dxUpnpSearchDone:Int ()
	Function dxUpnpCount:Int ()
	Function dxUpnpName:CStringNative (device_index:Int)
	Function dxSetAnimKey:Void (entity:Int, frame:Float, pos_key:Int, rotation_key:Int, scale_key:Int)
	Function dxAddAnimSeq:Int (entity:Int, length:Int)
	Function dxEntityHWShaders:Void (entity:Int, enable:Int)
	Function dxHWShaders:Void (entity:Int)
	Function dxSurfaceHWShaders:Int (surface:Int, enable:Int)
	Function dxEntityNegative:Int (entity:Int, enable:Int)
	Function dxEntityTextureBoundary:Void (entity:Int, texture_index:Int, min_x:Float, min_y:Float, min_z:Float, max_x:Float, max_y:Float, max_z:Float)

Public
