
#define VC_EXTRALEAN
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define BBDECL extern "C"
#include <iostream>

using namespace std; // Temp

HINSTANCE HW_DLL;

BBDECL typedef int (__stdcall *LPDCOUNTGFXDRIVERS)( );
BBDECL typedef int (__stdcall *LPDGRAPHICS3D)( int width,int height,int depth,int mode );
BBDECL typedef void (__stdcall *LPDENDGRAPHICS)( );
BBDECL typedef void (__stdcall *LPDSHOWMOUSE)( );
BBDECL typedef void (__stdcall *LPDHIDEMOUSE)( );
BBDECL typedef int (__stdcall *LPDKEYDOWN)( int key );
BBDECL typedef int (__stdcall *LPDMOUSEDOWN)( int button );
BBDECL typedef int (__stdcall *LPDGETMOUSE)( );
BBDECL typedef int (__stdcall *LPDMOUSEHIT)( int button );
BBDECL typedef void (__stdcall *LPDWAITMOUSE)( );
BBDECL typedef int (__stdcall *LPDMOUSEX)( );
BBDECL typedef int (__stdcall *LPDMOUSEY)( );
BBDECL typedef int (__stdcall *LPDMOUSEZ)( );
BBDECL typedef void (__stdcall *LPDMOVEMOUSE)( int x,int y );
BBDECL typedef void (__stdcall *LPDFLUSHMOUSE)( );
BBDECL typedef int (__stdcall *LPDMOUSEXSPEED)( );
BBDECL typedef int (__stdcall *LPDMOUSEYSPEED)( );
BBDECL typedef int (__stdcall *LPDMOUSEZSPEED)( );
BBDECL typedef int (__stdcall *LPDKEYHIT)( int key );
BBDECL typedef void (__stdcall *LPDFLUSHKEYS)( );
BBDECL typedef void (__stdcall *LPDWAITKEY)( );
BBDECL typedef int (__stdcall *LPDLOADFONT)( LPCTSTR filename,int height,int bold,int italic,int underline );
BBDECL typedef void (__stdcall *LPDCLS)( );
BBDECL typedef void (__stdcall *LPDCLSCOLOR)( float red,float green,float blue );
BBDECL typedef void (__stdcall *LPDFLIP)( int vsync );
BBDECL typedef int (__stdcall *LPDFRONTBUFFER)( );
BBDECL typedef int (__stdcall *LPDBACKBUFFER)( );
BBDECL typedef void (__stdcall *LPDCOLOR)( int red,int green,int blue );
BBDECL typedef void (__stdcall *LPDPLOT)( int x,int y );
BBDECL typedef int (__stdcall *LPDCREATEMESH)( int parent );
BBDECL typedef int (__stdcall *LPDCREATECAMERA)( int parent );
BBDECL typedef void (__stdcall *LPDPOSITIONENTITY)( int entity,float x,float y,float z,int _global );
BBDECL typedef int (__stdcall *LPDCREATETEAPOT)( int parent );
BBDECL typedef void (__stdcall *LPDRENDERWORLD)( int tween );
BBDECL typedef int (__stdcall *LPDADDVERTEX)( int surface,float x,float y,float z,float u,float v,float w );
BBDECL typedef int (__stdcall *LPDCREATESURFACE)( int mesh );
BBDECL typedef int (__stdcall *LPDCOUNTVERTICES)( int surface );
BBDECL typedef void (__stdcall *LPDVERTEXCOLOR)( int surface,int index,float red,float green,float blue,float alpha );
BBDECL typedef int (__stdcall *LPDVERTEXRED)( int surface,int index );
BBDECL typedef int (__stdcall *LPDVERTEXGREEN)( int surface,int index );
BBDECL typedef int (__stdcall *LPDVERTEXBLUE)( int surface,int index );
BBDECL typedef float (__stdcall *LPDVERTEXALPHA)( int surface,int index );
BBDECL typedef void (__stdcall *LPDVERTEXTEXCOORDS)( int surface,int index,float texture_u,float texture_v,float texture_w,int coord_set );
BBDECL typedef void (__stdcall *LPDVERTEXNORMAL)( int surface,int index,float x_normal,float y_normal,float z_normal );
BBDECL typedef float (__stdcall *LPDVERTEXX)( int surface,int index );
BBDECL typedef float (__stdcall *LPDVERTEXY)( int surface,int index );
BBDECL typedef float (__stdcall *LPDVERTEXZ)( int surface,int index );
BBDECL typedef float (__stdcall *LPDVERTEXNX)( int surface,int index );
BBDECL typedef float (__stdcall *LPDVERTEXNY)( int surface,int index );
BBDECL typedef float (__stdcall *LPDVERTEXNZ)( int surface,int index );
BBDECL typedef float (__stdcall *LPDVERTEXU)( int surface,int index );
BBDECL typedef float (__stdcall *LPDVERTEXV)( int surface,int index );
BBDECL typedef float (__stdcall *LPDVERTEXW)( int surface,int index );
BBDECL typedef int (__stdcall *LPDCOUNTSURFACES)( int mesh );
BBDECL typedef void (__stdcall *LPDCLEARSURFACE)( int surface,int vertices,int triangles );
BBDECL typedef int (__stdcall *LPDADDTRIANGLE)( int surface,int vertex_1,int vertex_2,int vertex_3 );
BBDECL typedef int (__stdcall *LPDCOUNTTRIANGLES)( int surface );
BBDECL typedef int (__stdcall *LPDTRIANGLEVERTEX)( int surface,int triangle_index,int corner );
BBDECL typedef void (__stdcall *LPDAMBIENTLIGHT)( int red,int green,int blue );
BBDECL typedef int (__stdcall *LPDCAMERAVIEWPORT)( int camera,int x,int y,int width,int height );
BBDECL typedef void (__stdcall *LPDCAMERACLSCOLOR)( int camera,int red,int green,int blue );
BBDECL typedef void (__stdcall *LPDCAMERAPROJMODE)( int camera,int projection_mode );
BBDECL typedef void (__stdcall *LPDCAMERARANGE)( int camera,float near,float far );
BBDECL typedef void (__stdcall *LPDCAMERACLSMODE)( int camera,int cls_color,int z_buffer );
BBDECL typedef void (__stdcall *LPDCAMERAASPECT)( int camera,float aspect_ratio );
BBDECL typedef void (__stdcall *LPDAUTOCAMERAASPECT)( int camera );
BBDECL typedef void (__stdcall *LPDCAMERAFOV)( int camera,float focus );
BBDECL typedef float (__stdcall *LPDGETCAMERAFOV)( int camera );
BBDECL typedef float (__stdcall *LPDGETCAMERAASPECT)( int camera );
BBDECL typedef int (__stdcall *LPDCREATETORUS)( float inner_radius,float outer_radius,int sides,int rings );
BBDECL typedef int (__stdcall *LPDCREATECUBE)( int parent );
BBDECL typedef int (__stdcall *LPDCREATECYLINDER)( float radius1,float radius2,float length,int slices,int stacks );
BBDECL typedef int (__stdcall *LPDCREATESPHERE)( int segments,int parent );
BBDECL typedef void (__stdcall *LPDFREEENTITY)( int entity );
BBDECL typedef void (__stdcall *LPDENTITYPARENT)( int entity,int parent );
BBDECL typedef int (__stdcall *LPDCOUNTCHILDREN)( int entity );
BBDECL typedef int (__stdcall *LPDGETCHILD)( int entity,int index );
BBDECL typedef LPCTSTR (__stdcall *LPDENTITYCLASS)( int entity );
BBDECL typedef int (__stdcall *LPDGETPARENT)( int entity );
BBDECL typedef void (__stdcall *LPDNAMEENTITY)( int entity,LPCTSTR name );
BBDECL typedef LPCTSTR (__stdcall *LPDENTITYNAME)( int entity );
BBDECL typedef float (__stdcall *LPDENTITYX)( int entity,int _global );
BBDECL typedef float (__stdcall *LPDENTITYY)( int entity,int _global );
BBDECL typedef float (__stdcall *LPDENTITYZ)( int entity,int _global );
BBDECL typedef void (__stdcall *LPDROTATEENTITY)( int entity,float pitch,float yaw,float roll,int _global );
BBDECL typedef float (__stdcall *LPDGETMATELEMENT)( int entity,int row,int column );
BBDECL typedef void (__stdcall *LPDUPDATENORMALS)( int mesh );
BBDECL typedef int (__stdcall *LPDCREATETEXTURE)( int width,int height,int flags,int frames );
BBDECL typedef void (__stdcall *LPDTURNENTITY)( int entity,float pitch,float yaw,float roll,int _global );
BBDECL typedef void (__stdcall *LPDMOVEENTITY)( int entity,float x,float y,float z );
BBDECL typedef void (__stdcall *LPDTRANSLATEENTITY)( int entity,float x,float y,float z,int _global );
BBDECL typedef int (__stdcall *LPDENTITYRED)( int entity );
BBDECL typedef int (__stdcall *LPDENTITYGREEN)( int entity );
BBDECL typedef int (__stdcall *LPDENTITYBLUE)( int entity );
BBDECL typedef void (__stdcall *LPDENTITYCOLOR)( int entity,int red,int green,int blue );
BBDECL typedef void (__stdcall *LPDENTITYFX)( int entity,int fx );
BBDECL typedef void (__stdcall *LPDGETENTITYFX)( int entity );
BBDECL typedef void (__stdcall *LPDDITHER)( int state );
BBDECL typedef void (__stdcall *LPDCAMERAFOGMODE)( int camera,int state );
BBDECL typedef void (__stdcall *LPDCAMERAFOGCOLOR)( int camera,int red,int green,int blue );
BBDECL typedef void (__stdcall *LPDCAMERAFOGRANGE)( int camera,float near,float far );
BBDECL typedef int (__stdcall *LPDLOADTEXTURE)( LPCTSTR file,int flags );
BBDECL typedef void (__stdcall *LPDENTITYTEXTURE)( int entity,int texture,int frame,int index );
BBDECL typedef int (__stdcall *LPDCOUNTGFXMODES3D)( );
BBDECL typedef int (__stdcall *LPDGFXMODEWIDTH)( int adapter );
BBDECL typedef int (__stdcall *LPDGFXMODEHEIGHT)( int adapter );
BBDECL typedef int (__stdcall *LPDGFXMODEDEPTH)( int adapter );
BBDECL typedef int (__stdcall *LPDGFXMODEREFRESHRATE)( int adapter );
BBDECL typedef void (__stdcall *LPDWIREFRAME)( int enable );
BBDECL typedef void (__stdcall *LPDENTITYWIREFRAME)( int entity,int enable );
BBDECL typedef void (__stdcall *LPDPOINTFRAME)( int enable );
BBDECL typedef void (__stdcall *LPDENTITYPOINTFRAME)( int entity,int enable );
BBDECL typedef void (__stdcall *LPDSCALEENTITY)( int entity,float scale_x,float scale_y,float scale_z,int _global );
BBDECL typedef float (__stdcall *LPDENTITYSCALEX)( int entity );
BBDECL typedef float (__stdcall *LPDENTITYSCALEY)( int entity );
BBDECL typedef float (__stdcall *LPDENTITYSCALEZ)( int entity );
BBDECL typedef int (__stdcall *LPDCREATELIGHT)( int _type,int parent );
BBDECL typedef int (__stdcall *LPDCOLORRED)( );
BBDECL typedef int (__stdcall *LPDCOLORGREEN)( );
BBDECL typedef int (__stdcall *LPDCOLORBLUE)( );
BBDECL typedef int (__stdcall *LPDGRAPHICSBUFFER)( );
BBDECL typedef int (__stdcall *LPDSETBUFFER)( int buffer );
BBDECL typedef int (__stdcall *LPDCREATETEXT)( LPCTSTR text,float extrusion );
BBDECL typedef int (__stdcall *LPD3DFONT)( LPCTSTR font,int bold,int italic,int underline,int strikeout );
BBDECL typedef void (__stdcall *LPDRECT)( int x,int y,int width,int height,int solid );
BBDECL typedef int (__stdcall *LPDTEXTUREBUFFER)( int texture );
BBDECL typedef int (__stdcall *LPDGRAPHICSWIDTH)( );
BBDECL typedef int (__stdcall *LPDGRAPHICSHEIGHT)( );
BBDECL typedef int (__stdcall *LPDGRAPHICSDEPTH)( );
BBDECL typedef void (__stdcall *LPDGETCOLOR)( int x,int y );
BBDECL typedef int (__stdcall *LPDREADPIXEL)( int x,int y,int buffer );
BBDECL typedef void (__stdcall *LPDLIGHTCOLOR)( int light,int red,int green,int blue );
BBDECL typedef void (__stdcall *LPDLIGHTRANGE)( int light,float range );
BBDECL typedef void (__stdcall *LPDLIGHTCONEANGLES)( int light,float inner_angle,float outer_angle );
BBDECL typedef void (__stdcall *LPDHIDEENTITY)( int entity );
BBDECL typedef void (__stdcall *LPDSHOWENTITY)( int entity );
BBDECL typedef void (__stdcall *LPDENTITYORDER)( int entity,int order );
BBDECL typedef void (__stdcall *LPDOVAL)( int x,int y,int width,int height,int solid );
BBDECL typedef void (__stdcall *LPDLINE)( int x1,int y1,int x2,int y2 );
BBDECL typedef void (__stdcall *LPDTEXT)( int x,int y,LPCTSTR text,int center_x,int center_y );
BBDECL typedef void (__stdcall *LPDSETFONT)( int font );
BBDECL typedef void (__stdcall *LPDFREEFONT)( int font );
BBDECL typedef void (__stdcall *LPDUPDATESURFACENORMALS)( int surface );
BBDECL typedef void (__stdcall *LPDWBUFFER)( int enable );
BBDECL typedef int (__stdcall *LPDPIXELSHADERVERSION)( );
BBDECL typedef int (__stdcall *LPDVERTEXSHADERVERSION)( );
BBDECL typedef int (__stdcall *LPDCREATEPIXELSHADER)( LPCTSTR operation,LPCTSTR file,LPCTSTR entry_point,LPCTSTR version );
BBDECL typedef void (__stdcall *LPDFREEPIXELSHADER)( int pixel_shader );
BBDECL typedef int (__stdcall *LPDCREATEVERTEXSHADER)( LPCTSTR operation,LPCTSTR file,LPCTSTR entry_point,LPCTSTR version );
BBDECL typedef void (__stdcall *LPDFREEVERTEXSHADER)( int vertex_shader );
BBDECL typedef void (__stdcall *LPDENTITYPIXELSHADER)( int entity,int pixel_shader );
BBDECL typedef void (__stdcall *LPDENTITYVERTEXSHADER)( int entity,int vertex_shader );
BBDECL typedef LPCTSTR (__stdcall *LPDGETLASTSHADERERROR)( );
BBDECL typedef void (__stdcall *LPDVERTEXCOORDS)( int surface,int vertex,float x,float y,float z );
BBDECL typedef void (__stdcall *LPDFLIPMESH)( int mesh );
BBDECL typedef void (__stdcall *LPDAPPTITLE)( LPCTSTR title );
BBDECL typedef int (__stdcall *LPDCOUNTENTITIES)( );
BBDECL typedef int (__stdcall *LPDGETSURFACE)( int mesh,int surface );
BBDECL typedef int (__stdcall *LPDFIRSTENTITY)( );
BBDECL typedef int (__stdcall *LPDNEXTENTITY)( int present_entity );
BBDECL typedef int (__stdcall *LPDPREVIOUSENTITY)( int present_entity );
BBDECL typedef void (__stdcall *LPDENTITYBLEND)( int entity,int blend );
BBDECL typedef int (__stdcall *LPDCOPYENTITY)( int entity,int parent );
BBDECL typedef void (__stdcall *LPDFREESURFACE)( int surface );
BBDECL typedef void (__stdcall *LPDTEXTUREBLEND)( int texture,int blend );
BBDECL typedef float (__stdcall *LPDGETVERSION)( );
BBDECL typedef int (__stdcall *LPDSTRINGWIDTH)( LPCTSTR _string );
BBDECL typedef int (__stdcall *LPDSTRINGHEIGHT)( LPCTSTR _string );
BBDECL typedef int (__stdcall *LPDCREATEBRUSH)( float red,float green,float blue );
BBDECL typedef void (__stdcall *LPDFREEBRUSH)( int brush );
BBDECL typedef void (__stdcall *LPDBRUSHCOLOR)( int brush,float red,float green,float blue );
BBDECL typedef void (__stdcall *LPDBRUSHALPHA)( int brush,float alpha );
BBDECL typedef void (__stdcall *LPDBRUSHSHININESS)( int brush,float shininess );
BBDECL typedef void (__stdcall *LPDBRUSHFX)( int brush,int fx );
BBDECL typedef void (__stdcall *LPDBRUSHTEXTURE)( int brush,int texture,int frame,int index );
BBDECL typedef void (__stdcall *LPDBRUSHBLEND)( int brush,int blend );
BBDECL typedef int (__stdcall *LPDGETENTITYBRUSH)( int entity );
BBDECL typedef void (__stdcall *LPDNAMETEXTURE)( int texture,LPCTSTR name );
BBDECL typedef LPCTSTR (__stdcall *LPDTEXTURENAME)( int texture );
BBDECL typedef void (__stdcall *LPDTEXTURECOORDS)( int texture,int coord_set );
BBDECL typedef int (__stdcall *LPDTEXTUREWIDTH)( int texture );
BBDECL typedef int (__stdcall *LPDTEXTUREHEIGHT)( int texture );
BBDECL typedef float (__stdcall *LPDGETDEBUGFLOAT)( );
BBDECL typedef void (__stdcall *LPDSCALETEXTURE)( int texture,float u_scale,float v_scale );
BBDECL typedef void (__stdcall *LPDPOSITIONTEXTURE)( int texture,float u_position,float v_position );
BBDECL typedef void (__stdcall *LPDROTATETEXTURE)( int texture,float angle );
BBDECL typedef void (__stdcall *LPDENTITYALPHA)( int entity,float alpha );
BBDECL typedef float (__stdcall *LPDGETENTITYALPHA)( int entity );
BBDECL typedef void (__stdcall *LPDPOSITIONMESH)( int mesh,float x,float y,float z );
BBDECL typedef float (__stdcall *LPDMESHWIDTH)( int mesh );
BBDECL typedef float (__stdcall *LPDMESHHEIGHT)( int mesh );
BBDECL typedef float (__stdcall *LPDMESHDEPTH)( int mesh );
BBDECL typedef float (__stdcall *LPDENTITYPITCH)( int entity,int _global );
BBDECL typedef float (__stdcall *LPDENTITYYAW)( int entity,int _global );
BBDECL typedef float (__stdcall *LPDENTITYROLL)( int entity,int _global );
BBDECL typedef void (__stdcall *LPDFREESURFACEATTRIBS)( int surface );
BBDECL typedef void (__stdcall *LPDSURFACEFX)( int surface,int fx );
BBDECL typedef void (__stdcall *LPDSURFACEBLEND)( int surface,int blend );
BBDECL typedef void (__stdcall *LPDSURFACEALPHA)( int surface,float alpha );
BBDECL typedef void (__stdcall *LPDSURFACEWIREFRAME)( int surface,int enable );
BBDECL typedef void (__stdcall *LPDSURFACEPOINTFRAME)( int surface,int enable );
BBDECL typedef void (__stdcall *LPDSURFACEPIXELSHADER)( int surface,int pixel_shader );
BBDECL typedef void (__stdcall *LPDSURFACEVERTEXSHADER)( int surface,int vertex_shader );
BBDECL typedef void (__stdcall *LPDSURFACECOLOR)( int surface,int red,int green,int blue );
BBDECL typedef int (__stdcall *LPDGETSURFACEBRUSH)( int surface );
BBDECL typedef void (__stdcall *LPDPAINTENTITY)( int entity,int brush );
BBDECL typedef void (__stdcall *LPDPAINTSURFACE)( int surface,int brush );
BBDECL typedef void (__stdcall *LPDSURFACETEXTURE)( int surf,int texture,int frame,int index );
BBDECL typedef void (__stdcall *LPDWRITEPIXEL)( int x,int y,int argb,int buffer );
BBDECL typedef void (__stdcall *LPDLOCKBUFFER)( int buffer );
BBDECL typedef void (__stdcall *LPDUNLOCKBUFFER)( int buffer );
BBDECL typedef void (__stdcall *LPDWRITEPIXELFAST)( int x,int y,int argb,int buffer );
BBDECL typedef int (__stdcall *LPDREADPIXELFAST)( int x,int y,int buffer );
BBDECL typedef void (__stdcall *LPDTEXTURESAVE)( int texture,LPCTSTR filename,int _type );
BBDECL typedef int (__stdcall *LPDCOPYSURFACE)( int surface,int parent_entity );
BBDECL typedef int (__stdcall *LPDCOPYMESH)( int entity,int parent );
BBDECL typedef int (__stdcall *LPDCREATEIMAGE)( int width,int height,int frames );
BBDECL typedef void (__stdcall *LPDFREEIMAGE)( int image );
BBDECL typedef int (__stdcall *LPDIMAGEWIDTH)( int image );
BBDECL typedef int (__stdcall *LPDIMAGEHEIGHT)( int image );
BBDECL typedef int (__stdcall *LPDIMAGEBUFFER)( int image );
BBDECL typedef int (__stdcall *LPDCOPYIMAGE)( int image );
BBDECL typedef int (__stdcall *LPDCOPYRECT)( int src_x,int src_y,int src_width,int src_height,int dest_x,int dest_y,int src_buffer,int dest_buffer );
BBDECL typedef void (__stdcall *LPDSETFILTERS)( int _max,int _min,int mip );
BBDECL typedef void (__stdcall *LPDRENDERTOTEXTURE)( int texture );
BBDECL typedef void (__stdcall *LPDRENDERTOSCREEN)( );
BBDECL typedef int (__stdcall *LPDCREATESPRITE)( int parent );
BBDECL typedef void (__stdcall *LPDSPRITEVIEWMODE)( int sprite,int view_mode );
BBDECL typedef void (__stdcall *LPDSCALESPRITE)( int sprite,float x_scale,float y_scale );
BBDECL typedef void (__stdcall *LPDHANDLESPRITE)( int sprite,float x,float y );
BBDECL typedef int (__stdcall *LPDUSEDIRECTX11)( int enable );
BBDECL typedef int (__stdcall *LPDDIRECTX11USED)( );
BBDECL typedef void (__stdcall *LPDSEEDRND)( int seed );
BBDECL typedef float (__stdcall *LPDRND)( float low,float high );
BBDECL typedef int (__stdcall *LPDRAND)( int low,int high );
BBDECL typedef int (__stdcall *LPDCREATEPIVOT)( int parent );
BBDECL typedef void (__stdcall *LPDBUFFERNOISE)( int buffer,int x,int y,int w,int h,float red_filter,float green_filter,float blue_filter,float alpha_filter );
BBDECL typedef void (__stdcall *LPDBUFFERINVERT)( int buffer,int x,int y,int w,int h );
BBDECL typedef void (__stdcall *LPDSETCUBEFACE)( int texture,int face );
BBDECL typedef float (__stdcall *LPDGETSURFACEBOUNDINGRADIUS)( int surface );
BBDECL typedef int (__stdcall *LPDTRISRENDERED)( );
BBDECL typedef int (__stdcall *LPDENTITYINVIEW)( int entity,int camera );
BBDECL typedef int (__stdcall *LPDMAXLIGHTS)( );
BBDECL typedef int (__stdcall *LPDCREATETERRAIN)( int grid_size,int parent );
BBDECL typedef void (__stdcall *LPDMODIFYTERRAIN)( int terrain,int grid_x,int grid_z,float height,int realtime );
BBDECL typedef int (__stdcall *LPDTERRAINSIZE)( int terrain );
BBDECL typedef int (__stdcall *LPDLOADTERRAIN)( LPCTSTR file,int parent );
BBDECL typedef float (__stdcall *LPDTERRAINHEIGHT)( int terrain,float grid_x,float grid_z );
BBDECL typedef void (__stdcall *LPDFITMESH)( int mesh,float x,float y,float z,float w,float h,float d,int uniform );
BBDECL typedef void (__stdcall *LPDSCALEMESH)( int mesh,float width,float height,float depth );
BBDECL typedef int (__stdcall *LPDGETCONSTANTTABLESIZE)( int shader );
BBDECL typedef int (__stdcall *LPDCONSTANTCOUNT)( int shader );
BBDECL typedef void (__stdcall *LPDDECLAREVERTEXSHADERWORLDCONSTANT)( int shader,LPCTSTR constant_name );
BBDECL typedef void (__stdcall *LPDDECLAREVERTEXSHADERVIEWCONSTANT)( int shader,LPCTSTR constant_name );
BBDECL typedef void (__stdcall *LPDDECLAREVERTEXSHADERPROJCONSTANT)( int shader,LPCTSTR constant_name );
BBDECL typedef void (__stdcall *LPDDECLAREVERTEXSHADERWORLDVIEWPROJCONSTANT)( int shader,LPCTSTR constant_name );
BBDECL typedef void (__stdcall *LPDENTITYRADIUS)( int entity,float radius_x,float radius_y );
BBDECL typedef void (__stdcall *LPDENTITYBOX)( int entity,float x,float y,float z,float width,float height,float depth );
BBDECL typedef void (__stdcall *LPDENTITYTYPE)( int entity,int collision_type,int recursive );
BBDECL typedef void (__stdcall *LPDENTITYPICKMODE)( int entity,int pick_geometry,int obscurer );
BBDECL typedef int (__stdcall *LPDGETENTITYTYPE)( int entity );
BBDECL typedef int (__stdcall *LPDGETFPS)( );
BBDECL typedef void (__stdcall *LPDPOINTENTITY)( int entity,int target,float roll );
BBDECL typedef void (__stdcall *LPDALIGNTOVECTOR)( int entity,float vector_x,float vector_y,float vector_z,int axis,float rate );
BBDECL typedef int (__stdcall *LPDFRAMESRENDERED)( );
BBDECL typedef void (__stdcall *LPDTFORMPOINT)( float x,float y,float z,int source_entity,int dest_entity );
BBDECL typedef float (__stdcall *LPDTFORMEDX)( );
BBDECL typedef float (__stdcall *LPDTFORMEDY)( );
BBDECL typedef float (__stdcall *LPDTFORMEDZ)( );
BBDECL typedef float (__stdcall *LPDENTITYDISTANCE)( int src_entity,int dest_entity );
BBDECL typedef float (__stdcall *LPDVECTORYAW)( float x,float y,float z );
BBDECL typedef float (__stdcall *LPDVECTORPITCH)( float x,float y,float z );
BBDECL typedef void (__stdcall *LPDCAMERAPROJECT)( int camera,float x,float y,float z );
BBDECL typedef float (__stdcall *LPDPROJECTEDX)( );
BBDECL typedef float (__stdcall *LPDPROJECTEDY)( );
BBDECL typedef float (__stdcall *LPDPROJECTEDZ)( );
BBDECL typedef float (__stdcall *LPDDELTAPITCH)( int src_entity,int dest_entity );
BBDECL typedef float (__stdcall *LPDDELTAYAW)( int src_entity,int dest_entity );
BBDECL typedef int (__stdcall *LPDCAMERAPICK)( int camera,int viewport_x,int viewport_y );
BBDECL typedef float (__stdcall *LPDPICKEDX)( );
BBDECL typedef float (__stdcall *LPDPICKEDY)( );
BBDECL typedef float (__stdcall *LPDPICKEDZ)( );
BBDECL typedef float (__stdcall *LPDPICKEDNX)( );
BBDECL typedef float (__stdcall *LPDPICKEDNY)( );
BBDECL typedef float (__stdcall *LPDPICKEDNZ)( );
BBDECL typedef int (__stdcall *LPDPICKEDTIME)( );
BBDECL typedef int (__stdcall *LPDPICKEDENTITY)( );
BBDECL typedef int (__stdcall *LPDPICKEDSURFACE)( );
BBDECL typedef int (__stdcall *LPDPICKEDTRIANGLE)( );
BBDECL typedef int (__stdcall *LPDENTITYPICK)( int entity,float range );
BBDECL typedef int (__stdcall *LPDLINEPICK)( float x,float y,float z,float dx,float dy,float dz,float radius );
BBDECL typedef void (__stdcall *LPDHIDEWINDOW)( int enable );
BBDECL typedef int (__stdcall *LPDISWINDOWMINIMIZED)( );
BBDECL typedef void (__stdcall *LPDROTATEMESH)( int entity,float pitch,float yaw,float roll );
BBDECL typedef int (__stdcall *LPDCREATEEMITTER)( int elements,int base_entity,int parent );
BBDECL typedef int (__stdcall *LPDEMITTERCOUNTELEMENTS)( int emitter );
BBDECL typedef void (__stdcall *LPDEMITTERSETELEMENTCOUNT)( int emitter,int count );
BBDECL typedef void (__stdcall *LPDEMITTERDELETEELEMENT)( int emitter,int element );
BBDECL typedef LPCTSTR (__stdcall *LPDGETWINVERSION)( );
BBDECL typedef void (__stdcall *LPDCAMERAZOOM)( int camera,float zoom );
BBDECL typedef void (__stdcall *LPDSURFACESHININESS)( int surface,float shininess );
BBDECL typedef void (__stdcall *LPDENTITYSHININESS)( int entity,float shininess );
BBDECL typedef int (__stdcall *LPDCREATEMAZE)( int width,int height,int halls );
BBDECL typedef int (__stdcall *LPDFREEMAZE)( int maze );
BBDECL typedef int (__stdcall *LPDREADMAZE)( int maze,int x,int z );
BBDECL typedef int (__stdcall *LPDLOADMESH)( LPCTSTR file,int parent );
BBDECL typedef int (__stdcall *LPDSAVEMESH)( LPCTSTR file,int entity );
BBDECL typedef int (__stdcall *LPDLOADMESHXFROMBANK)( int bank,int parent );
BBDECL typedef int (__stdcall *LPDLOADTEXTUREFROMBANK)( int bank,int flags );
BBDECL typedef int (__stdcall *LPDBANKSIZE)( int bank );
BBDECL typedef int (__stdcall *LPDPEEKMEMINT)( int address );
BBDECL typedef void (__stdcall *LPDPOKEMEMINT)( int address,int value );
BBDECL typedef void (__stdcall *LPDLOCATE)( int x,int y );
BBDECL typedef void (__stdcall *LPDPRINT)( LPCTSTR _string );
BBDECL typedef int (__stdcall *LPDLOADANIMTEXTURE)( LPCTSTR file,int flags,int frame_width,int frame_height,int first_frame,int frame_count );
BBDECL typedef int (__stdcall *LPDLOADANIMTEXTUREFROMBANK)( int bank,int flags,int frame_width,int frame_height,int first_frame,int frame_count );
BBDECL typedef int (__stdcall *LPDMESHESINTERSECT)( int mesh_a,int mesh_b );
BBDECL typedef void (__stdcall *LPDROTATESPRITE)( int sprite,float angle );
BBDECL typedef void (__stdcall *LPDUPDATEWORLD)( float anim_speed );
BBDECL typedef int (__stdcall *LPDCREATECONE)( int segments,int solid,int parent );
BBDECL typedef void (__stdcall *LPDLIGHTCASTER)( int light,int enable );
BBDECL typedef void (__stdcall *LPDENTITYCASTER)( int entity,int enable );
BBDECL typedef void (__stdcall *LPDENITYSHADOWDETAIL)( int entity,int triangles,float detail_percent );
BBDECL typedef void (__stdcall *LPDENITYSHADOWCOLOR)( int entity,int red,int green,int blue );
BBDECL typedef void (__stdcall *LPDENITYSHADOWINTENSITY)( int entity,float intensity_percent );
BBDECL typedef void (__stdcall *LPDENABLESHADOWS)( int enable );
BBDECL typedef void (__stdcall *LPDENITYSHADOWCUTOFF)( int entity,float minimum,float maximum,float fadein );
BBDECL typedef void (__stdcall *LPDSETVSYNC)( int enable );
BBDECL typedef void (__stdcall *LPDSETWINDOWDEFAULTS)( int borderless,int minimize_button,int maximize_button,int close_button,int autoclose );
BBDECL typedef int (__stdcall *LPDWINCLOSE)( );
BBDECL typedef int (__stdcall *LPDCLEARWORLD)( int entities,int brushes,int textures );
BBDECL typedef void (__stdcall *LPDCLEARCOLLISIONS)( );
BBDECL typedef void (__stdcall *LPDCOLLISIONS)( int src_type,int dest_type,int _method,int response );
BBDECL typedef void (__stdcall *LPDTEXTUREFILTER)( LPCTSTR match_text,int flags );
BBDECL typedef void (__stdcall *LPDCLEARTEXTUREFILTERS)( );
BBDECL typedef int (__stdcall *LPDSCREENWIDTH)( );
BBDECL typedef int (__stdcall *LPDSCREENHEIGHT)( );
BBDECL typedef int (__stdcall *LPDWINDOWWIDTH)( );
BBDECL typedef int (__stdcall *LPDWINDOWHEIGHT)( );
BBDECL typedef int (__stdcall *LPDWINDOWX)( );
BBDECL typedef int (__stdcall *LPDWINDOWY)( );
BBDECL typedef int (__stdcall *LPDWINDOWRESIZED)( );
BBDECL typedef int (__stdcall *LPDWINDOWMOVED)( );
BBDECL typedef int (__stdcall *LPDMESHSIMPLIFY)( int mesh,int vertex_count,int triangle_count,float vertex_percent,float triangle_percent );
BBDECL typedef int (__stdcall *LPDVLCPRESENT)( );
BBDECL typedef void (__stdcall *LPDFREEVID)( int video );
BBDECL typedef int (__stdcall *LPDVIDLOAD)( LPCTSTR file );
BBDECL typedef int (__stdcall *LPDVIDDOWNLOAD)( int path );
BBDECL typedef int (__stdcall *LPDVIDTRACKCOUNT)( int video );
BBDECL typedef int (__stdcall *LPDVIDTRACKTYPE)( int video,int track );
BBDECL typedef int (__stdcall *LPDVIDWIDTH)( int video );
BBDECL typedef int (__stdcall *LPDVIDHEIGHT)( int video );
BBDECL typedef int (__stdcall *LPDVIDDURATION)( int video );
BBDECL typedef void (__stdcall *LPDVIDTEXTURE)( int video,int texture );
BBDECL typedef int (__stdcall *LPDGETVIDTEXTURE)( int video );
BBDECL typedef void (__stdcall *LPDVIDPLAY)( int video );
BBDECL typedef int (__stdcall *LPDVIDPLAYING)( int video );
BBDECL typedef void (__stdcall *LPDVIDSTOP)( int video );
BBDECL typedef void (__stdcall *LPDVIDPAUSE)( int video );
BBDECL typedef int (__stdcall *LPDVIDGETPOSITION)( int video );
BBDECL typedef int (__stdcall *LPDVIDSETPOSITION)( int video,int millisecs );
BBDECL typedef int (__stdcall *LPDVIDMUTED)( int video );
BBDECL typedef void (__stdcall *LPDVIDMUTE)( int video );
BBDECL typedef void (__stdcall *LPDVIDUNMUTE)( int video );
BBDECL typedef int (__stdcall *LPDVIDGETVOLUME)( int video );
BBDECL typedef void (__stdcall *LPDVIDSETVOLUME)( int video );
BBDECL typedef int (__stdcall *LPDVIDGETSUBTITLECOUNT)( int video );
BBDECL typedef int (__stdcall *LPDVIDGETAUDIOTRACKCOUNT)( int video );
BBDECL typedef LPCTSTR (__stdcall *LPDVIDGETAUDIOTRACKDESCRIPTION)( int video,int track );
BBDECL typedef void (__stdcall *LPDVIDSETAUDIOTRACK)( int video,int track );
BBDECL typedef LPCTSTR (__stdcall *LPDVIDGETSUBTITLEDESCRIPTION)( int video,int track );
BBDECL typedef void (__stdcall *LPDVIDSETSUBTITLE)( int video,int track );
BBDECL typedef LPCTSTR (__stdcall *LPDREQUESTFILE)( LPCTSTR title,LPCTSTR default_folder,LPCTSTR filter );
BBDECL typedef float (__stdcall *LPDVIDGETPLAYRATE)( int video );
BBDECL typedef void (__stdcall *LPDVIDSETPLAYRATE)( int video,float rate );
BBDECL typedef int (__stdcall *LPDDX11PRESENT)( );
BBDECL typedef void (__stdcall *LPDBEGINSCENE)( );
BBDECL typedef void (__stdcall *LPDENDSCENE)( );
BBDECL typedef void (__stdcall *LPDRENDERENTITY)( int entity,int camera );
BBDECL typedef void (__stdcall *LPDRENDERCLS)( int camera );
BBDECL typedef LPCTSTR (__stdcall *LPD11GETMAXFEATURELEVEL)( );
BBDECL typedef void (__stdcall *LPD11SOFTWAREEMULATION)( );
BBDECL typedef void (__stdcall *LPD11NOSOFTWAREEMULATION)( );
BBDECL typedef void (__stdcall *LPDDEBUGSILENT)( );
BBDECL typedef void (__stdcall *LPDDEBUGLOUD)( );
BBDECL typedef void (__stdcall *LPDDEBUGHARSH)( );
BBDECL typedef void (__stdcall *LPDDEBUGLOUDANDHARSH)( );
BBDECL typedef int (__stdcall *LPDLOADANIMMESH)( LPCTSTR file,int parent );
BBDECL typedef void (__stdcall *LPDANIMATE)( int entity,int mode,float speed,int sequence,float transition );
BBDECL typedef void (__stdcall *LPDSETANIMTIME)( int entity,float time,int anim_sequence );
BBDECL typedef float (__stdcall *LPDANIMTIME)( int entity );
BBDECL typedef int (__stdcall *LPDANIMATING)( int entity );
BBDECL typedef int (__stdcall *LPDCOUNTBONES)( int entity );
BBDECL typedef LPCTSTR (__stdcall *LPDBONENAME)( int entity,int bone );
BBDECL typedef float (__stdcall *LPDBONEX)( int entity,int bone,int _global,int initial_position );
BBDECL typedef float (__stdcall *LPDBONEY)( int entity,int bone,int _global,int initial_position );
BBDECL typedef float (__stdcall *LPDBONEZ)( int entity,int bone,int _global,int initial_position );
BBDECL typedef float (__stdcall *LPDBONEPITCH)( int entity,int bone,int _global );
BBDECL typedef float (__stdcall *LPDBONEYAW)( int entity,int bone,int _global );
BBDECL typedef float (__stdcall *LPDBONEROLL)( int entity,int bone,int _global );
BBDECL typedef void (__stdcall *LPDMOVEBONE)( int entity,int bone,float x,float y,float z );
BBDECL typedef void (__stdcall *LPDTURNBONE)( int entity,int bone,float pitch,float yaw,float roll );
BBDECL typedef int (__stdcall *LPDGETBONEPARENT)( int entity,int bone );
BBDECL typedef int (__stdcall *LPDGETROOTBONE)( int entity,int bone );
BBDECL typedef int (__stdcall *LPDCOUNTBONECHILDREN)( int entity,int bone );
BBDECL typedef int (__stdcall *LPDGETBONECHILD)( int entity,int bone,int child_index );
BBDECL typedef int (__stdcall *LPDCOUNTBONESIBLINGS)( int entity,int bone );
BBDECL typedef int (__stdcall *LPDGETBONESIBLING)( int entity,int bone,int sibling_index );
BBDECL typedef void (__stdcall *LPDSCALEBONE)( int entity,int bone,float scale_x,float scale_y,float scale_z,int _global );
BBDECL typedef float (__stdcall *LPDBONESCALEX)( int entity,int bone,int _global );
BBDECL typedef float (__stdcall *LPDBONESCALEY)( int entity,int bone,int _global );
BBDECL typedef float (__stdcall *LPDBONESCALEZ)( int entity,int bone,int _global );
BBDECL typedef int (__stdcall *LPDCOUNTBONEINFLUENCES)( int entity,int bone );
BBDECL typedef int (__stdcall *LPDGETBONEINFLUENCEVERTEX)( int entity,int bone,int influence_index );
BBDECL typedef int (__stdcall *LPDGETBONEINFLUENCESURFACE)( int entity,int bone,int influence_index );
BBDECL typedef float (__stdcall *LPDGETBONEINFLUENCEWEIGHT)( int entity,int bone,int influence_index );
BBDECL typedef int (__stdcall *LPDFINDBONE)( int entity,LPCTSTR name );
BBDECL typedef int (__stdcall *LPDRENAMEBONE)( int entity,int bone,LPCTSTR name );
BBDECL typedef int (__stdcall *LPDCOUNTVERTEXINFLUENCES)( int surface,int vertex );
BBDECL typedef int (__stdcall *LPDGETVERTEXINFLUENCEBONE)( int surface,int vertex,int influence_index );
BBDECL typedef float (__stdcall *LPDGETVERTEXINFLUENCEWEIGHT)( int surface,int vertex,int influence_index );
BBDECL typedef void (__stdcall *LPDSETBONEINFLUENCEWEIGHT)( int entity,int bone,int influence_index,float weight );
BBDECL typedef void (__stdcall *LPDFREEBONEINFLUENCE)( int entity,int bone,int influence_index );
BBDECL typedef void (__stdcall *LPDBONEPARENT)( int entity,int bone,int parent_bone );
BBDECL typedef void (__stdcall *LPDFREEBONE)( int entity,int bone );
BBDECL typedef int (__stdcall *LPDCOUNTCAPTUREDEVICES)( );
BBDECL typedef LPCTSTR (__stdcall *LPDCAPTURENAME)( int capture_device_number );
BBDECL typedef int (__stdcall *LPDOPENCAPTUREDEVICE)( int capture_device_number );
BBDECL typedef int (__stdcall *LPDCAPTUREWIDTH)( int capture_device_number );
BBDECL typedef int (__stdcall *LPDCAPTUREHEIGHT)( int capture_device_number );
BBDECL typedef void (__stdcall *LPDUPNPSEARCH)( );
BBDECL typedef int (__stdcall *LPDUPNPSEARCHDONE)( );
BBDECL typedef int (__stdcall *LPDUPNPCOUNT)( );
BBDECL typedef LPCTSTR (__stdcall *LPDUPNPNAME)( int device_index );
BBDECL typedef void (__stdcall *LPDSETANIMKEY)( int entity,float frame,int pos_key,int rotation_key,int scale_key );
BBDECL typedef int (__stdcall *LPDADDANIMSEQ)( int entity,int length );
BBDECL typedef void (__stdcall *LPDENTITYHWSHADERS)( int entity,int enable );
BBDECL typedef void (__stdcall *LPDHWSHADERS)( int entity );
BBDECL typedef int (__stdcall *LPDSURFACEHWSHADERS)( int surface,int enable );
BBDECL typedef int (__stdcall *LPDENTITYNEGATIVE)( int entity,int enable );
BBDECL typedef void (__stdcall *LPDENTITYTEXTUREBOUNDARY)( int entity,int texture_index,float min_x,float min_y,float min_z,float max_x,float max_y,float max_z );

LPDCOUNTGFXDRIVERS dxCountGfxDrivers;
LPDGRAPHICS3D dxGraphics3D;
LPDENDGRAPHICS dxEndGraphics;
LPDSHOWMOUSE dxShowMouse;
LPDHIDEMOUSE dxHideMouse;
LPDKEYDOWN dxKeyDown;
LPDMOUSEDOWN dxMouseDown;
LPDGETMOUSE dxGetMouse;
LPDMOUSEHIT dxMouseHit;
LPDWAITMOUSE dxWaitMouse;
LPDMOUSEX dxMouseX;
LPDMOUSEY dxMouseY;
LPDMOUSEZ dxMouseZ;
LPDMOVEMOUSE dxMoveMouse;
LPDFLUSHMOUSE dxFlushMouse;
LPDMOUSEXSPEED dxMouseXSpeed;
LPDMOUSEYSPEED dxMouseYSpeed;
LPDMOUSEZSPEED dxMouseZSpeed;
LPDKEYHIT dxKeyHit;
LPDFLUSHKEYS dxFlushKeys;
LPDWAITKEY dxWaitKey;
LPDLOADFONT dxLoadFont;
LPDCLS dxCls;
LPDCLSCOLOR dxClsColor;
LPDFLIP dxFlip;
LPDFRONTBUFFER dxFrontBuffer;
LPDBACKBUFFER dxBackBuffer;
LPDCOLOR dxColor;
LPDPLOT dxPlot;
LPDCREATEMESH dxCreateMesh;
LPDCREATECAMERA dxCreateCamera;
LPDPOSITIONENTITY dxPositionEntity;
LPDCREATETEAPOT dxCreateTeapot;
LPDRENDERWORLD dxRenderWorld;
LPDADDVERTEX dxAddVertex;
LPDCREATESURFACE dxCreateSurface;
LPDCOUNTVERTICES dxCountVertices;
LPDVERTEXCOLOR dxVertexColor;
LPDVERTEXRED dxVertexRed;
LPDVERTEXGREEN dxVertexGreen;
LPDVERTEXBLUE dxVertexBlue;
LPDVERTEXALPHA dxVertexAlpha;
LPDVERTEXTEXCOORDS dxVertexTexCoords;
LPDVERTEXNORMAL dxVertexNormal;
LPDVERTEXX dxVertexX;
LPDVERTEXY dxVertexY;
LPDVERTEXZ dxVertexZ;
LPDVERTEXNX dxVertexNX;
LPDVERTEXNY dxVertexNY;
LPDVERTEXNZ dxVertexNZ;
LPDVERTEXU dxVertexU;
LPDVERTEXV dxVertexV;
LPDVERTEXW dxVertexW;
LPDCOUNTSURFACES dxCountSurfaces;
LPDCLEARSURFACE dxClearSurface;
LPDADDTRIANGLE dxAddTriangle;
LPDCOUNTTRIANGLES dxCountTriangles;
LPDTRIANGLEVERTEX dxTriangleVertex;
LPDAMBIENTLIGHT dxAmbientLight;
LPDCAMERAVIEWPORT dxCameraViewport;
LPDCAMERACLSCOLOR dxCameraClsColor;
LPDCAMERAPROJMODE dxCameraProjMode;
LPDCAMERARANGE dxCameraRange;
LPDCAMERACLSMODE dxCameraClsMode;
LPDCAMERAASPECT dxCameraAspect;
LPDAUTOCAMERAASPECT dxAutoCameraAspect;
LPDCAMERAFOV dxCameraFOV;
LPDGETCAMERAFOV dxGetCameraFOV;
LPDGETCAMERAASPECT dxGetCameraAspect;
LPDCREATETORUS dxCreateTorus;
LPDCREATECUBE dxCreateCube;
LPDCREATECYLINDER dxCreateCylinder;
LPDCREATESPHERE dxCreateSphere;
LPDFREEENTITY dxFreeEntity;
LPDENTITYPARENT dxEntityParent;
LPDCOUNTCHILDREN dxCountChildren;
LPDGETCHILD dxGetChild;
LPDENTITYCLASS dxEntityClass;
LPDGETPARENT dxGetParent;
LPDNAMEENTITY dxNameEntity;
LPDENTITYNAME dxEntityName;
LPDENTITYX dxEntityX;
LPDENTITYY dxEntityY;
LPDENTITYZ dxEntityZ;
LPDROTATEENTITY dxRotateEntity;
LPDGETMATELEMENT dxGetMatElement;
LPDUPDATENORMALS dxUpdateNormals;
LPDCREATETEXTURE dxCreateTexture;
LPDTURNENTITY dxTurnEntity;
LPDMOVEENTITY dxMoveEntity;
LPDTRANSLATEENTITY dxTranslateEntity;
LPDENTITYRED dxEntityRed;
LPDENTITYGREEN dxEntityGreen;
LPDENTITYBLUE dxEntityBlue;
LPDENTITYCOLOR dxEntityColor;
LPDENTITYFX dxEntityFX;
LPDGETENTITYFX dxGetEntityFX;
LPDDITHER dxDither;
LPDCAMERAFOGMODE dxCameraFogMode;
LPDCAMERAFOGCOLOR dxCameraFogColor;
LPDCAMERAFOGRANGE dxCameraFogRange;
LPDLOADTEXTURE dxLoadTexture;
LPDENTITYTEXTURE dxEntityTexture;
LPDCOUNTGFXMODES3D dxCountGfxModes3D;
LPDGFXMODEWIDTH dxGfxModeWidth;
LPDGFXMODEHEIGHT dxGfxModeHeight;
LPDGFXMODEDEPTH dxGfxModeDepth;
LPDGFXMODEREFRESHRATE dxGfxModeRefreshRate;
LPDWIREFRAME dxWireframe;
LPDENTITYWIREFRAME dxEntityWireframe;
LPDPOINTFRAME dxPointframe;
LPDENTITYPOINTFRAME dxEntityPointframe;
LPDSCALEENTITY dxScaleEntity;
LPDENTITYSCALEX dxEntityScaleX;
LPDENTITYSCALEY dxEntityScaleY;
LPDENTITYSCALEZ dxEntityScaleZ;
LPDCREATELIGHT dxCreateLight;
LPDCOLORRED dxColorRed;
LPDCOLORGREEN dxColorGreen;
LPDCOLORBLUE dxColorBlue;
LPDGRAPHICSBUFFER dxGraphicsBuffer;
LPDSETBUFFER dxSetBuffer;
LPDCREATETEXT dxCreateText;
LPD3DFONT dx3DFont;
LPDRECT dxRect;
LPDTEXTUREBUFFER dxTextureBuffer;
LPDGRAPHICSWIDTH dxGraphicsWidth;
LPDGRAPHICSHEIGHT dxGraphicsHeight;
LPDGRAPHICSDEPTH dxGraphicsDepth;
LPDGETCOLOR dxGetColor;
LPDREADPIXEL dxReadPixel;
LPDLIGHTCOLOR dxLightColor;
LPDLIGHTRANGE dxLightRange;
LPDLIGHTCONEANGLES dxLightConeAngles;
LPDHIDEENTITY dxHideEntity;
LPDSHOWENTITY dxShowEntity;
LPDENTITYORDER dxEntityOrder;
LPDOVAL dxOval;
LPDLINE dxLine;
LPDTEXT dxText;
LPDSETFONT dxSetFont;
LPDFREEFONT dxFreeFont;
LPDUPDATESURFACENORMALS dxUpdateSurfaceNormals;
LPDWBUFFER dxWBuffer;
LPDPIXELSHADERVERSION dxPixelShaderVersion;
LPDVERTEXSHADERVERSION dxVertexShaderVersion;
LPDCREATEPIXELSHADER dxCreatePixelShader;
LPDFREEPIXELSHADER dxFreePixelShader;
LPDCREATEVERTEXSHADER dxCreateVertexShader;
LPDFREEVERTEXSHADER dxFreeVertexShader;
LPDENTITYPIXELSHADER dxEntityPixelShader;
LPDENTITYVERTEXSHADER dxEntityVertexShader;
LPDGETLASTSHADERERROR dxGetLastShaderError;
LPDVERTEXCOORDS dxVertexCoords;
LPDFLIPMESH dxFlipMesh;
LPDAPPTITLE dxApptitle;
LPDCOUNTENTITIES dxCountEntities;
LPDGETSURFACE dxGetSurface;
LPDFIRSTENTITY dxFirstEntity;
LPDNEXTENTITY dxNextEntity;
LPDPREVIOUSENTITY dxPreviousEntity;
LPDENTITYBLEND dxEntityBlend;
LPDCOPYENTITY dxCopyEntity;
LPDFREESURFACE dxFreeSurface;
LPDTEXTUREBLEND dxTextureBlend;
LPDGETVERSION dxGetVersion;
LPDSTRINGWIDTH dxStringWidth;
LPDSTRINGHEIGHT dxStringHeight;
LPDCREATEBRUSH dxCreateBrush;
LPDFREEBRUSH dxFreeBrush;
LPDBRUSHCOLOR dxBrushColor;
LPDBRUSHALPHA dxBrushAlpha;
LPDBRUSHSHININESS dxBrushShininess;
LPDBRUSHFX dxBrushFX;
LPDBRUSHTEXTURE dxBrushTexture;
LPDBRUSHBLEND dxBrushBlend;
LPDGETENTITYBRUSH dxGetEntityBrush;
LPDNAMETEXTURE dxNameTexture;
LPDTEXTURENAME dxTextureName;
LPDTEXTURECOORDS dxTextureCoords;
LPDTEXTUREWIDTH dxTextureWidth;
LPDTEXTUREHEIGHT dxTextureHeight;
LPDGETDEBUGFLOAT dxGetDebugFloat;
LPDSCALETEXTURE dxScaleTexture;
LPDPOSITIONTEXTURE dxPositionTexture;
LPDROTATETEXTURE dxRotateTexture;
LPDENTITYALPHA dxEntityAlpha;
LPDGETENTITYALPHA dxGetEntityAlpha;
LPDPOSITIONMESH dxPositionMesh;
LPDMESHWIDTH dxMeshWidth;
LPDMESHHEIGHT dxMeshHeight;
LPDMESHDEPTH dxMeshDepth;
LPDENTITYPITCH dxEntityPitch;
LPDENTITYYAW dxEntityYaw;
LPDENTITYROLL dxEntityRoll;
LPDFREESURFACEATTRIBS dxFreeSurfaceAttribs;
LPDSURFACEFX dxSurfaceFx;
LPDSURFACEBLEND dxSurfaceBlend;
LPDSURFACEALPHA dxSurfaceAlpha;
LPDSURFACEWIREFRAME dxSurfaceWireframe;
LPDSURFACEPOINTFRAME dxSurfacePointframe;
LPDSURFACEPIXELSHADER dxSurfacePixelShader;
LPDSURFACEVERTEXSHADER dxSurfaceVertexShader;
LPDSURFACECOLOR dxSurfaceColor;
LPDGETSURFACEBRUSH dxGetSurfaceBrush;
LPDPAINTENTITY dxPaintEntity;
LPDPAINTSURFACE dxPaintSurface;
LPDSURFACETEXTURE dxSurfaceTexture;
LPDWRITEPIXEL dxWritePixel;
LPDLOCKBUFFER dxLockBuffer;
LPDUNLOCKBUFFER dxUnLockBuffer;
LPDWRITEPIXELFAST dxWritePixelFast;
LPDREADPIXELFAST dxReadPixelFast;
LPDTEXTURESAVE dxTextureSave;
LPDCOPYSURFACE dxCopySurface;
LPDCOPYMESH dxCopyMesh;
LPDCREATEIMAGE dxCreateImage;
LPDFREEIMAGE dxFreeImage;
LPDIMAGEWIDTH dxImageWidth;
LPDIMAGEHEIGHT dxImageHeight;
LPDIMAGEBUFFER dxImageBuffer;
LPDCOPYIMAGE dxCopyImage;
LPDCOPYRECT dxCopyRect;
LPDSETFILTERS dxSetFilters;
LPDRENDERTOTEXTURE dxRenderToTexture;
LPDRENDERTOSCREEN dxRenderToScreen;
LPDCREATESPRITE dxCreateSprite;
LPDSPRITEVIEWMODE dxSpriteViewMode;
LPDSCALESPRITE dxScaleSprite;
LPDHANDLESPRITE dxHandleSprite;
LPDUSEDIRECTX11 dxUseDirectX11;
LPDDIRECTX11USED dxDirectX11Used;
LPDSEEDRND dxSeedRnd;
LPDRND dxRnd;
LPDRAND dxRand;
LPDCREATEPIVOT dxCreatePivot;
LPDBUFFERNOISE dxBufferNoise;
LPDBUFFERINVERT dxBufferInvert;
LPDSETCUBEFACE dxSetCubeFace;
LPDGETSURFACEBOUNDINGRADIUS dxGetSurfaceBoundingRadius;
LPDTRISRENDERED dxTrisRendered;
LPDENTITYINVIEW dxEntityInView;
LPDMAXLIGHTS dxMaxLights;
LPDCREATETERRAIN dxCreateTerrain;
LPDMODIFYTERRAIN dxModifyTerrain;
LPDTERRAINSIZE dxTerrainSize;
LPDLOADTERRAIN dxLoadTerrain;
LPDTERRAINHEIGHT dxTerrainHeight;
LPDFITMESH dxFitMesh;
LPDSCALEMESH dxScaleMesh;
LPDGETCONSTANTTABLESIZE dxGetConstantTableSize;
LPDCONSTANTCOUNT dxConstantCount;
LPDDECLAREVERTEXSHADERWORLDCONSTANT dxDeclareVertexShaderWorldConstant;
LPDDECLAREVERTEXSHADERVIEWCONSTANT dxDeclareVertexShaderViewConstant;
LPDDECLAREVERTEXSHADERPROJCONSTANT dxDeclareVertexShaderProjConstant;
LPDDECLAREVERTEXSHADERWORLDVIEWPROJCONSTANT dxDeclareVertexShaderWorldViewProjConstant;
LPDENTITYRADIUS dxEntityRadius;
LPDENTITYBOX dxEntityBox;
LPDENTITYTYPE dxEntityType;
LPDENTITYPICKMODE dxEntityPickMode;
LPDGETENTITYTYPE dxGetEntityType;
LPDGETFPS dxGetFPS;
LPDPOINTENTITY dxPointEntity;
LPDALIGNTOVECTOR dxAlignToVector;
LPDFRAMESRENDERED dxFramesRendered;
LPDTFORMPOINT dxTFormPoint;
LPDTFORMEDX dxTFormedX;
LPDTFORMEDY dxTFormedY;
LPDTFORMEDZ dxTFormedZ;
LPDENTITYDISTANCE dxEntityDistance;
LPDVECTORYAW dxVectorYaw;
LPDVECTORPITCH dxVectorPitch;
LPDCAMERAPROJECT dxCameraProject;
LPDPROJECTEDX dxProjectedX;
LPDPROJECTEDY dxProjectedY;
LPDPROJECTEDZ dxProjectedZ;
LPDDELTAPITCH dxDeltaPitch;
LPDDELTAYAW dxDeltaYaw;
LPDCAMERAPICK dxCameraPick;
LPDPICKEDX dxPickedX;
LPDPICKEDY dxPickedY;
LPDPICKEDZ dxPickedZ;
LPDPICKEDNX dxPickedNX;
LPDPICKEDNY dxPickedNY;
LPDPICKEDNZ dxPickedNZ;
LPDPICKEDTIME dxPickedTime;
LPDPICKEDENTITY dxPickedEntity;
LPDPICKEDSURFACE dxPickedSurface;
LPDPICKEDTRIANGLE dxPickedTriangle;
LPDENTITYPICK dxEntityPick;
LPDLINEPICK dxLinePick;
LPDHIDEWINDOW dxHideWindow;
LPDISWINDOWMINIMIZED dxIsWindowMinimized;
LPDROTATEMESH dxRotateMesh;
LPDCREATEEMITTER dxCreateEmitter;
LPDEMITTERCOUNTELEMENTS dxEmitterCountElements;
LPDEMITTERSETELEMENTCOUNT dxEmitterSetElementCount;
LPDEMITTERDELETEELEMENT dxEmitterDeleteElement;
LPDGETWINVERSION dxGetWinVersion;
LPDCAMERAZOOM dxCameraZoom;
LPDSURFACESHININESS dxSurfaceShininess;
LPDENTITYSHININESS dxEntityShininess;
LPDCREATEMAZE dxCreateMaze;
LPDFREEMAZE dxFreeMaze;
LPDREADMAZE dxReadMaze;
LPDLOADMESH dxLoadMesh;
LPDSAVEMESH dxSaveMesh;
LPDLOADMESHXFROMBANK dxLoadMeshXFromBank;
LPDLOADTEXTUREFROMBANK dxLoadTextureFromBank;
LPDBANKSIZE dxBankSize;
LPDPEEKMEMINT dxPeekMemInt;
LPDPOKEMEMINT dxPokeMemInt;
LPDLOCATE dxLocate;
LPDPRINT dxPrint;
LPDLOADANIMTEXTURE dxLoadAnimTexture;
LPDLOADANIMTEXTUREFROMBANK dxLoadAnimTextureFromBank;
LPDMESHESINTERSECT dxMeshesIntersect;
LPDROTATESPRITE dxRotateSprite;
LPDUPDATEWORLD dxUpdateWorld;
LPDCREATECONE dxCreateCone;
LPDLIGHTCASTER dxLightCaster;
LPDENTITYCASTER dxEntityCaster;
LPDENITYSHADOWDETAIL dxEnityShadowDetail;
LPDENITYSHADOWCOLOR dxEnityShadowColor;
LPDENITYSHADOWINTENSITY dxEnityShadowIntensity;
LPDENABLESHADOWS dxEnableShadows;
LPDENITYSHADOWCUTOFF dxEnityShadowCutoff;
LPDSETVSYNC dxSetVSync;
LPDSETWINDOWDEFAULTS dxSetWindowDefaults;
LPDWINCLOSE dxWinClose;
LPDCLEARWORLD dxClearWorld;
LPDCLEARCOLLISIONS dxClearCollisions;
LPDCOLLISIONS dxCollisions;
LPDTEXTUREFILTER dxTextureFilter;
LPDCLEARTEXTUREFILTERS dxClearTextureFilters;
LPDSCREENWIDTH dxScreenWidth;
LPDSCREENHEIGHT dxScreenHeight;
LPDWINDOWWIDTH dxWindowWidth;
LPDWINDOWHEIGHT dxWindowHeight;
LPDWINDOWX dxWindowX;
LPDWINDOWY dxWindowY;
LPDWINDOWRESIZED dxWindowResized;
LPDWINDOWMOVED dxWindowMoved;
LPDMESHSIMPLIFY dxMeshSimplify;
LPDVLCPRESENT dxVlcPresent;
LPDFREEVID dxFreeVid;
LPDVIDLOAD dxVidLoad;
LPDVIDDOWNLOAD dxVidDownload;
LPDVIDTRACKCOUNT dxVidTrackCount;
LPDVIDTRACKTYPE dxVidTrackType;
LPDVIDWIDTH dxVidWidth;
LPDVIDHEIGHT dxVidHeight;
LPDVIDDURATION dxVidDuration;
LPDVIDTEXTURE dxVidTexture;
LPDGETVIDTEXTURE dxGetVidTexture;
LPDVIDPLAY dxVidPlay;
LPDVIDPLAYING dxVidPlaying;
LPDVIDSTOP dxVidStop;
LPDVIDPAUSE dxVidPause;
LPDVIDGETPOSITION dxVidGetPosition;
LPDVIDSETPOSITION dxVidSetPosition;
LPDVIDMUTED dxVidMuted;
LPDVIDMUTE dxVidMute;
LPDVIDUNMUTE dxVidUnMute;
LPDVIDGETVOLUME dxVidGetVolume;
LPDVIDSETVOLUME dxVidSetVolume;
LPDVIDGETSUBTITLECOUNT dxVidGetSubtitleCount;
LPDVIDGETAUDIOTRACKCOUNT dxVidGetAudioTrackCount;
LPDVIDGETAUDIOTRACKDESCRIPTION dxVidGetAudioTrackDescription;
LPDVIDSETAUDIOTRACK dxVidSetAudioTrack;
LPDVIDGETSUBTITLEDESCRIPTION dxVidGetSubtitleDescription;
LPDVIDSETSUBTITLE dxVidSetSubtitle;
LPDREQUESTFILE dxRequestFile;
LPDVIDGETPLAYRATE dxVidGetPlayRate;
LPDVIDSETPLAYRATE dxVidSetPlayRate;
LPDDX11PRESENT dxDx11Present;
LPDBEGINSCENE dxBeginScene;
LPDENDSCENE dxEndScene;
LPDRENDERENTITY dxRenderEntity;
LPDRENDERCLS dxRenderCls;
LPD11GETMAXFEATURELEVEL dx11GetMaxFeatureLevel;
LPD11SOFTWAREEMULATION dx11SoftwareEmulation;
LPD11NOSOFTWAREEMULATION dx11NoSoftwareEmulation;
LPDDEBUGSILENT dxDebugSilent;
LPDDEBUGLOUD dxDebugLoud;
LPDDEBUGHARSH dxDebugHarsh;
LPDDEBUGLOUDANDHARSH dxDebugLoudAndHarsh;
LPDLOADANIMMESH dxLoadAnimMesh;
LPDANIMATE dxAnimate;
LPDSETANIMTIME dxSetAnimTime;
LPDANIMTIME dxAnimTime;
LPDANIMATING dxAnimating;
LPDCOUNTBONES dxCountBones;
LPDBONENAME dxBoneName;
LPDBONEX dxBoneX;
LPDBONEY dxBoneY;
LPDBONEZ dxBoneZ;
LPDBONEPITCH dxBonePitch;
LPDBONEYAW dxBoneYaw;
LPDBONEROLL dxBoneRoll;
LPDMOVEBONE dxMoveBone;
LPDTURNBONE dxTurnBone;
LPDGETBONEPARENT dxGetBoneParent;
LPDGETROOTBONE dxGetRootBone;
LPDCOUNTBONECHILDREN dxCountBoneChildren;
LPDGETBONECHILD dxGetBoneChild;
LPDCOUNTBONESIBLINGS dxCountBoneSiblings;
LPDGETBONESIBLING dxGetBoneSibling;
LPDSCALEBONE dxScaleBone;
LPDBONESCALEX dxBoneScaleX;
LPDBONESCALEY dxBoneScaleY;
LPDBONESCALEZ dxBoneScaleZ;
LPDCOUNTBONEINFLUENCES dxCountBoneInfluences;
LPDGETBONEINFLUENCEVERTEX dxGetBoneInfluenceVertex;
LPDGETBONEINFLUENCESURFACE dxGetBoneInfluenceSurface;
LPDGETBONEINFLUENCEWEIGHT dxGetBoneInfluenceWeight;
LPDFINDBONE dxFindBone;
LPDRENAMEBONE dxRenameBone;
LPDCOUNTVERTEXINFLUENCES dxCountVertexInfluences;
LPDGETVERTEXINFLUENCEBONE dxGetVertexInfluenceBone;
LPDGETVERTEXINFLUENCEWEIGHT dxGetVertexInfluenceWeight;
LPDSETBONEINFLUENCEWEIGHT dxSetBoneInfluenceWeight;
LPDFREEBONEINFLUENCE dxFreeBoneInfluence;
LPDBONEPARENT dxBoneParent;
LPDFREEBONE dxFreeBone;
LPDCOUNTCAPTUREDEVICES dxCountCaptureDevices;
LPDCAPTURENAME dxCaptureName;
LPDOPENCAPTUREDEVICE dxOpenCaptureDevice;
LPDCAPTUREWIDTH dxCaptureWidth;
LPDCAPTUREHEIGHT dxCaptureHeight;
LPDUPNPSEARCH dxUpnpSearch;
LPDUPNPSEARCHDONE dxUpnpSearchDone;
LPDUPNPCOUNT dxUpnpCount;
LPDUPNPNAME dxUpnpName;
LPDSETANIMKEY dxSetAnimKey;
LPDADDANIMSEQ dxAddAnimSeq;
LPDENTITYHWSHADERS dxEntityHWShaders;
LPDHWSHADERS dxHWShaders;
LPDSURFACEHWSHADERS dxSurfaceHWShaders;
LPDENTITYNEGATIVE dxEntityNegative;
LPDENTITYTEXTUREBOUNDARY dxEntityTextureBoundary;

BBDECL int InitDLL ()
{
HW_DLL = LoadLibrary ("Hardwired.dll");

if (HW_DLL != NULL)
	{
		dxCountGfxDrivers = (LPDCOUNTGFXDRIVERS)GetProcAddress ((HMODULE)HW_DLL, "dCountGfxDrivers");

		if (dxCountGfxDrivers == NULL)
		{
			cout << "Function dxCountGfxDrivers (\"dCountGfxDrivers\") not found in DLL!\n";
		}

		dxGraphics3D = (LPDGRAPHICS3D)GetProcAddress ((HMODULE)HW_DLL, "dGraphics3D");

		if (dxGraphics3D == NULL)
		{
			cout << "Function dxGraphics3D (\"dGraphics3D\") not found in DLL!\n";
		}

		dxEndGraphics = (LPDENDGRAPHICS)GetProcAddress ((HMODULE)HW_DLL, "dEndGraphics");

		if (dxEndGraphics == NULL)
		{
			cout << "Function dxEndGraphics (\"dEndGraphics\") not found in DLL!\n";
		}

		dxShowMouse = (LPDSHOWMOUSE)GetProcAddress ((HMODULE)HW_DLL, "dShowMouse");

		if (dxShowMouse == NULL)
		{
			cout << "Function dxShowMouse (\"dShowMouse\") not found in DLL!\n";
		}

		dxHideMouse = (LPDHIDEMOUSE)GetProcAddress ((HMODULE)HW_DLL, "dHideMouse");

		if (dxHideMouse == NULL)
		{
			cout << "Function dxHideMouse (\"dHideMouse\") not found in DLL!\n";
		}

		dxKeyDown = (LPDKEYDOWN)GetProcAddress ((HMODULE)HW_DLL, "dKeyDown");

		if (dxKeyDown == NULL)
		{
			cout << "Function dxKeyDown (\"dKeyDown\") not found in DLL!\n";
		}

		dxMouseDown = (LPDMOUSEDOWN)GetProcAddress ((HMODULE)HW_DLL, "dMouseDown");

		if (dxMouseDown == NULL)
		{
			cout << "Function dxMouseDown (\"dMouseDown\") not found in DLL!\n";
		}

		dxGetMouse = (LPDGETMOUSE)GetProcAddress ((HMODULE)HW_DLL, "dGetMouse");

		if (dxGetMouse == NULL)
		{
			cout << "Function dxGetMouse (\"dGetMouse\") not found in DLL!\n";
		}

		dxMouseHit = (LPDMOUSEHIT)GetProcAddress ((HMODULE)HW_DLL, "dMouseHit");

		if (dxMouseHit == NULL)
		{
			cout << "Function dxMouseHit (\"dMouseHit\") not found in DLL!\n";
		}

		dxWaitMouse = (LPDWAITMOUSE)GetProcAddress ((HMODULE)HW_DLL, "dWaitMouse");

		if (dxWaitMouse == NULL)
		{
			cout << "Function dxWaitMouse (\"dWaitMouse\") not found in DLL!\n";
		}

		dxMouseX = (LPDMOUSEX)GetProcAddress ((HMODULE)HW_DLL, "dMouseX");

		if (dxMouseX == NULL)
		{
			cout << "Function dxMouseX (\"dMouseX\") not found in DLL!\n";
		}

		dxMouseY = (LPDMOUSEY)GetProcAddress ((HMODULE)HW_DLL, "dMouseY");

		if (dxMouseY == NULL)
		{
			cout << "Function dxMouseY (\"dMouseY\") not found in DLL!\n";
		}

		dxMouseZ = (LPDMOUSEZ)GetProcAddress ((HMODULE)HW_DLL, "dMouseZ");

		if (dxMouseZ == NULL)
		{
			cout << "Function dxMouseZ (\"dMouseZ\") not found in DLL!\n";
		}

		dxMoveMouse = (LPDMOVEMOUSE)GetProcAddress ((HMODULE)HW_DLL, "dMoveMouse");

		if (dxMoveMouse == NULL)
		{
			cout << "Function dxMoveMouse (\"dMoveMouse\") not found in DLL!\n";
		}

		dxFlushMouse = (LPDFLUSHMOUSE)GetProcAddress ((HMODULE)HW_DLL, "dFlushMouse");

		if (dxFlushMouse == NULL)
		{
			cout << "Function dxFlushMouse (\"dFlushMouse\") not found in DLL!\n";
		}

		dxMouseXSpeed = (LPDMOUSEXSPEED)GetProcAddress ((HMODULE)HW_DLL, "dMouseXSpeed");

		if (dxMouseXSpeed == NULL)
		{
			cout << "Function dxMouseXSpeed (\"dMouseXSpeed\") not found in DLL!\n";
		}

		dxMouseYSpeed = (LPDMOUSEYSPEED)GetProcAddress ((HMODULE)HW_DLL, "dMouseYSpeed");

		if (dxMouseYSpeed == NULL)
		{
			cout << "Function dxMouseYSpeed (\"dMouseYSpeed\") not found in DLL!\n";
		}

		dxMouseZSpeed = (LPDMOUSEZSPEED)GetProcAddress ((HMODULE)HW_DLL, "dMouseZSpeed");

		if (dxMouseZSpeed == NULL)
		{
			cout << "Function dxMouseZSpeed (\"dMouseZSpeed\") not found in DLL!\n";
		}

		dxKeyHit = (LPDKEYHIT)GetProcAddress ((HMODULE)HW_DLL, "dKeyHit");

		if (dxKeyHit == NULL)
		{
			cout << "Function dxKeyHit (\"dKeyHit\") not found in DLL!\n";
		}

		dxFlushKeys = (LPDFLUSHKEYS)GetProcAddress ((HMODULE)HW_DLL, "dFlushKeys");

		if (dxFlushKeys == NULL)
		{
			cout << "Function dxFlushKeys (\"dFlushKeys\") not found in DLL!\n";
		}

		dxWaitKey = (LPDWAITKEY)GetProcAddress ((HMODULE)HW_DLL, "dWaitKey");

		if (dxWaitKey == NULL)
		{
			cout << "Function dxWaitKey (\"dWaitKey\") not found in DLL!\n";
		}

		dxLoadFont = (LPDLOADFONT)GetProcAddress ((HMODULE)HW_DLL, "dLoadFont");

		if (dxLoadFont == NULL)
		{
			cout << "Function dxLoadFont (\"dLoadFont\") not found in DLL!\n";
		}

		dxCls = (LPDCLS)GetProcAddress ((HMODULE)HW_DLL, "dCls");

		if (dxCls == NULL)
		{
			cout << "Function dxCls (\"dCls\") not found in DLL!\n";
		}

		dxClsColor = (LPDCLSCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dClsColor");

		if (dxClsColor == NULL)
		{
			cout << "Function dxClsColor (\"dClsColor\") not found in DLL!\n";
		}

		dxFlip = (LPDFLIP)GetProcAddress ((HMODULE)HW_DLL, "dFlip");

		if (dxFlip == NULL)
		{
			cout << "Function dxFlip (\"dFlip\") not found in DLL!\n";
		}

		dxFrontBuffer = (LPDFRONTBUFFER)GetProcAddress ((HMODULE)HW_DLL, "dFrontBuffer");

		if (dxFrontBuffer == NULL)
		{
			cout << "Function dxFrontBuffer (\"dFrontBuffer\") not found in DLL!\n";
		}

		dxBackBuffer = (LPDBACKBUFFER)GetProcAddress ((HMODULE)HW_DLL, "dBackBuffer");

		if (dxBackBuffer == NULL)
		{
			cout << "Function dxBackBuffer (\"dBackBuffer\") not found in DLL!\n";
		}

		dxColor = (LPDCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dColor");

		if (dxColor == NULL)
		{
			cout << "Function dxColor (\"dColor\") not found in DLL!\n";
		}

		dxPlot = (LPDPLOT)GetProcAddress ((HMODULE)HW_DLL, "dPlot");

		if (dxPlot == NULL)
		{
			cout << "Function dxPlot (\"dPlot\") not found in DLL!\n";
		}

		dxCreateMesh = (LPDCREATEMESH)GetProcAddress ((HMODULE)HW_DLL, "dCreateMesh");

		if (dxCreateMesh == NULL)
		{
			cout << "Function dxCreateMesh (\"dCreateMesh\") not found in DLL!\n";
		}

		dxCreateCamera = (LPDCREATECAMERA)GetProcAddress ((HMODULE)HW_DLL, "dCreateCamera");

		if (dxCreateCamera == NULL)
		{
			cout << "Function dxCreateCamera (\"dCreateCamera\") not found in DLL!\n";
		}

		dxPositionEntity = (LPDPOSITIONENTITY)GetProcAddress ((HMODULE)HW_DLL, "dPositionEntity");

		if (dxPositionEntity == NULL)
		{
			cout << "Function dxPositionEntity (\"dPositionEntity\") not found in DLL!\n";
		}

		dxCreateTeapot = (LPDCREATETEAPOT)GetProcAddress ((HMODULE)HW_DLL, "dCreateTeapot");

		if (dxCreateTeapot == NULL)
		{
			cout << "Function dxCreateTeapot (\"dCreateTeapot\") not found in DLL!\n";
		}

		dxRenderWorld = (LPDRENDERWORLD)GetProcAddress ((HMODULE)HW_DLL, "dRenderWorld");

		if (dxRenderWorld == NULL)
		{
			cout << "Function dxRenderWorld (\"dRenderWorld\") not found in DLL!\n";
		}

		dxAddVertex = (LPDADDVERTEX)GetProcAddress ((HMODULE)HW_DLL, "dAddVertex");

		if (dxAddVertex == NULL)
		{
			cout << "Function dxAddVertex (\"dAddVertex\") not found in DLL!\n";
		}

		dxCreateSurface = (LPDCREATESURFACE)GetProcAddress ((HMODULE)HW_DLL, "dCreateSurface");

		if (dxCreateSurface == NULL)
		{
			cout << "Function dxCreateSurface (\"dCreateSurface\") not found in DLL!\n";
		}

		dxCountVertices = (LPDCOUNTVERTICES)GetProcAddress ((HMODULE)HW_DLL, "dCountVertices");

		if (dxCountVertices == NULL)
		{
			cout << "Function dxCountVertices (\"dCountVertices\") not found in DLL!\n";
		}

		dxVertexColor = (LPDVERTEXCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dVertexColor");

		if (dxVertexColor == NULL)
		{
			cout << "Function dxVertexColor (\"dVertexColor\") not found in DLL!\n";
		}

		dxVertexRed = (LPDVERTEXRED)GetProcAddress ((HMODULE)HW_DLL, "dVertexRed");

		if (dxVertexRed == NULL)
		{
			cout << "Function dxVertexRed (\"dVertexRed\") not found in DLL!\n";
		}

		dxVertexGreen = (LPDVERTEXGREEN)GetProcAddress ((HMODULE)HW_DLL, "dVertexGreen");

		if (dxVertexGreen == NULL)
		{
			cout << "Function dxVertexGreen (\"dVertexGreen\") not found in DLL!\n";
		}

		dxVertexBlue = (LPDVERTEXBLUE)GetProcAddress ((HMODULE)HW_DLL, "dVertexBlue");

		if (dxVertexBlue == NULL)
		{
			cout << "Function dxVertexBlue (\"dVertexBlue\") not found in DLL!\n";
		}

		dxVertexAlpha = (LPDVERTEXALPHA)GetProcAddress ((HMODULE)HW_DLL, "dVertexAlpha");

		if (dxVertexAlpha == NULL)
		{
			cout << "Function dxVertexAlpha (\"dVertexAlpha\") not found in DLL!\n";
		}

		dxVertexTexCoords = (LPDVERTEXTEXCOORDS)GetProcAddress ((HMODULE)HW_DLL, "dVertexTexCoords");

		if (dxVertexTexCoords == NULL)
		{
			cout << "Function dxVertexTexCoords (\"dVertexTexCoords\") not found in DLL!\n";
		}

		dxVertexNormal = (LPDVERTEXNORMAL)GetProcAddress ((HMODULE)HW_DLL, "dVertexNormal");

		if (dxVertexNormal == NULL)
		{
			cout << "Function dxVertexNormal (\"dVertexNormal\") not found in DLL!\n";
		}

		dxVertexX = (LPDVERTEXX)GetProcAddress ((HMODULE)HW_DLL, "dVertexX");

		if (dxVertexX == NULL)
		{
			cout << "Function dxVertexX (\"dVertexX\") not found in DLL!\n";
		}

		dxVertexY = (LPDVERTEXY)GetProcAddress ((HMODULE)HW_DLL, "dVertexY");

		if (dxVertexY == NULL)
		{
			cout << "Function dxVertexY (\"dVertexY\") not found in DLL!\n";
		}

		dxVertexZ = (LPDVERTEXZ)GetProcAddress ((HMODULE)HW_DLL, "dVertexZ");

		if (dxVertexZ == NULL)
		{
			cout << "Function dxVertexZ (\"dVertexZ\") not found in DLL!\n";
		}

		dxVertexNX = (LPDVERTEXNX)GetProcAddress ((HMODULE)HW_DLL, "dVertexNX");

		if (dxVertexNX == NULL)
		{
			cout << "Function dxVertexNX (\"dVertexNX\") not found in DLL!\n";
		}

		dxVertexNY = (LPDVERTEXNY)GetProcAddress ((HMODULE)HW_DLL, "dVertexNY");

		if (dxVertexNY == NULL)
		{
			cout << "Function dxVertexNY (\"dVertexNY\") not found in DLL!\n";
		}

		dxVertexNZ = (LPDVERTEXNZ)GetProcAddress ((HMODULE)HW_DLL, "dVertexNZ");

		if (dxVertexNZ == NULL)
		{
			cout << "Function dxVertexNZ (\"dVertexNZ\") not found in DLL!\n";
		}

		dxVertexU = (LPDVERTEXU)GetProcAddress ((HMODULE)HW_DLL, "dVertexU");

		if (dxVertexU == NULL)
		{
			cout << "Function dxVertexU (\"dVertexU\") not found in DLL!\n";
		}

		dxVertexV = (LPDVERTEXV)GetProcAddress ((HMODULE)HW_DLL, "dVertexV");

		if (dxVertexV == NULL)
		{
			cout << "Function dxVertexV (\"dVertexV\") not found in DLL!\n";
		}

		dxVertexW = (LPDVERTEXW)GetProcAddress ((HMODULE)HW_DLL, "dVertexW");

		if (dxVertexW == NULL)
		{
			cout << "Function dxVertexW (\"dVertexW\") not found in DLL!\n";
		}

		dxCountSurfaces = (LPDCOUNTSURFACES)GetProcAddress ((HMODULE)HW_DLL, "dCountSurfaces");

		if (dxCountSurfaces == NULL)
		{
			cout << "Function dxCountSurfaces (\"dCountSurfaces\") not found in DLL!\n";
		}

		dxClearSurface = (LPDCLEARSURFACE)GetProcAddress ((HMODULE)HW_DLL, "dClearSurface");

		if (dxClearSurface == NULL)
		{
			cout << "Function dxClearSurface (\"dClearSurface\") not found in DLL!\n";
		}

		dxAddTriangle = (LPDADDTRIANGLE)GetProcAddress ((HMODULE)HW_DLL, "dAddTriangle");

		if (dxAddTriangle == NULL)
		{
			cout << "Function dxAddTriangle (\"dAddTriangle\") not found in DLL!\n";
		}

		dxCountTriangles = (LPDCOUNTTRIANGLES)GetProcAddress ((HMODULE)HW_DLL, "dCountTriangles");

		if (dxCountTriangles == NULL)
		{
			cout << "Function dxCountTriangles (\"dCountTriangles\") not found in DLL!\n";
		}

		dxTriangleVertex = (LPDTRIANGLEVERTEX)GetProcAddress ((HMODULE)HW_DLL, "dTriangleVertex");

		if (dxTriangleVertex == NULL)
		{
			cout << "Function dxTriangleVertex (\"dTriangleVertex\") not found in DLL!\n";
		}

		dxAmbientLight = (LPDAMBIENTLIGHT)GetProcAddress ((HMODULE)HW_DLL, "dAmbientLight");

		if (dxAmbientLight == NULL)
		{
			cout << "Function dxAmbientLight (\"dAmbientLight\") not found in DLL!\n";
		}

		dxCameraViewport = (LPDCAMERAVIEWPORT)GetProcAddress ((HMODULE)HW_DLL, "dCameraViewport");

		if (dxCameraViewport == NULL)
		{
			cout << "Function dxCameraViewport (\"dCameraViewport\") not found in DLL!\n";
		}

		dxCameraClsColor = (LPDCAMERACLSCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dCameraClsColor");

		if (dxCameraClsColor == NULL)
		{
			cout << "Function dxCameraClsColor (\"dCameraClsColor\") not found in DLL!\n";
		}

		dxCameraProjMode = (LPDCAMERAPROJMODE)GetProcAddress ((HMODULE)HW_DLL, "dCameraProjMode");

		if (dxCameraProjMode == NULL)
		{
			cout << "Function dxCameraProjMode (\"dCameraProjMode\") not found in DLL!\n";
		}

		dxCameraRange = (LPDCAMERARANGE)GetProcAddress ((HMODULE)HW_DLL, "dCameraRange");

		if (dxCameraRange == NULL)
		{
			cout << "Function dxCameraRange (\"dCameraRange\") not found in DLL!\n";
		}

		dxCameraClsMode = (LPDCAMERACLSMODE)GetProcAddress ((HMODULE)HW_DLL, "dCameraClsMode");

		if (dxCameraClsMode == NULL)
		{
			cout << "Function dxCameraClsMode (\"dCameraClsMode\") not found in DLL!\n";
		}

		dxCameraAspect = (LPDCAMERAASPECT)GetProcAddress ((HMODULE)HW_DLL, "dCameraAspect");

		if (dxCameraAspect == NULL)
		{
			cout << "Function dxCameraAspect (\"dCameraAspect\") not found in DLL!\n";
		}

		dxAutoCameraAspect = (LPDAUTOCAMERAASPECT)GetProcAddress ((HMODULE)HW_DLL, "dAutoCameraAspect");

		if (dxAutoCameraAspect == NULL)
		{
			cout << "Function dxAutoCameraAspect (\"dAutoCameraAspect\") not found in DLL!\n";
		}

		dxCameraFOV = (LPDCAMERAFOV)GetProcAddress ((HMODULE)HW_DLL, "dCameraFOV");

		if (dxCameraFOV == NULL)
		{
			cout << "Function dxCameraFOV (\"dCameraFOV\") not found in DLL!\n";
		}

		dxGetCameraFOV = (LPDGETCAMERAFOV)GetProcAddress ((HMODULE)HW_DLL, "dGetCameraFOV");

		if (dxGetCameraFOV == NULL)
		{
			cout << "Function dxGetCameraFOV (\"dGetCameraFOV\") not found in DLL!\n";
		}

		dxGetCameraAspect = (LPDGETCAMERAASPECT)GetProcAddress ((HMODULE)HW_DLL, "dGetCameraAspect");

		if (dxGetCameraAspect == NULL)
		{
			cout << "Function dxGetCameraAspect (\"dGetCameraAspect\") not found in DLL!\n";
		}

		dxCreateTorus = (LPDCREATETORUS)GetProcAddress ((HMODULE)HW_DLL, "dCreateTorus");

		if (dxCreateTorus == NULL)
		{
			cout << "Function dxCreateTorus (\"dCreateTorus\") not found in DLL!\n";
		}

		dxCreateCube = (LPDCREATECUBE)GetProcAddress ((HMODULE)HW_DLL, "dCreateCube");

		if (dxCreateCube == NULL)
		{
			cout << "Function dxCreateCube (\"dCreateCube\") not found in DLL!\n";
		}

		dxCreateCylinder = (LPDCREATECYLINDER)GetProcAddress ((HMODULE)HW_DLL, "dCreateCylinder");

		if (dxCreateCylinder == NULL)
		{
			cout << "Function dxCreateCylinder (\"dCreateCylinder\") not found in DLL!\n";
		}

		dxCreateSphere = (LPDCREATESPHERE)GetProcAddress ((HMODULE)HW_DLL, "dCreateSphere");

		if (dxCreateSphere == NULL)
		{
			cout << "Function dxCreateSphere (\"dCreateSphere\") not found in DLL!\n";
		}

		dxFreeEntity = (LPDFREEENTITY)GetProcAddress ((HMODULE)HW_DLL, "dFreeEntity");

		if (dxFreeEntity == NULL)
		{
			cout << "Function dxFreeEntity (\"dFreeEntity\") not found in DLL!\n";
		}

		dxEntityParent = (LPDENTITYPARENT)GetProcAddress ((HMODULE)HW_DLL, "dEntityParent");

		if (dxEntityParent == NULL)
		{
			cout << "Function dxEntityParent (\"dEntityParent\") not found in DLL!\n";
		}

		dxCountChildren = (LPDCOUNTCHILDREN)GetProcAddress ((HMODULE)HW_DLL, "dCountChildren");

		if (dxCountChildren == NULL)
		{
			cout << "Function dxCountChildren (\"dCountChildren\") not found in DLL!\n";
		}

		dxGetChild = (LPDGETCHILD)GetProcAddress ((HMODULE)HW_DLL, "dGetChild");

		if (dxGetChild == NULL)
		{
			cout << "Function dxGetChild (\"dGetChild\") not found in DLL!\n";
		}

		dxEntityClass = (LPDENTITYCLASS)GetProcAddress ((HMODULE)HW_DLL, "dEntityClass");

		if (dxEntityClass == NULL)
		{
			cout << "Function dxEntityClass (\"dEntityClass\") not found in DLL!\n";
		}

		dxGetParent = (LPDGETPARENT)GetProcAddress ((HMODULE)HW_DLL, "dGetParent");

		if (dxGetParent == NULL)
		{
			cout << "Function dxGetParent (\"dGetParent\") not found in DLL!\n";
		}

		dxNameEntity = (LPDNAMEENTITY)GetProcAddress ((HMODULE)HW_DLL, "dNameEntity");

		if (dxNameEntity == NULL)
		{
			cout << "Function dxNameEntity (\"dNameEntity\") not found in DLL!\n";
		}

		dxEntityName = (LPDENTITYNAME)GetProcAddress ((HMODULE)HW_DLL, "dEntityName");

		if (dxEntityName == NULL)
		{
			cout << "Function dxEntityName (\"dEntityName\") not found in DLL!\n";
		}

		dxEntityX = (LPDENTITYX)GetProcAddress ((HMODULE)HW_DLL, "dEntityX");

		if (dxEntityX == NULL)
		{
			cout << "Function dxEntityX (\"dEntityX\") not found in DLL!\n";
		}

		dxEntityY = (LPDENTITYY)GetProcAddress ((HMODULE)HW_DLL, "dEntityY");

		if (dxEntityY == NULL)
		{
			cout << "Function dxEntityY (\"dEntityY\") not found in DLL!\n";
		}

		dxEntityZ = (LPDENTITYZ)GetProcAddress ((HMODULE)HW_DLL, "dEntityZ");

		if (dxEntityZ == NULL)
		{
			cout << "Function dxEntityZ (\"dEntityZ\") not found in DLL!\n";
		}

		dxRotateEntity = (LPDROTATEENTITY)GetProcAddress ((HMODULE)HW_DLL, "dRotateEntity");

		if (dxRotateEntity == NULL)
		{
			cout << "Function dxRotateEntity (\"dRotateEntity\") not found in DLL!\n";
		}

		dxGetMatElement = (LPDGETMATELEMENT)GetProcAddress ((HMODULE)HW_DLL, "dGetMatElement");

		if (dxGetMatElement == NULL)
		{
			cout << "Function dxGetMatElement (\"dGetMatElement\") not found in DLL!\n";
		}

		dxUpdateNormals = (LPDUPDATENORMALS)GetProcAddress ((HMODULE)HW_DLL, "dUpdateNormals");

		if (dxUpdateNormals == NULL)
		{
			cout << "Function dxUpdateNormals (\"dUpdateNormals\") not found in DLL!\n";
		}

		dxCreateTexture = (LPDCREATETEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dCreateTexture");

		if (dxCreateTexture == NULL)
		{
			cout << "Function dxCreateTexture (\"dCreateTexture\") not found in DLL!\n";
		}

		dxTurnEntity = (LPDTURNENTITY)GetProcAddress ((HMODULE)HW_DLL, "dTurnEntity");

		if (dxTurnEntity == NULL)
		{
			cout << "Function dxTurnEntity (\"dTurnEntity\") not found in DLL!\n";
		}

		dxMoveEntity = (LPDMOVEENTITY)GetProcAddress ((HMODULE)HW_DLL, "dMoveEntity");

		if (dxMoveEntity == NULL)
		{
			cout << "Function dxMoveEntity (\"dMoveEntity\") not found in DLL!\n";
		}

		dxTranslateEntity = (LPDTRANSLATEENTITY)GetProcAddress ((HMODULE)HW_DLL, "dTranslateEntity");

		if (dxTranslateEntity == NULL)
		{
			cout << "Function dxTranslateEntity (\"dTranslateEntity\") not found in DLL!\n";
		}

		dxEntityRed = (LPDENTITYRED)GetProcAddress ((HMODULE)HW_DLL, "dEntityRed");

		if (dxEntityRed == NULL)
		{
			cout << "Function dxEntityRed (\"dEntityRed\") not found in DLL!\n";
		}

		dxEntityGreen = (LPDENTITYGREEN)GetProcAddress ((HMODULE)HW_DLL, "dEntityGreen");

		if (dxEntityGreen == NULL)
		{
			cout << "Function dxEntityGreen (\"dEntityGreen\") not found in DLL!\n";
		}

		dxEntityBlue = (LPDENTITYBLUE)GetProcAddress ((HMODULE)HW_DLL, "dEntityBlue");

		if (dxEntityBlue == NULL)
		{
			cout << "Function dxEntityBlue (\"dEntityBlue\") not found in DLL!\n";
		}

		dxEntityColor = (LPDENTITYCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dEntityColor");

		if (dxEntityColor == NULL)
		{
			cout << "Function dxEntityColor (\"dEntityColor\") not found in DLL!\n";
		}

		dxEntityFX = (LPDENTITYFX)GetProcAddress ((HMODULE)HW_DLL, "dEntityFX");

		if (dxEntityFX == NULL)
		{
			cout << "Function dxEntityFX (\"dEntityFX\") not found in DLL!\n";
		}

		dxGetEntityFX = (LPDGETENTITYFX)GetProcAddress ((HMODULE)HW_DLL, "dGetEntityFX");

		if (dxGetEntityFX == NULL)
		{
			cout << "Function dxGetEntityFX (\"dGetEntityFX\") not found in DLL!\n";
		}

		dxDither = (LPDDITHER)GetProcAddress ((HMODULE)HW_DLL, "dDither");

		if (dxDither == NULL)
		{
			cout << "Function dxDither (\"dDither\") not found in DLL!\n";
		}

		dxCameraFogMode = (LPDCAMERAFOGMODE)GetProcAddress ((HMODULE)HW_DLL, "dCameraFogMode");

		if (dxCameraFogMode == NULL)
		{
			cout << "Function dxCameraFogMode (\"dCameraFogMode\") not found in DLL!\n";
		}

		dxCameraFogColor = (LPDCAMERAFOGCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dCameraFogColor");

		if (dxCameraFogColor == NULL)
		{
			cout << "Function dxCameraFogColor (\"dCameraFogColor\") not found in DLL!\n";
		}

		dxCameraFogRange = (LPDCAMERAFOGRANGE)GetProcAddress ((HMODULE)HW_DLL, "dCameraFogRange");

		if (dxCameraFogRange == NULL)
		{
			cout << "Function dxCameraFogRange (\"dCameraFogRange\") not found in DLL!\n";
		}

		dxLoadTexture = (LPDLOADTEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dLoadTexture");

		if (dxLoadTexture == NULL)
		{
			cout << "Function dxLoadTexture (\"dLoadTexture\") not found in DLL!\n";
		}

		dxEntityTexture = (LPDENTITYTEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dEntityTexture");

		if (dxEntityTexture == NULL)
		{
			cout << "Function dxEntityTexture (\"dEntityTexture\") not found in DLL!\n";
		}

		dxCountGfxModes3D = (LPDCOUNTGFXMODES3D)GetProcAddress ((HMODULE)HW_DLL, "dCountGfxModes3D");

		if (dxCountGfxModes3D == NULL)
		{
			cout << "Function dxCountGfxModes3D (\"dCountGfxModes3D\") not found in DLL!\n";
		}

		dxGfxModeWidth = (LPDGFXMODEWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dGfxModeWidth");

		if (dxGfxModeWidth == NULL)
		{
			cout << "Function dxGfxModeWidth (\"dGfxModeWidth\") not found in DLL!\n";
		}

		dxGfxModeHeight = (LPDGFXMODEHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dGfxModeHeight");

		if (dxGfxModeHeight == NULL)
		{
			cout << "Function dxGfxModeHeight (\"dGfxModeHeight\") not found in DLL!\n";
		}

		dxGfxModeDepth = (LPDGFXMODEDEPTH)GetProcAddress ((HMODULE)HW_DLL, "dGfxModeDepth");

		if (dxGfxModeDepth == NULL)
		{
			cout << "Function dxGfxModeDepth (\"dGfxModeDepth\") not found in DLL!\n";
		}

		dxGfxModeRefreshRate = (LPDGFXMODEREFRESHRATE)GetProcAddress ((HMODULE)HW_DLL, "dGfxModeRefreshRate");

		if (dxGfxModeRefreshRate == NULL)
		{
			cout << "Function dxGfxModeRefreshRate (\"dGfxModeRefreshRate\") not found in DLL!\n";
		}

		dxWireframe = (LPDWIREFRAME)GetProcAddress ((HMODULE)HW_DLL, "dWireframe");

		if (dxWireframe == NULL)
		{
			cout << "Function dxWireframe (\"dWireframe\") not found in DLL!\n";
		}

		dxEntityWireframe = (LPDENTITYWIREFRAME)GetProcAddress ((HMODULE)HW_DLL, "dEntityWireframe");

		if (dxEntityWireframe == NULL)
		{
			cout << "Function dxEntityWireframe (\"dEntityWireframe\") not found in DLL!\n";
		}

		dxPointframe = (LPDPOINTFRAME)GetProcAddress ((HMODULE)HW_DLL, "dPointframe");

		if (dxPointframe == NULL)
		{
			cout << "Function dxPointframe (\"dPointframe\") not found in DLL!\n";
		}

		dxEntityPointframe = (LPDENTITYPOINTFRAME)GetProcAddress ((HMODULE)HW_DLL, "dEntityPointframe");

		if (dxEntityPointframe == NULL)
		{
			cout << "Function dxEntityPointframe (\"dEntityPointframe\") not found in DLL!\n";
		}

		dxScaleEntity = (LPDSCALEENTITY)GetProcAddress ((HMODULE)HW_DLL, "dScaleEntity");

		if (dxScaleEntity == NULL)
		{
			cout << "Function dxScaleEntity (\"dScaleEntity\") not found in DLL!\n";
		}

		dxEntityScaleX = (LPDENTITYSCALEX)GetProcAddress ((HMODULE)HW_DLL, "dEntityScaleX");

		if (dxEntityScaleX == NULL)
		{
			cout << "Function dxEntityScaleX (\"dEntityScaleX\") not found in DLL!\n";
		}

		dxEntityScaleY = (LPDENTITYSCALEY)GetProcAddress ((HMODULE)HW_DLL, "dEntityScaleY");

		if (dxEntityScaleY == NULL)
		{
			cout << "Function dxEntityScaleY (\"dEntityScaleY\") not found in DLL!\n";
		}

		dxEntityScaleZ = (LPDENTITYSCALEZ)GetProcAddress ((HMODULE)HW_DLL, "dEntityScaleZ");

		if (dxEntityScaleZ == NULL)
		{
			cout << "Function dxEntityScaleZ (\"dEntityScaleZ\") not found in DLL!\n";
		}

		dxCreateLight = (LPDCREATELIGHT)GetProcAddress ((HMODULE)HW_DLL, "dCreateLight");

		if (dxCreateLight == NULL)
		{
			cout << "Function dxCreateLight (\"dCreateLight\") not found in DLL!\n";
		}

		dxColorRed = (LPDCOLORRED)GetProcAddress ((HMODULE)HW_DLL, "dColorRed");

		if (dxColorRed == NULL)
		{
			cout << "Function dxColorRed (\"dColorRed\") not found in DLL!\n";
		}

		dxColorGreen = (LPDCOLORGREEN)GetProcAddress ((HMODULE)HW_DLL, "dColorGreen");

		if (dxColorGreen == NULL)
		{
			cout << "Function dxColorGreen (\"dColorGreen\") not found in DLL!\n";
		}

		dxColorBlue = (LPDCOLORBLUE)GetProcAddress ((HMODULE)HW_DLL, "dColorBlue");

		if (dxColorBlue == NULL)
		{
			cout << "Function dxColorBlue (\"dColorBlue\") not found in DLL!\n";
		}

		dxGraphicsBuffer = (LPDGRAPHICSBUFFER)GetProcAddress ((HMODULE)HW_DLL, "dGraphicsBuffer");

		if (dxGraphicsBuffer == NULL)
		{
			cout << "Function dxGraphicsBuffer (\"dGraphicsBuffer\") not found in DLL!\n";
		}

		dxSetBuffer = (LPDSETBUFFER)GetProcAddress ((HMODULE)HW_DLL, "dSetBuffer");

		if (dxSetBuffer == NULL)
		{
			cout << "Function dxSetBuffer (\"dSetBuffer\") not found in DLL!\n";
		}

		dxCreateText = (LPDCREATETEXT)GetProcAddress ((HMODULE)HW_DLL, "dCreateText");

		if (dxCreateText == NULL)
		{
			cout << "Function dxCreateText (\"dCreateText\") not found in DLL!\n";
		}

		dx3DFont = (LPD3DFONT)GetProcAddress ((HMODULE)HW_DLL, "d3DFont");

		if (dx3DFont == NULL)
		{
			cout << "Function dx3DFont (\"d3DFont\") not found in DLL!\n";
		}

		dxRect = (LPDRECT)GetProcAddress ((HMODULE)HW_DLL, "dRect");

		if (dxRect == NULL)
		{
			cout << "Function dxRect (\"dRect\") not found in DLL!\n";
		}

		dxTextureBuffer = (LPDTEXTUREBUFFER)GetProcAddress ((HMODULE)HW_DLL, "dTextureBuffer");

		if (dxTextureBuffer == NULL)
		{
			cout << "Function dxTextureBuffer (\"dTextureBuffer\") not found in DLL!\n";
		}

		dxGraphicsWidth = (LPDGRAPHICSWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dGraphicsWidth");

		if (dxGraphicsWidth == NULL)
		{
			cout << "Function dxGraphicsWidth (\"dGraphicsWidth\") not found in DLL!\n";
		}

		dxGraphicsHeight = (LPDGRAPHICSHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dGraphicsHeight");

		if (dxGraphicsHeight == NULL)
		{
			cout << "Function dxGraphicsHeight (\"dGraphicsHeight\") not found in DLL!\n";
		}

		dxGraphicsDepth = (LPDGRAPHICSDEPTH)GetProcAddress ((HMODULE)HW_DLL, "dGraphicsDepth");

		if (dxGraphicsDepth == NULL)
		{
			cout << "Function dxGraphicsDepth (\"dGraphicsDepth\") not found in DLL!\n";
		}

		dxGetColor = (LPDGETCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dGetColor");

		if (dxGetColor == NULL)
		{
			cout << "Function dxGetColor (\"dGetColor\") not found in DLL!\n";
		}

		dxReadPixel = (LPDREADPIXEL)GetProcAddress ((HMODULE)HW_DLL, "dReadPixel");

		if (dxReadPixel == NULL)
		{
			cout << "Function dxReadPixel (\"dReadPixel\") not found in DLL!\n";
		}

		dxLightColor = (LPDLIGHTCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dLightColor");

		if (dxLightColor == NULL)
		{
			cout << "Function dxLightColor (\"dLightColor\") not found in DLL!\n";
		}

		dxLightRange = (LPDLIGHTRANGE)GetProcAddress ((HMODULE)HW_DLL, "dLightRange");

		if (dxLightRange == NULL)
		{
			cout << "Function dxLightRange (\"dLightRange\") not found in DLL!\n";
		}

		dxLightConeAngles = (LPDLIGHTCONEANGLES)GetProcAddress ((HMODULE)HW_DLL, "dLightConeAngles");

		if (dxLightConeAngles == NULL)
		{
			cout << "Function dxLightConeAngles (\"dLightConeAngles\") not found in DLL!\n";
		}

		dxHideEntity = (LPDHIDEENTITY)GetProcAddress ((HMODULE)HW_DLL, "dHideEntity");

		if (dxHideEntity == NULL)
		{
			cout << "Function dxHideEntity (\"dHideEntity\") not found in DLL!\n";
		}

		dxShowEntity = (LPDSHOWENTITY)GetProcAddress ((HMODULE)HW_DLL, "dShowEntity");

		if (dxShowEntity == NULL)
		{
			cout << "Function dxShowEntity (\"dShowEntity\") not found in DLL!\n";
		}

		dxEntityOrder = (LPDENTITYORDER)GetProcAddress ((HMODULE)HW_DLL, "dEntityOrder");

		if (dxEntityOrder == NULL)
		{
			cout << "Function dxEntityOrder (\"dEntityOrder\") not found in DLL!\n";
		}

		dxOval = (LPDOVAL)GetProcAddress ((HMODULE)HW_DLL, "dOval");

		if (dxOval == NULL)
		{
			cout << "Function dxOval (\"dOval\") not found in DLL!\n";
		}

		dxLine = (LPDLINE)GetProcAddress ((HMODULE)HW_DLL, "dLine");

		if (dxLine == NULL)
		{
			cout << "Function dxLine (\"dLine\") not found in DLL!\n";
		}

		dxText = (LPDTEXT)GetProcAddress ((HMODULE)HW_DLL, "dText");

		if (dxText == NULL)
		{
			cout << "Function dxText (\"dText\") not found in DLL!\n";
		}

		dxSetFont = (LPDSETFONT)GetProcAddress ((HMODULE)HW_DLL, "dSetFont");

		if (dxSetFont == NULL)
		{
			cout << "Function dxSetFont (\"dSetFont\") not found in DLL!\n";
		}

		dxFreeFont = (LPDFREEFONT)GetProcAddress ((HMODULE)HW_DLL, "dFreeFont");

		if (dxFreeFont == NULL)
		{
			cout << "Function dxFreeFont (\"dFreeFont\") not found in DLL!\n";
		}

		dxUpdateSurfaceNormals = (LPDUPDATESURFACENORMALS)GetProcAddress ((HMODULE)HW_DLL, "dUpdateSurfaceNormals");

		if (dxUpdateSurfaceNormals == NULL)
		{
			cout << "Function dxUpdateSurfaceNormals (\"dUpdateSurfaceNormals\") not found in DLL!\n";
		}

		dxWBuffer = (LPDWBUFFER)GetProcAddress ((HMODULE)HW_DLL, "dWBuffer");

		if (dxWBuffer == NULL)
		{
			cout << "Function dxWBuffer (\"dWBuffer\") not found in DLL!\n";
		}

		dxPixelShaderVersion = (LPDPIXELSHADERVERSION)GetProcAddress ((HMODULE)HW_DLL, "dPixelShaderVersion");

		if (dxPixelShaderVersion == NULL)
		{
			cout << "Function dxPixelShaderVersion (\"dPixelShaderVersion\") not found in DLL!\n";
		}

		dxVertexShaderVersion = (LPDVERTEXSHADERVERSION)GetProcAddress ((HMODULE)HW_DLL, "dVertexShaderVersion");

		if (dxVertexShaderVersion == NULL)
		{
			cout << "Function dxVertexShaderVersion (\"dVertexShaderVersion\") not found in DLL!\n";
		}

		dxCreatePixelShader = (LPDCREATEPIXELSHADER)GetProcAddress ((HMODULE)HW_DLL, "dCreatePixelShader");

		if (dxCreatePixelShader == NULL)
		{
			cout << "Function dxCreatePixelShader (\"dCreatePixelShader\") not found in DLL!\n";
		}

		dxFreePixelShader = (LPDFREEPIXELSHADER)GetProcAddress ((HMODULE)HW_DLL, "dFreePixelShader");

		if (dxFreePixelShader == NULL)
		{
			cout << "Function dxFreePixelShader (\"dFreePixelShader\") not found in DLL!\n";
		}

		dxCreateVertexShader = (LPDCREATEVERTEXSHADER)GetProcAddress ((HMODULE)HW_DLL, "dCreateVertexShader");

		if (dxCreateVertexShader == NULL)
		{
			cout << "Function dxCreateVertexShader (\"dCreateVertexShader\") not found in DLL!\n";
		}

		dxFreeVertexShader = (LPDFREEVERTEXSHADER)GetProcAddress ((HMODULE)HW_DLL, "dFreeVertexShader");

		if (dxFreeVertexShader == NULL)
		{
			cout << "Function dxFreeVertexShader (\"dFreeVertexShader\") not found in DLL!\n";
		}

		dxEntityPixelShader = (LPDENTITYPIXELSHADER)GetProcAddress ((HMODULE)HW_DLL, "dEntityPixelShader");

		if (dxEntityPixelShader == NULL)
		{
			cout << "Function dxEntityPixelShader (\"dEntityPixelShader\") not found in DLL!\n";
		}

		dxEntityVertexShader = (LPDENTITYVERTEXSHADER)GetProcAddress ((HMODULE)HW_DLL, "dEntityVertexShader");

		if (dxEntityVertexShader == NULL)
		{
			cout << "Function dxEntityVertexShader (\"dEntityVertexShader\") not found in DLL!\n";
		}

		dxGetLastShaderError = (LPDGETLASTSHADERERROR)GetProcAddress ((HMODULE)HW_DLL, "dGetLastShaderError");

		if (dxGetLastShaderError == NULL)
		{
			cout << "Function dxGetLastShaderError (\"dGetLastShaderError\") not found in DLL!\n";
		}

		dxVertexCoords = (LPDVERTEXCOORDS)GetProcAddress ((HMODULE)HW_DLL, "dVertexCoords");

		if (dxVertexCoords == NULL)
		{
			cout << "Function dxVertexCoords (\"dVertexCoords\") not found in DLL!\n";
		}

		dxFlipMesh = (LPDFLIPMESH)GetProcAddress ((HMODULE)HW_DLL, "dFlipMesh");

		if (dxFlipMesh == NULL)
		{
			cout << "Function dxFlipMesh (\"dFlipMesh\") not found in DLL!\n";
		}

		dxApptitle = (LPDAPPTITLE)GetProcAddress ((HMODULE)HW_DLL, "dApptitle");

		if (dxApptitle == NULL)
		{
			cout << "Function dxApptitle (\"dApptitle\") not found in DLL!\n";
		}

		dxCountEntities = (LPDCOUNTENTITIES)GetProcAddress ((HMODULE)HW_DLL, "dCountEntities");

		if (dxCountEntities == NULL)
		{
			cout << "Function dxCountEntities (\"dCountEntities\") not found in DLL!\n";
		}

		dxGetSurface = (LPDGETSURFACE)GetProcAddress ((HMODULE)HW_DLL, "dGetSurface");

		if (dxGetSurface == NULL)
		{
			cout << "Function dxGetSurface (\"dGetSurface\") not found in DLL!\n";
		}

		dxFirstEntity = (LPDFIRSTENTITY)GetProcAddress ((HMODULE)HW_DLL, "dFirstEntity");

		if (dxFirstEntity == NULL)
		{
			cout << "Function dxFirstEntity (\"dFirstEntity\") not found in DLL!\n";
		}

		dxNextEntity = (LPDNEXTENTITY)GetProcAddress ((HMODULE)HW_DLL, "dNextEntity");

		if (dxNextEntity == NULL)
		{
			cout << "Function dxNextEntity (\"dNextEntity\") not found in DLL!\n";
		}

		dxPreviousEntity = (LPDPREVIOUSENTITY)GetProcAddress ((HMODULE)HW_DLL, "dPreviousEntity");

		if (dxPreviousEntity == NULL)
		{
			cout << "Function dxPreviousEntity (\"dPreviousEntity\") not found in DLL!\n";
		}

		dxEntityBlend = (LPDENTITYBLEND)GetProcAddress ((HMODULE)HW_DLL, "dEntityBlend");

		if (dxEntityBlend == NULL)
		{
			cout << "Function dxEntityBlend (\"dEntityBlend\") not found in DLL!\n";
		}

		dxCopyEntity = (LPDCOPYENTITY)GetProcAddress ((HMODULE)HW_DLL, "dCopyEntity");

		if (dxCopyEntity == NULL)
		{
			cout << "Function dxCopyEntity (\"dCopyEntity\") not found in DLL!\n";
		}

		dxFreeSurface = (LPDFREESURFACE)GetProcAddress ((HMODULE)HW_DLL, "dFreeSurface");

		if (dxFreeSurface == NULL)
		{
			cout << "Function dxFreeSurface (\"dFreeSurface\") not found in DLL!\n";
		}

		dxTextureBlend = (LPDTEXTUREBLEND)GetProcAddress ((HMODULE)HW_DLL, "dTextureBlend");

		if (dxTextureBlend == NULL)
		{
			cout << "Function dxTextureBlend (\"dTextureBlend\") not found in DLL!\n";
		}

		dxGetVersion = (LPDGETVERSION)GetProcAddress ((HMODULE)HW_DLL, "dGetVersion");

		if (dxGetVersion == NULL)
		{
			cout << "Function dxGetVersion (\"dGetVersion\") not found in DLL!\n";
		}

		dxStringWidth = (LPDSTRINGWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dStringWidth");

		if (dxStringWidth == NULL)
		{
			cout << "Function dxStringWidth (\"dStringWidth\") not found in DLL!\n";
		}

		dxStringHeight = (LPDSTRINGHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dStringHeight");

		if (dxStringHeight == NULL)
		{
			cout << "Function dxStringHeight (\"dStringHeight\") not found in DLL!\n";
		}

		dxCreateBrush = (LPDCREATEBRUSH)GetProcAddress ((HMODULE)HW_DLL, "dCreateBrush");

		if (dxCreateBrush == NULL)
		{
			cout << "Function dxCreateBrush (\"dCreateBrush\") not found in DLL!\n";
		}

		dxFreeBrush = (LPDFREEBRUSH)GetProcAddress ((HMODULE)HW_DLL, "dFreeBrush");

		if (dxFreeBrush == NULL)
		{
			cout << "Function dxFreeBrush (\"dFreeBrush\") not found in DLL!\n";
		}

		dxBrushColor = (LPDBRUSHCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dBrushColor");

		if (dxBrushColor == NULL)
		{
			cout << "Function dxBrushColor (\"dBrushColor\") not found in DLL!\n";
		}

		dxBrushAlpha = (LPDBRUSHALPHA)GetProcAddress ((HMODULE)HW_DLL, "dBrushAlpha");

		if (dxBrushAlpha == NULL)
		{
			cout << "Function dxBrushAlpha (\"dBrushAlpha\") not found in DLL!\n";
		}

		dxBrushShininess = (LPDBRUSHSHININESS)GetProcAddress ((HMODULE)HW_DLL, "dBrushShininess");

		if (dxBrushShininess == NULL)
		{
			cout << "Function dxBrushShininess (\"dBrushShininess\") not found in DLL!\n";
		}

		dxBrushFX = (LPDBRUSHFX)GetProcAddress ((HMODULE)HW_DLL, "dBrushFX");

		if (dxBrushFX == NULL)
		{
			cout << "Function dxBrushFX (\"dBrushFX\") not found in DLL!\n";
		}

		dxBrushTexture = (LPDBRUSHTEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dBrushTexture");

		if (dxBrushTexture == NULL)
		{
			cout << "Function dxBrushTexture (\"dBrushTexture\") not found in DLL!\n";
		}

		dxBrushBlend = (LPDBRUSHBLEND)GetProcAddress ((HMODULE)HW_DLL, "dBrushBlend");

		if (dxBrushBlend == NULL)
		{
			cout << "Function dxBrushBlend (\"dBrushBlend\") not found in DLL!\n";
		}

		dxGetEntityBrush = (LPDGETENTITYBRUSH)GetProcAddress ((HMODULE)HW_DLL, "dGetEntityBrush");

		if (dxGetEntityBrush == NULL)
		{
			cout << "Function dxGetEntityBrush (\"dGetEntityBrush\") not found in DLL!\n";
		}

		dxNameTexture = (LPDNAMETEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dNameTexture");

		if (dxNameTexture == NULL)
		{
			cout << "Function dxNameTexture (\"dNameTexture\") not found in DLL!\n";
		}

		dxTextureName = (LPDTEXTURENAME)GetProcAddress ((HMODULE)HW_DLL, "dTextureName");

		if (dxTextureName == NULL)
		{
			cout << "Function dxTextureName (\"dTextureName\") not found in DLL!\n";
		}

		dxTextureCoords = (LPDTEXTURECOORDS)GetProcAddress ((HMODULE)HW_DLL, "dTextureCoords");

		if (dxTextureCoords == NULL)
		{
			cout << "Function dxTextureCoords (\"dTextureCoords\") not found in DLL!\n";
		}

		dxTextureWidth = (LPDTEXTUREWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dTextureWidth");

		if (dxTextureWidth == NULL)
		{
			cout << "Function dxTextureWidth (\"dTextureWidth\") not found in DLL!\n";
		}

		dxTextureHeight = (LPDTEXTUREHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dTextureHeight");

		if (dxTextureHeight == NULL)
		{
			cout << "Function dxTextureHeight (\"dTextureHeight\") not found in DLL!\n";
		}

		dxGetDebugFloat = (LPDGETDEBUGFLOAT)GetProcAddress ((HMODULE)HW_DLL, "dGetDebugFloat");

		if (dxGetDebugFloat == NULL)
		{
			cout << "Function dxGetDebugFloat (\"dGetDebugFloat\") not found in DLL!\n";
		}

		dxScaleTexture = (LPDSCALETEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dScaleTexture");

		if (dxScaleTexture == NULL)
		{
			cout << "Function dxScaleTexture (\"dScaleTexture\") not found in DLL!\n";
		}

		dxPositionTexture = (LPDPOSITIONTEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dPositionTexture");

		if (dxPositionTexture == NULL)
		{
			cout << "Function dxPositionTexture (\"dPositionTexture\") not found in DLL!\n";
		}

		dxRotateTexture = (LPDROTATETEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dRotateTexture");

		if (dxRotateTexture == NULL)
		{
			cout << "Function dxRotateTexture (\"dRotateTexture\") not found in DLL!\n";
		}

		dxEntityAlpha = (LPDENTITYALPHA)GetProcAddress ((HMODULE)HW_DLL, "dEntityAlpha");

		if (dxEntityAlpha == NULL)
		{
			cout << "Function dxEntityAlpha (\"dEntityAlpha\") not found in DLL!\n";
		}

		dxGetEntityAlpha = (LPDGETENTITYALPHA)GetProcAddress ((HMODULE)HW_DLL, "dGetEntityAlpha");

		if (dxGetEntityAlpha == NULL)
		{
			cout << "Function dxGetEntityAlpha (\"dGetEntityAlpha\") not found in DLL!\n";
		}

		dxPositionMesh = (LPDPOSITIONMESH)GetProcAddress ((HMODULE)HW_DLL, "dPositionMesh");

		if (dxPositionMesh == NULL)
		{
			cout << "Function dxPositionMesh (\"dPositionMesh\") not found in DLL!\n";
		}

		dxMeshWidth = (LPDMESHWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dMeshWidth");

		if (dxMeshWidth == NULL)
		{
			cout << "Function dxMeshWidth (\"dMeshWidth\") not found in DLL!\n";
		}

		dxMeshHeight = (LPDMESHHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dMeshHeight");

		if (dxMeshHeight == NULL)
		{
			cout << "Function dxMeshHeight (\"dMeshHeight\") not found in DLL!\n";
		}

		dxMeshDepth = (LPDMESHDEPTH)GetProcAddress ((HMODULE)HW_DLL, "dMeshDepth");

		if (dxMeshDepth == NULL)
		{
			cout << "Function dxMeshDepth (\"dMeshDepth\") not found in DLL!\n";
		}

		dxEntityPitch = (LPDENTITYPITCH)GetProcAddress ((HMODULE)HW_DLL, "dEntityPitch");

		if (dxEntityPitch == NULL)
		{
			cout << "Function dxEntityPitch (\"dEntityPitch\") not found in DLL!\n";
		}

		dxEntityYaw = (LPDENTITYYAW)GetProcAddress ((HMODULE)HW_DLL, "dEntityYaw");

		if (dxEntityYaw == NULL)
		{
			cout << "Function dxEntityYaw (\"dEntityYaw\") not found in DLL!\n";
		}

		dxEntityRoll = (LPDENTITYROLL)GetProcAddress ((HMODULE)HW_DLL, "dEntityRoll");

		if (dxEntityRoll == NULL)
		{
			cout << "Function dxEntityRoll (\"dEntityRoll\") not found in DLL!\n";
		}

		dxFreeSurfaceAttribs = (LPDFREESURFACEATTRIBS)GetProcAddress ((HMODULE)HW_DLL, "dFreeSurfaceAttribs");

		if (dxFreeSurfaceAttribs == NULL)
		{
			cout << "Function dxFreeSurfaceAttribs (\"dFreeSurfaceAttribs\") not found in DLL!\n";
		}

		dxSurfaceFx = (LPDSURFACEFX)GetProcAddress ((HMODULE)HW_DLL, "dSurfaceFx");

		if (dxSurfaceFx == NULL)
		{
			cout << "Function dxSurfaceFx (\"dSurfaceFx\") not found in DLL!\n";
		}

		dxSurfaceBlend = (LPDSURFACEBLEND)GetProcAddress ((HMODULE)HW_DLL, "dSurfaceBlend");

		if (dxSurfaceBlend == NULL)
		{
			cout << "Function dxSurfaceBlend (\"dSurfaceBlend\") not found in DLL!\n";
		}

		dxSurfaceAlpha = (LPDSURFACEALPHA)GetProcAddress ((HMODULE)HW_DLL, "dSurfaceAlpha");

		if (dxSurfaceAlpha == NULL)
		{
			cout << "Function dxSurfaceAlpha (\"dSurfaceAlpha\") not found in DLL!\n";
		}

		dxSurfaceWireframe = (LPDSURFACEWIREFRAME)GetProcAddress ((HMODULE)HW_DLL, "dSurfaceWireframe");

		if (dxSurfaceWireframe == NULL)
		{
			cout << "Function dxSurfaceWireframe (\"dSurfaceWireframe\") not found in DLL!\n";
		}

		dxSurfacePointframe = (LPDSURFACEPOINTFRAME)GetProcAddress ((HMODULE)HW_DLL, "dSurfacePointframe");

		if (dxSurfacePointframe == NULL)
		{
			cout << "Function dxSurfacePointframe (\"dSurfacePointframe\") not found in DLL!\n";
		}

		dxSurfacePixelShader = (LPDSURFACEPIXELSHADER)GetProcAddress ((HMODULE)HW_DLL, "dSurfacePixelShader");

		if (dxSurfacePixelShader == NULL)
		{
			cout << "Function dxSurfacePixelShader (\"dSurfacePixelShader\") not found in DLL!\n";
		}

		dxSurfaceVertexShader = (LPDSURFACEVERTEXSHADER)GetProcAddress ((HMODULE)HW_DLL, "dSurfaceVertexShader");

		if (dxSurfaceVertexShader == NULL)
		{
			cout << "Function dxSurfaceVertexShader (\"dSurfaceVertexShader\") not found in DLL!\n";
		}

		dxSurfaceColor = (LPDSURFACECOLOR)GetProcAddress ((HMODULE)HW_DLL, "dSurfaceColor");

		if (dxSurfaceColor == NULL)
		{
			cout << "Function dxSurfaceColor (\"dSurfaceColor\") not found in DLL!\n";
		}

		dxGetSurfaceBrush = (LPDGETSURFACEBRUSH)GetProcAddress ((HMODULE)HW_DLL, "dGetSurfaceBrush");

		if (dxGetSurfaceBrush == NULL)
		{
			cout << "Function dxGetSurfaceBrush (\"dGetSurfaceBrush\") not found in DLL!\n";
		}

		dxPaintEntity = (LPDPAINTENTITY)GetProcAddress ((HMODULE)HW_DLL, "dPaintEntity");

		if (dxPaintEntity == NULL)
		{
			cout << "Function dxPaintEntity (\"dPaintEntity\") not found in DLL!\n";
		}

		dxPaintSurface = (LPDPAINTSURFACE)GetProcAddress ((HMODULE)HW_DLL, "dPaintSurface");

		if (dxPaintSurface == NULL)
		{
			cout << "Function dxPaintSurface (\"dPaintSurface\") not found in DLL!\n";
		}

		dxSurfaceTexture = (LPDSURFACETEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dSurfaceTexture");

		if (dxSurfaceTexture == NULL)
		{
			cout << "Function dxSurfaceTexture (\"dSurfaceTexture\") not found in DLL!\n";
		}

		dxWritePixel = (LPDWRITEPIXEL)GetProcAddress ((HMODULE)HW_DLL, "dWritePixel");

		if (dxWritePixel == NULL)
		{
			cout << "Function dxWritePixel (\"dWritePixel\") not found in DLL!\n";
		}

		dxLockBuffer = (LPDLOCKBUFFER)GetProcAddress ((HMODULE)HW_DLL, "dLockBuffer");

		if (dxLockBuffer == NULL)
		{
			cout << "Function dxLockBuffer (\"dLockBuffer\") not found in DLL!\n";
		}

		dxUnLockBuffer = (LPDUNLOCKBUFFER)GetProcAddress ((HMODULE)HW_DLL, "dUnLockBuffer");

		if (dxUnLockBuffer == NULL)
		{
			cout << "Function dxUnLockBuffer (\"dUnLockBuffer\") not found in DLL!\n";
		}

		dxWritePixelFast = (LPDWRITEPIXELFAST)GetProcAddress ((HMODULE)HW_DLL, "dWritePixelFast");

		if (dxWritePixelFast == NULL)
		{
			cout << "Function dxWritePixelFast (\"dWritePixelFast\") not found in DLL!\n";
		}

		dxReadPixelFast = (LPDREADPIXELFAST)GetProcAddress ((HMODULE)HW_DLL, "dReadPixelFast");

		if (dxReadPixelFast == NULL)
		{
			cout << "Function dxReadPixelFast (\"dReadPixelFast\") not found in DLL!\n";
		}

		dxTextureSave = (LPDTEXTURESAVE)GetProcAddress ((HMODULE)HW_DLL, "dTextureSave");

		if (dxTextureSave == NULL)
		{
			cout << "Function dxTextureSave (\"dTextureSave\") not found in DLL!\n";
		}

		dxCopySurface = (LPDCOPYSURFACE)GetProcAddress ((HMODULE)HW_DLL, "dCopySurface");

		if (dxCopySurface == NULL)
		{
			cout << "Function dxCopySurface (\"dCopySurface\") not found in DLL!\n";
		}

		dxCopyMesh = (LPDCOPYMESH)GetProcAddress ((HMODULE)HW_DLL, "dCopyMesh");

		if (dxCopyMesh == NULL)
		{
			cout << "Function dxCopyMesh (\"dCopyMesh\") not found in DLL!\n";
		}

		dxCreateImage = (LPDCREATEIMAGE)GetProcAddress ((HMODULE)HW_DLL, "dCreateImage");

		if (dxCreateImage == NULL)
		{
			cout << "Function dxCreateImage (\"dCreateImage\") not found in DLL!\n";
		}

		dxFreeImage = (LPDFREEIMAGE)GetProcAddress ((HMODULE)HW_DLL, "dFreeImage");

		if (dxFreeImage == NULL)
		{
			cout << "Function dxFreeImage (\"dFreeImage\") not found in DLL!\n";
		}

		dxImageWidth = (LPDIMAGEWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dImageWidth");

		if (dxImageWidth == NULL)
		{
			cout << "Function dxImageWidth (\"dImageWidth\") not found in DLL!\n";
		}

		dxImageHeight = (LPDIMAGEHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dImageHeight");

		if (dxImageHeight == NULL)
		{
			cout << "Function dxImageHeight (\"dImageHeight\") not found in DLL!\n";
		}

		dxImageBuffer = (LPDIMAGEBUFFER)GetProcAddress ((HMODULE)HW_DLL, "dImageBuffer");

		if (dxImageBuffer == NULL)
		{
			cout << "Function dxImageBuffer (\"dImageBuffer\") not found in DLL!\n";
		}

		dxCopyImage = (LPDCOPYIMAGE)GetProcAddress ((HMODULE)HW_DLL, "dCopyImage");

		if (dxCopyImage == NULL)
		{
			cout << "Function dxCopyImage (\"dCopyImage\") not found in DLL!\n";
		}

		dxCopyRect = (LPDCOPYRECT)GetProcAddress ((HMODULE)HW_DLL, "dCopyRect");

		if (dxCopyRect == NULL)
		{
			cout << "Function dxCopyRect (\"dCopyRect\") not found in DLL!\n";
		}

		dxSetFilters = (LPDSETFILTERS)GetProcAddress ((HMODULE)HW_DLL, "dSetFilters");

		if (dxSetFilters == NULL)
		{
			cout << "Function dxSetFilters (\"dSetFilters\") not found in DLL!\n";
		}

		dxRenderToTexture = (LPDRENDERTOTEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dRenderToTexture");

		if (dxRenderToTexture == NULL)
		{
			cout << "Function dxRenderToTexture (\"dRenderToTexture\") not found in DLL!\n";
		}

		dxRenderToScreen = (LPDRENDERTOSCREEN)GetProcAddress ((HMODULE)HW_DLL, "dRenderToScreen");

		if (dxRenderToScreen == NULL)
		{
			cout << "Function dxRenderToScreen (\"dRenderToScreen\") not found in DLL!\n";
		}

		dxCreateSprite = (LPDCREATESPRITE)GetProcAddress ((HMODULE)HW_DLL, "dCreateSprite");

		if (dxCreateSprite == NULL)
		{
			cout << "Function dxCreateSprite (\"dCreateSprite\") not found in DLL!\n";
		}

		dxSpriteViewMode = (LPDSPRITEVIEWMODE)GetProcAddress ((HMODULE)HW_DLL, "dSpriteViewMode");

		if (dxSpriteViewMode == NULL)
		{
			cout << "Function dxSpriteViewMode (\"dSpriteViewMode\") not found in DLL!\n";
		}

		dxScaleSprite = (LPDSCALESPRITE)GetProcAddress ((HMODULE)HW_DLL, "dScaleSprite");

		if (dxScaleSprite == NULL)
		{
			cout << "Function dxScaleSprite (\"dScaleSprite\") not found in DLL!\n";
		}

		dxHandleSprite = (LPDHANDLESPRITE)GetProcAddress ((HMODULE)HW_DLL, "dHandleSprite");

		if (dxHandleSprite == NULL)
		{
			cout << "Function dxHandleSprite (\"dHandleSprite\") not found in DLL!\n";
		}

		dxUseDirectX11 = (LPDUSEDIRECTX11)GetProcAddress ((HMODULE)HW_DLL, "dUseDirectX11");

		if (dxUseDirectX11 == NULL)
		{
			cout << "Function dxUseDirectX11 (\"dUseDirectX11\") not found in DLL!\n";
		}

		dxDirectX11Used = (LPDDIRECTX11USED)GetProcAddress ((HMODULE)HW_DLL, "dDirectX11Used");

		if (dxDirectX11Used == NULL)
		{
			cout << "Function dxDirectX11Used (\"dDirectX11Used\") not found in DLL!\n";
		}

		dxSeedRnd = (LPDSEEDRND)GetProcAddress ((HMODULE)HW_DLL, "dSeedRnd");

		if (dxSeedRnd == NULL)
		{
			cout << "Function dxSeedRnd (\"dSeedRnd\") not found in DLL!\n";
		}

		dxRnd = (LPDRND)GetProcAddress ((HMODULE)HW_DLL, "dRnd");

		if (dxRnd == NULL)
		{
			cout << "Function dxRnd (\"dRnd\") not found in DLL!\n";
		}

		dxRand = (LPDRAND)GetProcAddress ((HMODULE)HW_DLL, "dRand");

		if (dxRand == NULL)
		{
			cout << "Function dxRand (\"dRand\") not found in DLL!\n";
		}

		dxCreatePivot = (LPDCREATEPIVOT)GetProcAddress ((HMODULE)HW_DLL, "dCreatePivot");

		if (dxCreatePivot == NULL)
		{
			cout << "Function dxCreatePivot (\"dCreatePivot\") not found in DLL!\n";
		}

		dxBufferNoise = (LPDBUFFERNOISE)GetProcAddress ((HMODULE)HW_DLL, "dBufferNoise");

		if (dxBufferNoise == NULL)
		{
			cout << "Function dxBufferNoise (\"dBufferNoise\") not found in DLL!\n";
		}

		dxBufferInvert = (LPDBUFFERINVERT)GetProcAddress ((HMODULE)HW_DLL, "dBufferInvert");

		if (dxBufferInvert == NULL)
		{
			cout << "Function dxBufferInvert (\"dBufferInvert\") not found in DLL!\n";
		}

		dxSetCubeFace = (LPDSETCUBEFACE)GetProcAddress ((HMODULE)HW_DLL, "dSetCubeFace");

		if (dxSetCubeFace == NULL)
		{
			cout << "Function dxSetCubeFace (\"dSetCubeFace\") not found in DLL!\n";
		}

		dxGetSurfaceBoundingRadius = (LPDGETSURFACEBOUNDINGRADIUS)GetProcAddress ((HMODULE)HW_DLL, "dGetSurfaceBoundingRadius");

		if (dxGetSurfaceBoundingRadius == NULL)
		{
			cout << "Function dxGetSurfaceBoundingRadius (\"dGetSurfaceBoundingRadius\") not found in DLL!\n";
		}

		dxTrisRendered = (LPDTRISRENDERED)GetProcAddress ((HMODULE)HW_DLL, "dTrisRendered");

		if (dxTrisRendered == NULL)
		{
			cout << "Function dxTrisRendered (\"dTrisRendered\") not found in DLL!\n";
		}

		dxEntityInView = (LPDENTITYINVIEW)GetProcAddress ((HMODULE)HW_DLL, "dEntityInView");

		if (dxEntityInView == NULL)
		{
			cout << "Function dxEntityInView (\"dEntityInView\") not found in DLL!\n";
		}

		dxMaxLights = (LPDMAXLIGHTS)GetProcAddress ((HMODULE)HW_DLL, "dMaxLights");

		if (dxMaxLights == NULL)
		{
			cout << "Function dxMaxLights (\"dMaxLights\") not found in DLL!\n";
		}

		dxCreateTerrain = (LPDCREATETERRAIN)GetProcAddress ((HMODULE)HW_DLL, "dCreateTerrain");

		if (dxCreateTerrain == NULL)
		{
			cout << "Function dxCreateTerrain (\"dCreateTerrain\") not found in DLL!\n";
		}

		dxModifyTerrain = (LPDMODIFYTERRAIN)GetProcAddress ((HMODULE)HW_DLL, "dModifyTerrain");

		if (dxModifyTerrain == NULL)
		{
			cout << "Function dxModifyTerrain (\"dModifyTerrain\") not found in DLL!\n";
		}

		dxTerrainSize = (LPDTERRAINSIZE)GetProcAddress ((HMODULE)HW_DLL, "dTerrainSize");

		if (dxTerrainSize == NULL)
		{
			cout << "Function dxTerrainSize (\"dTerrainSize\") not found in DLL!\n";
		}

		dxLoadTerrain = (LPDLOADTERRAIN)GetProcAddress ((HMODULE)HW_DLL, "dLoadTerrain");

		if (dxLoadTerrain == NULL)
		{
			cout << "Function dxLoadTerrain (\"dLoadTerrain\") not found in DLL!\n";
		}

		dxTerrainHeight = (LPDTERRAINHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dTerrainHeight");

		if (dxTerrainHeight == NULL)
		{
			cout << "Function dxTerrainHeight (\"dTerrainHeight\") not found in DLL!\n";
		}

		dxFitMesh = (LPDFITMESH)GetProcAddress ((HMODULE)HW_DLL, "dFitMesh");

		if (dxFitMesh == NULL)
		{
			cout << "Function dxFitMesh (\"dFitMesh\") not found in DLL!\n";
		}

		dxScaleMesh = (LPDSCALEMESH)GetProcAddress ((HMODULE)HW_DLL, "dScaleMesh");

		if (dxScaleMesh == NULL)
		{
			cout << "Function dxScaleMesh (\"dScaleMesh\") not found in DLL!\n";
		}

		dxGetConstantTableSize = (LPDGETCONSTANTTABLESIZE)GetProcAddress ((HMODULE)HW_DLL, "dGetConstantTableSize");

		if (dxGetConstantTableSize == NULL)
		{
			cout << "Function dxGetConstantTableSize (\"dGetConstantTableSize\") not found in DLL!\n";
		}

		dxConstantCount = (LPDCONSTANTCOUNT)GetProcAddress ((HMODULE)HW_DLL, "dConstantCount");

		if (dxConstantCount == NULL)
		{
			cout << "Function dxConstantCount (\"dConstantCount\") not found in DLL!\n";
		}

		dxDeclareVertexShaderWorldConstant = (LPDDECLAREVERTEXSHADERWORLDCONSTANT)GetProcAddress ((HMODULE)HW_DLL, "dDeclareVertexShaderWorldConstant");

		if (dxDeclareVertexShaderWorldConstant == NULL)
		{
			cout << "Function dxDeclareVertexShaderWorldConstant (\"dDeclareVertexShaderWorldConstant\") not found in DLL!\n";
		}

		dxDeclareVertexShaderViewConstant = (LPDDECLAREVERTEXSHADERVIEWCONSTANT)GetProcAddress ((HMODULE)HW_DLL, "dDeclareVertexShaderViewConstant");

		if (dxDeclareVertexShaderViewConstant == NULL)
		{
			cout << "Function dxDeclareVertexShaderViewConstant (\"dDeclareVertexShaderViewConstant\") not found in DLL!\n";
		}

		dxDeclareVertexShaderProjConstant = (LPDDECLAREVERTEXSHADERPROJCONSTANT)GetProcAddress ((HMODULE)HW_DLL, "dDeclareVertexShaderProjConstant");

		if (dxDeclareVertexShaderProjConstant == NULL)
		{
			cout << "Function dxDeclareVertexShaderProjConstant (\"dDeclareVertexShaderProjConstant\") not found in DLL!\n";
		}

		dxDeclareVertexShaderWorldViewProjConstant = (LPDDECLAREVERTEXSHADERWORLDVIEWPROJCONSTANT)GetProcAddress ((HMODULE)HW_DLL, "dDeclareVertexShaderWorldViewProjConstant");

		if (dxDeclareVertexShaderWorldViewProjConstant == NULL)
		{
			cout << "Function dxDeclareVertexShaderWorldViewProjConstant (\"dDeclareVertexShaderWorldViewProjConstant\") not found in DLL!\n";
		}

		dxEntityRadius = (LPDENTITYRADIUS)GetProcAddress ((HMODULE)HW_DLL, "dEntityRadius");

		if (dxEntityRadius == NULL)
		{
			cout << "Function dxEntityRadius (\"dEntityRadius\") not found in DLL!\n";
		}

		dxEntityBox = (LPDENTITYBOX)GetProcAddress ((HMODULE)HW_DLL, "dEntityBox");

		if (dxEntityBox == NULL)
		{
			cout << "Function dxEntityBox (\"dEntityBox\") not found in DLL!\n";
		}

		dxEntityType = (LPDENTITYTYPE)GetProcAddress ((HMODULE)HW_DLL, "dEntityType");

		if (dxEntityType == NULL)
		{
			cout << "Function dxEntityType (\"dEntityType\") not found in DLL!\n";
		}

		dxEntityPickMode = (LPDENTITYPICKMODE)GetProcAddress ((HMODULE)HW_DLL, "dEntityPickMode");

		if (dxEntityPickMode == NULL)
		{
			cout << "Function dxEntityPickMode (\"dEntityPickMode\") not found in DLL!\n";
		}

		dxGetEntityType = (LPDGETENTITYTYPE)GetProcAddress ((HMODULE)HW_DLL, "dGetEntityType");

		if (dxGetEntityType == NULL)
		{
			cout << "Function dxGetEntityType (\"dGetEntityType\") not found in DLL!\n";
		}

		dxGetFPS = (LPDGETFPS)GetProcAddress ((HMODULE)HW_DLL, "dGetFPS");

		if (dxGetFPS == NULL)
		{
			cout << "Function dxGetFPS (\"dGetFPS\") not found in DLL!\n";
		}

		dxPointEntity = (LPDPOINTENTITY)GetProcAddress ((HMODULE)HW_DLL, "dPointEntity");

		if (dxPointEntity == NULL)
		{
			cout << "Function dxPointEntity (\"dPointEntity\") not found in DLL!\n";
		}

		dxAlignToVector = (LPDALIGNTOVECTOR)GetProcAddress ((HMODULE)HW_DLL, "dAlignToVector");

		if (dxAlignToVector == NULL)
		{
			cout << "Function dxAlignToVector (\"dAlignToVector\") not found in DLL!\n";
		}

		dxFramesRendered = (LPDFRAMESRENDERED)GetProcAddress ((HMODULE)HW_DLL, "dFramesRendered");

		if (dxFramesRendered == NULL)
		{
			cout << "Function dxFramesRendered (\"dFramesRendered\") not found in DLL!\n";
		}

		dxTFormPoint = (LPDTFORMPOINT)GetProcAddress ((HMODULE)HW_DLL, "dTFormPoint");

		if (dxTFormPoint == NULL)
		{
			cout << "Function dxTFormPoint (\"dTFormPoint\") not found in DLL!\n";
		}

		dxTFormedX = (LPDTFORMEDX)GetProcAddress ((HMODULE)HW_DLL, "dTFormedX");

		if (dxTFormedX == NULL)
		{
			cout << "Function dxTFormedX (\"dTFormedX\") not found in DLL!\n";
		}

		dxTFormedY = (LPDTFORMEDY)GetProcAddress ((HMODULE)HW_DLL, "dTFormedY");

		if (dxTFormedY == NULL)
		{
			cout << "Function dxTFormedY (\"dTFormedY\") not found in DLL!\n";
		}

		dxTFormedZ = (LPDTFORMEDZ)GetProcAddress ((HMODULE)HW_DLL, "dTFormedZ");

		if (dxTFormedZ == NULL)
		{
			cout << "Function dxTFormedZ (\"dTFormedZ\") not found in DLL!\n";
		}

		dxEntityDistance = (LPDENTITYDISTANCE)GetProcAddress ((HMODULE)HW_DLL, "dEntityDistance");

		if (dxEntityDistance == NULL)
		{
			cout << "Function dxEntityDistance (\"dEntityDistance\") not found in DLL!\n";
		}

		dxVectorYaw = (LPDVECTORYAW)GetProcAddress ((HMODULE)HW_DLL, "dVectorYaw");

		if (dxVectorYaw == NULL)
		{
			cout << "Function dxVectorYaw (\"dVectorYaw\") not found in DLL!\n";
		}

		dxVectorPitch = (LPDVECTORPITCH)GetProcAddress ((HMODULE)HW_DLL, "dVectorPitch");

		if (dxVectorPitch == NULL)
		{
			cout << "Function dxVectorPitch (\"dVectorPitch\") not found in DLL!\n";
		}

		dxCameraProject = (LPDCAMERAPROJECT)GetProcAddress ((HMODULE)HW_DLL, "dCameraProject");

		if (dxCameraProject == NULL)
		{
			cout << "Function dxCameraProject (\"dCameraProject\") not found in DLL!\n";
		}

		dxProjectedX = (LPDPROJECTEDX)GetProcAddress ((HMODULE)HW_DLL, "dProjectedX");

		if (dxProjectedX == NULL)
		{
			cout << "Function dxProjectedX (\"dProjectedX\") not found in DLL!\n";
		}

		dxProjectedY = (LPDPROJECTEDY)GetProcAddress ((HMODULE)HW_DLL, "dProjectedY");

		if (dxProjectedY == NULL)
		{
			cout << "Function dxProjectedY (\"dProjectedY\") not found in DLL!\n";
		}

		dxProjectedZ = (LPDPROJECTEDZ)GetProcAddress ((HMODULE)HW_DLL, "dProjectedZ");

		if (dxProjectedZ == NULL)
		{
			cout << "Function dxProjectedZ (\"dProjectedZ\") not found in DLL!\n";
		}

		dxDeltaPitch = (LPDDELTAPITCH)GetProcAddress ((HMODULE)HW_DLL, "dDeltaPitch");

		if (dxDeltaPitch == NULL)
		{
			cout << "Function dxDeltaPitch (\"dDeltaPitch\") not found in DLL!\n";
		}

		dxDeltaYaw = (LPDDELTAYAW)GetProcAddress ((HMODULE)HW_DLL, "dDeltaYaw");

		if (dxDeltaYaw == NULL)
		{
			cout << "Function dxDeltaYaw (\"dDeltaYaw\") not found in DLL!\n";
		}

		dxCameraPick = (LPDCAMERAPICK)GetProcAddress ((HMODULE)HW_DLL, "dCameraPick");

		if (dxCameraPick == NULL)
		{
			cout << "Function dxCameraPick (\"dCameraPick\") not found in DLL!\n";
		}

		dxPickedX = (LPDPICKEDX)GetProcAddress ((HMODULE)HW_DLL, "dPickedX");

		if (dxPickedX == NULL)
		{
			cout << "Function dxPickedX (\"dPickedX\") not found in DLL!\n";
		}

		dxPickedY = (LPDPICKEDY)GetProcAddress ((HMODULE)HW_DLL, "dPickedY");

		if (dxPickedY == NULL)
		{
			cout << "Function dxPickedY (\"dPickedY\") not found in DLL!\n";
		}

		dxPickedZ = (LPDPICKEDZ)GetProcAddress ((HMODULE)HW_DLL, "dPickedZ");

		if (dxPickedZ == NULL)
		{
			cout << "Function dxPickedZ (\"dPickedZ\") not found in DLL!\n";
		}

		dxPickedNX = (LPDPICKEDNX)GetProcAddress ((HMODULE)HW_DLL, "dPickedNX");

		if (dxPickedNX == NULL)
		{
			cout << "Function dxPickedNX (\"dPickedNX\") not found in DLL!\n";
		}

		dxPickedNY = (LPDPICKEDNY)GetProcAddress ((HMODULE)HW_DLL, "dPickedNY");

		if (dxPickedNY == NULL)
		{
			cout << "Function dxPickedNY (\"dPickedNY\") not found in DLL!\n";
		}

		dxPickedNZ = (LPDPICKEDNZ)GetProcAddress ((HMODULE)HW_DLL, "dPickedNZ");

		if (dxPickedNZ == NULL)
		{
			cout << "Function dxPickedNZ (\"dPickedNZ\") not found in DLL!\n";
		}

		dxPickedTime = (LPDPICKEDTIME)GetProcAddress ((HMODULE)HW_DLL, "dPickedTime");

		if (dxPickedTime == NULL)
		{
			cout << "Function dxPickedTime (\"dPickedTime\") not found in DLL!\n";
		}

		dxPickedEntity = (LPDPICKEDENTITY)GetProcAddress ((HMODULE)HW_DLL, "dPickedEntity");

		if (dxPickedEntity == NULL)
		{
			cout << "Function dxPickedEntity (\"dPickedEntity\") not found in DLL!\n";
		}

		dxPickedSurface = (LPDPICKEDSURFACE)GetProcAddress ((HMODULE)HW_DLL, "dPickedSurface");

		if (dxPickedSurface == NULL)
		{
			cout << "Function dxPickedSurface (\"dPickedSurface\") not found in DLL!\n";
		}

		dxPickedTriangle = (LPDPICKEDTRIANGLE)GetProcAddress ((HMODULE)HW_DLL, "dPickedTriangle");

		if (dxPickedTriangle == NULL)
		{
			cout << "Function dxPickedTriangle (\"dPickedTriangle\") not found in DLL!\n";
		}

		dxEntityPick = (LPDENTITYPICK)GetProcAddress ((HMODULE)HW_DLL, "dEntityPick");

		if (dxEntityPick == NULL)
		{
			cout << "Function dxEntityPick (\"dEntityPick\") not found in DLL!\n";
		}

		dxLinePick = (LPDLINEPICK)GetProcAddress ((HMODULE)HW_DLL, "dLinePick");

		if (dxLinePick == NULL)
		{
			cout << "Function dxLinePick (\"dLinePick\") not found in DLL!\n";
		}

		dxHideWindow = (LPDHIDEWINDOW)GetProcAddress ((HMODULE)HW_DLL, "dHideWindow");

		if (dxHideWindow == NULL)
		{
			cout << "Function dxHideWindow (\"dHideWindow\") not found in DLL!\n";
		}

		dxIsWindowMinimized = (LPDISWINDOWMINIMIZED)GetProcAddress ((HMODULE)HW_DLL, "dIsWindowMinimized");

		if (dxIsWindowMinimized == NULL)
		{
			cout << "Function dxIsWindowMinimized (\"dIsWindowMinimized\") not found in DLL!\n";
		}

		dxRotateMesh = (LPDROTATEMESH)GetProcAddress ((HMODULE)HW_DLL, "dRotateMesh");

		if (dxRotateMesh == NULL)
		{
			cout << "Function dxRotateMesh (\"dRotateMesh\") not found in DLL!\n";
		}

		dxCreateEmitter = (LPDCREATEEMITTER)GetProcAddress ((HMODULE)HW_DLL, "dCreateEmitter");

		if (dxCreateEmitter == NULL)
		{
			cout << "Function dxCreateEmitter (\"dCreateEmitter\") not found in DLL!\n";
		}

		dxEmitterCountElements = (LPDEMITTERCOUNTELEMENTS)GetProcAddress ((HMODULE)HW_DLL, "dEmitterCountElements");

		if (dxEmitterCountElements == NULL)
		{
			cout << "Function dxEmitterCountElements (\"dEmitterCountElements\") not found in DLL!\n";
		}

		dxEmitterSetElementCount = (LPDEMITTERSETELEMENTCOUNT)GetProcAddress ((HMODULE)HW_DLL, "dEmitterSetElementCount");

		if (dxEmitterSetElementCount == NULL)
		{
			cout << "Function dxEmitterSetElementCount (\"dEmitterSetElementCount\") not found in DLL!\n";
		}

		dxEmitterDeleteElement = (LPDEMITTERDELETEELEMENT)GetProcAddress ((HMODULE)HW_DLL, "dEmitterDeleteElement");

		if (dxEmitterDeleteElement == NULL)
		{
			cout << "Function dxEmitterDeleteElement (\"dEmitterDeleteElement\") not found in DLL!\n";
		}

		dxGetWinVersion = (LPDGETWINVERSION)GetProcAddress ((HMODULE)HW_DLL, "dGetWinVersion");

		if (dxGetWinVersion == NULL)
		{
			cout << "Function dxGetWinVersion (\"dGetWinVersion\") not found in DLL!\n";
		}

		dxCameraZoom = (LPDCAMERAZOOM)GetProcAddress ((HMODULE)HW_DLL, "dCameraZoom");

		if (dxCameraZoom == NULL)
		{
			cout << "Function dxCameraZoom (\"dCameraZoom\") not found in DLL!\n";
		}

		dxSurfaceShininess = (LPDSURFACESHININESS)GetProcAddress ((HMODULE)HW_DLL, "dSurfaceShininess");

		if (dxSurfaceShininess == NULL)
		{
			cout << "Function dxSurfaceShininess (\"dSurfaceShininess\") not found in DLL!\n";
		}

		dxEntityShininess = (LPDENTITYSHININESS)GetProcAddress ((HMODULE)HW_DLL, "dEntityShininess");

		if (dxEntityShininess == NULL)
		{
			cout << "Function dxEntityShininess (\"dEntityShininess\") not found in DLL!\n";
		}

		dxCreateMaze = (LPDCREATEMAZE)GetProcAddress ((HMODULE)HW_DLL, "dCreateMaze");

		if (dxCreateMaze == NULL)
		{
			cout << "Function dxCreateMaze (\"dCreateMaze\") not found in DLL!\n";
		}

		dxFreeMaze = (LPDFREEMAZE)GetProcAddress ((HMODULE)HW_DLL, "dFreeMaze");

		if (dxFreeMaze == NULL)
		{
			cout << "Function dxFreeMaze (\"dFreeMaze\") not found in DLL!\n";
		}

		dxReadMaze = (LPDREADMAZE)GetProcAddress ((HMODULE)HW_DLL, "dReadMaze");

		if (dxReadMaze == NULL)
		{
			cout << "Function dxReadMaze (\"dReadMaze\") not found in DLL!\n";
		}

		dxLoadMesh = (LPDLOADMESH)GetProcAddress ((HMODULE)HW_DLL, "dLoadMesh");

		if (dxLoadMesh == NULL)
		{
			cout << "Function dxLoadMesh (\"dLoadMesh\") not found in DLL!\n";
		}

		dxSaveMesh = (LPDSAVEMESH)GetProcAddress ((HMODULE)HW_DLL, "dSaveMesh");

		if (dxSaveMesh == NULL)
		{
			cout << "Function dxSaveMesh (\"dSaveMesh\") not found in DLL!\n";
		}

		dxLoadMeshXFromBank = (LPDLOADMESHXFROMBANK)GetProcAddress ((HMODULE)HW_DLL, "dLoadMeshXFromBank");

		if (dxLoadMeshXFromBank == NULL)
		{
			cout << "Function dxLoadMeshXFromBank (\"dLoadMeshXFromBank\") not found in DLL!\n";
		}

		dxLoadTextureFromBank = (LPDLOADTEXTUREFROMBANK)GetProcAddress ((HMODULE)HW_DLL, "dLoadTextureFromBank");

		if (dxLoadTextureFromBank == NULL)
		{
			cout << "Function dxLoadTextureFromBank (\"dLoadTextureFromBank\") not found in DLL!\n";
		}

		dxBankSize = (LPDBANKSIZE)GetProcAddress ((HMODULE)HW_DLL, "dBankSize");

		if (dxBankSize == NULL)
		{
			cout << "Function dxBankSize (\"dBankSize\") not found in DLL!\n";
		}

		dxPeekMemInt = (LPDPEEKMEMINT)GetProcAddress ((HMODULE)HW_DLL, "dPeekMemInt");

		if (dxPeekMemInt == NULL)
		{
			cout << "Function dxPeekMemInt (\"dPeekMemInt\") not found in DLL!\n";
		}

		dxPokeMemInt = (LPDPOKEMEMINT)GetProcAddress ((HMODULE)HW_DLL, "dPokeMemInt");

		if (dxPokeMemInt == NULL)
		{
			cout << "Function dxPokeMemInt (\"dPokeMemInt\") not found in DLL!\n";
		}

		dxLocate = (LPDLOCATE)GetProcAddress ((HMODULE)HW_DLL, "dLocate");

		if (dxLocate == NULL)
		{
			cout << "Function dxLocate (\"dLocate\") not found in DLL!\n";
		}

		dxPrint = (LPDPRINT)GetProcAddress ((HMODULE)HW_DLL, "dPrint");

		if (dxPrint == NULL)
		{
			cout << "Function dxPrint (\"dPrint\") not found in DLL!\n";
		}

		dxLoadAnimTexture = (LPDLOADANIMTEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dLoadAnimTexture");

		if (dxLoadAnimTexture == NULL)
		{
			cout << "Function dxLoadAnimTexture (\"dLoadAnimTexture\") not found in DLL!\n";
		}

		dxLoadAnimTextureFromBank = (LPDLOADANIMTEXTUREFROMBANK)GetProcAddress ((HMODULE)HW_DLL, "dLoadAnimTextureFromBank");

		if (dxLoadAnimTextureFromBank == NULL)
		{
			cout << "Function dxLoadAnimTextureFromBank (\"dLoadAnimTextureFromBank\") not found in DLL!\n";
		}

		dxMeshesIntersect = (LPDMESHESINTERSECT)GetProcAddress ((HMODULE)HW_DLL, "dMeshesIntersect");

		if (dxMeshesIntersect == NULL)
		{
			cout << "Function dxMeshesIntersect (\"dMeshesIntersect\") not found in DLL!\n";
		}

		dxRotateSprite = (LPDROTATESPRITE)GetProcAddress ((HMODULE)HW_DLL, "dRotateSprite");

		if (dxRotateSprite == NULL)
		{
			cout << "Function dxRotateSprite (\"dRotateSprite\") not found in DLL!\n";
		}

		dxUpdateWorld = (LPDUPDATEWORLD)GetProcAddress ((HMODULE)HW_DLL, "dUpdateWorld");

		if (dxUpdateWorld == NULL)
		{
			cout << "Function dxUpdateWorld (\"dUpdateWorld\") not found in DLL!\n";
		}

		dxCreateCone = (LPDCREATECONE)GetProcAddress ((HMODULE)HW_DLL, "dCreateCone");

		if (dxCreateCone == NULL)
		{
			cout << "Function dxCreateCone (\"dCreateCone\") not found in DLL!\n";
		}

		dxLightCaster = (LPDLIGHTCASTER)GetProcAddress ((HMODULE)HW_DLL, "dLightCaster");

		if (dxLightCaster == NULL)
		{
			cout << "Function dxLightCaster (\"dLightCaster\") not found in DLL!\n";
		}

		dxEntityCaster = (LPDENTITYCASTER)GetProcAddress ((HMODULE)HW_DLL, "dEntityCaster");

		if (dxEntityCaster == NULL)
		{
			cout << "Function dxEntityCaster (\"dEntityCaster\") not found in DLL!\n";
		}

		dxEnityShadowDetail = (LPDENITYSHADOWDETAIL)GetProcAddress ((HMODULE)HW_DLL, "dEnityShadowDetail");

		if (dxEnityShadowDetail == NULL)
		{
			cout << "Function dxEnityShadowDetail (\"dEnityShadowDetail\") not found in DLL!\n";
		}

		dxEnityShadowColor = (LPDENITYSHADOWCOLOR)GetProcAddress ((HMODULE)HW_DLL, "dEnityShadowColor");

		if (dxEnityShadowColor == NULL)
		{
			cout << "Function dxEnityShadowColor (\"dEnityShadowColor\") not found in DLL!\n";
		}

		dxEnityShadowIntensity = (LPDENITYSHADOWINTENSITY)GetProcAddress ((HMODULE)HW_DLL, "dEnityShadowIntensity");

		if (dxEnityShadowIntensity == NULL)
		{
			cout << "Function dxEnityShadowIntensity (\"dEnityShadowIntensity\") not found in DLL!\n";
		}

		dxEnableShadows = (LPDENABLESHADOWS)GetProcAddress ((HMODULE)HW_DLL, "dEnableShadows");

		if (dxEnableShadows == NULL)
		{
			cout << "Function dxEnableShadows (\"dEnableShadows\") not found in DLL!\n";
		}

		dxEnityShadowCutoff = (LPDENITYSHADOWCUTOFF)GetProcAddress ((HMODULE)HW_DLL, "dEnityShadowCutoff");

		if (dxEnityShadowCutoff == NULL)
		{
			cout << "Function dxEnityShadowCutoff (\"dEnityShadowCutoff\") not found in DLL!\n";
		}

		dxSetVSync = (LPDSETVSYNC)GetProcAddress ((HMODULE)HW_DLL, "dSetVSync");

		if (dxSetVSync == NULL)
		{
			cout << "Function dxSetVSync (\"dSetVSync\") not found in DLL!\n";
		}

		dxSetWindowDefaults = (LPDSETWINDOWDEFAULTS)GetProcAddress ((HMODULE)HW_DLL, "dSetWindowDefaults");

		if (dxSetWindowDefaults == NULL)
		{
			cout << "Function dxSetWindowDefaults (\"dSetWindowDefaults\") not found in DLL!\n";
		}

		dxWinClose = (LPDWINCLOSE)GetProcAddress ((HMODULE)HW_DLL, "dWinClose");

		if (dxWinClose == NULL)
		{
			cout << "Function dxWinClose (\"dWinClose\") not found in DLL!\n";
		}

		dxClearWorld = (LPDCLEARWORLD)GetProcAddress ((HMODULE)HW_DLL, "dClearWorld");

		if (dxClearWorld == NULL)
		{
			cout << "Function dxClearWorld (\"dClearWorld\") not found in DLL!\n";
		}

		dxClearCollisions = (LPDCLEARCOLLISIONS)GetProcAddress ((HMODULE)HW_DLL, "dClearCollisions");

		if (dxClearCollisions == NULL)
		{
			cout << "Function dxClearCollisions (\"dClearCollisions\") not found in DLL!\n";
		}

		dxCollisions = (LPDCOLLISIONS)GetProcAddress ((HMODULE)HW_DLL, "dCollisions");

		if (dxCollisions == NULL)
		{
			cout << "Function dxCollisions (\"dCollisions\") not found in DLL!\n";
		}

		dxTextureFilter = (LPDTEXTUREFILTER)GetProcAddress ((HMODULE)HW_DLL, "dTextureFilter");

		if (dxTextureFilter == NULL)
		{
			cout << "Function dxTextureFilter (\"dTextureFilter\") not found in DLL!\n";
		}

		dxClearTextureFilters = (LPDCLEARTEXTUREFILTERS)GetProcAddress ((HMODULE)HW_DLL, "dClearTextureFilters");

		if (dxClearTextureFilters == NULL)
		{
			cout << "Function dxClearTextureFilters (\"dClearTextureFilters\") not found in DLL!\n";
		}

		dxScreenWidth = (LPDSCREENWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dScreenWidth");

		if (dxScreenWidth == NULL)
		{
			cout << "Function dxScreenWidth (\"dScreenWidth\") not found in DLL!\n";
		}

		dxScreenHeight = (LPDSCREENHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dScreenHeight");

		if (dxScreenHeight == NULL)
		{
			cout << "Function dxScreenHeight (\"dScreenHeight\") not found in DLL!\n";
		}

		dxWindowWidth = (LPDWINDOWWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dWindowWidth");

		if (dxWindowWidth == NULL)
		{
			cout << "Function dxWindowWidth (\"dWindowWidth\") not found in DLL!\n";
		}

		dxWindowHeight = (LPDWINDOWHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dWindowHeight");

		if (dxWindowHeight == NULL)
		{
			cout << "Function dxWindowHeight (\"dWindowHeight\") not found in DLL!\n";
		}

		dxWindowX = (LPDWINDOWX)GetProcAddress ((HMODULE)HW_DLL, "dWindowX");

		if (dxWindowX == NULL)
		{
			cout << "Function dxWindowX (\"dWindowX\") not found in DLL!\n";
		}

		dxWindowY = (LPDWINDOWY)GetProcAddress ((HMODULE)HW_DLL, "dWindowY");

		if (dxWindowY == NULL)
		{
			cout << "Function dxWindowY (\"dWindowY\") not found in DLL!\n";
		}

		dxWindowResized = (LPDWINDOWRESIZED)GetProcAddress ((HMODULE)HW_DLL, "dWindowResized");

		if (dxWindowResized == NULL)
		{
			cout << "Function dxWindowResized (\"dWindowResized\") not found in DLL!\n";
		}

		dxWindowMoved = (LPDWINDOWMOVED)GetProcAddress ((HMODULE)HW_DLL, "dWindowMoved");

		if (dxWindowMoved == NULL)
		{
			cout << "Function dxWindowMoved (\"dWindowMoved\") not found in DLL!\n";
		}

		dxMeshSimplify = (LPDMESHSIMPLIFY)GetProcAddress ((HMODULE)HW_DLL, "dMeshSimplify");

		if (dxMeshSimplify == NULL)
		{
			cout << "Function dxMeshSimplify (\"dMeshSimplify\") not found in DLL!\n";
		}

		dxVlcPresent = (LPDVLCPRESENT)GetProcAddress ((HMODULE)HW_DLL, "dVlcPresent");

		if (dxVlcPresent == NULL)
		{
			cout << "Function dxVlcPresent (\"dVlcPresent\") not found in DLL!\n";
		}

		dxFreeVid = (LPDFREEVID)GetProcAddress ((HMODULE)HW_DLL, "dFreeVid");

		if (dxFreeVid == NULL)
		{
			cout << "Function dxFreeVid (\"dFreeVid\") not found in DLL!\n";
		}

		dxVidLoad = (LPDVIDLOAD)GetProcAddress ((HMODULE)HW_DLL, "dVidLoad");

		if (dxVidLoad == NULL)
		{
			cout << "Function dxVidLoad (\"dVidLoad\") not found in DLL!\n";
		}

		dxVidDownload = (LPDVIDDOWNLOAD)GetProcAddress ((HMODULE)HW_DLL, "dVidDownload");

		if (dxVidDownload == NULL)
		{
			cout << "Function dxVidDownload (\"dVidDownload\") not found in DLL!\n";
		}

		dxVidTrackCount = (LPDVIDTRACKCOUNT)GetProcAddress ((HMODULE)HW_DLL, "dVidTrackCount");

		if (dxVidTrackCount == NULL)
		{
			cout << "Function dxVidTrackCount (\"dVidTrackCount\") not found in DLL!\n";
		}

		dxVidTrackType = (LPDVIDTRACKTYPE)GetProcAddress ((HMODULE)HW_DLL, "dVidTrackType");

		if (dxVidTrackType == NULL)
		{
			cout << "Function dxVidTrackType (\"dVidTrackType\") not found in DLL!\n";
		}

		dxVidWidth = (LPDVIDWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dVidWidth");

		if (dxVidWidth == NULL)
		{
			cout << "Function dxVidWidth (\"dVidWidth\") not found in DLL!\n";
		}

		dxVidHeight = (LPDVIDHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dVidHeight");

		if (dxVidHeight == NULL)
		{
			cout << "Function dxVidHeight (\"dVidHeight\") not found in DLL!\n";
		}

		dxVidDuration = (LPDVIDDURATION)GetProcAddress ((HMODULE)HW_DLL, "dVidDuration");

		if (dxVidDuration == NULL)
		{
			cout << "Function dxVidDuration (\"dVidDuration\") not found in DLL!\n";
		}

		dxVidTexture = (LPDVIDTEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dVidTexture");

		if (dxVidTexture == NULL)
		{
			cout << "Function dxVidTexture (\"dVidTexture\") not found in DLL!\n";
		}

		dxGetVidTexture = (LPDGETVIDTEXTURE)GetProcAddress ((HMODULE)HW_DLL, "dGetVidTexture");

		if (dxGetVidTexture == NULL)
		{
			cout << "Function dxGetVidTexture (\"dGetVidTexture\") not found in DLL!\n";
		}

		dxVidPlay = (LPDVIDPLAY)GetProcAddress ((HMODULE)HW_DLL, "dVidPlay");

		if (dxVidPlay == NULL)
		{
			cout << "Function dxVidPlay (\"dVidPlay\") not found in DLL!\n";
		}

		dxVidPlaying = (LPDVIDPLAYING)GetProcAddress ((HMODULE)HW_DLL, "dVidPlaying");

		if (dxVidPlaying == NULL)
		{
			cout << "Function dxVidPlaying (\"dVidPlaying\") not found in DLL!\n";
		}

		dxVidStop = (LPDVIDSTOP)GetProcAddress ((HMODULE)HW_DLL, "dVidStop");

		if (dxVidStop == NULL)
		{
			cout << "Function dxVidStop (\"dVidStop\") not found in DLL!\n";
		}

		dxVidPause = (LPDVIDPAUSE)GetProcAddress ((HMODULE)HW_DLL, "dVidPause");

		if (dxVidPause == NULL)
		{
			cout << "Function dxVidPause (\"dVidPause\") not found in DLL!\n";
		}

		dxVidGetPosition = (LPDVIDGETPOSITION)GetProcAddress ((HMODULE)HW_DLL, "dVidGetPosition");

		if (dxVidGetPosition == NULL)
		{
			cout << "Function dxVidGetPosition (\"dVidGetPosition\") not found in DLL!\n";
		}

		dxVidSetPosition = (LPDVIDSETPOSITION)GetProcAddress ((HMODULE)HW_DLL, "dVidSetPosition");

		if (dxVidSetPosition == NULL)
		{
			cout << "Function dxVidSetPosition (\"dVidSetPosition\") not found in DLL!\n";
		}

		dxVidMuted = (LPDVIDMUTED)GetProcAddress ((HMODULE)HW_DLL, "dVidMuted");

		if (dxVidMuted == NULL)
		{
			cout << "Function dxVidMuted (\"dVidMuted\") not found in DLL!\n";
		}

		dxVidMute = (LPDVIDMUTE)GetProcAddress ((HMODULE)HW_DLL, "dVidMute");

		if (dxVidMute == NULL)
		{
			cout << "Function dxVidMute (\"dVidMute\") not found in DLL!\n";
		}

		dxVidUnMute = (LPDVIDUNMUTE)GetProcAddress ((HMODULE)HW_DLL, "dVidUnMute");

		if (dxVidUnMute == NULL)
		{
			cout << "Function dxVidUnMute (\"dVidUnMute\") not found in DLL!\n";
		}

		dxVidGetVolume = (LPDVIDGETVOLUME)GetProcAddress ((HMODULE)HW_DLL, "dVidGetVolume");

		if (dxVidGetVolume == NULL)
		{
			cout << "Function dxVidGetVolume (\"dVidGetVolume\") not found in DLL!\n";
		}

		dxVidSetVolume = (LPDVIDSETVOLUME)GetProcAddress ((HMODULE)HW_DLL, "dVidSetVolume");

		if (dxVidSetVolume == NULL)
		{
			cout << "Function dxVidSetVolume (\"dVidSetVolume\") not found in DLL!\n";
		}

		dxVidGetSubtitleCount = (LPDVIDGETSUBTITLECOUNT)GetProcAddress ((HMODULE)HW_DLL, "dVidGetSubtitleCount");

		if (dxVidGetSubtitleCount == NULL)
		{
			cout << "Function dxVidGetSubtitleCount (\"dVidGetSubtitleCount\") not found in DLL!\n";
		}

		dxVidGetAudioTrackCount = (LPDVIDGETAUDIOTRACKCOUNT)GetProcAddress ((HMODULE)HW_DLL, "dVidGetAudioTrackCount");

		if (dxVidGetAudioTrackCount == NULL)
		{
			cout << "Function dxVidGetAudioTrackCount (\"dVidGetAudioTrackCount\") not found in DLL!\n";
		}

		dxVidGetAudioTrackDescription = (LPDVIDGETAUDIOTRACKDESCRIPTION)GetProcAddress ((HMODULE)HW_DLL, "dVidGetAudioTrackDescription");

		if (dxVidGetAudioTrackDescription == NULL)
		{
			cout << "Function dxVidGetAudioTrackDescription (\"dVidGetAudioTrackDescription\") not found in DLL!\n";
		}

		dxVidSetAudioTrack = (LPDVIDSETAUDIOTRACK)GetProcAddress ((HMODULE)HW_DLL, "dVidSetAudioTrack");

		if (dxVidSetAudioTrack == NULL)
		{
			cout << "Function dxVidSetAudioTrack (\"dVidSetAudioTrack\") not found in DLL!\n";
		}

		dxVidGetSubtitleDescription = (LPDVIDGETSUBTITLEDESCRIPTION)GetProcAddress ((HMODULE)HW_DLL, "dVidGetSubtitleDescription");

		if (dxVidGetSubtitleDescription == NULL)
		{
			cout << "Function dxVidGetSubtitleDescription (\"dVidGetSubtitleDescription\") not found in DLL!\n";
		}

		dxVidSetSubtitle = (LPDVIDSETSUBTITLE)GetProcAddress ((HMODULE)HW_DLL, "dVidSetSubtitle");

		if (dxVidSetSubtitle == NULL)
		{
			cout << "Function dxVidSetSubtitle (\"dVidSetSubtitle\") not found in DLL!\n";
		}

		dxRequestFile = (LPDREQUESTFILE)GetProcAddress ((HMODULE)HW_DLL, "dRequestFile");

		if (dxRequestFile == NULL)
		{
			cout << "Function dxRequestFile (\"dRequestFile\") not found in DLL!\n";
		}

		dxVidGetPlayRate = (LPDVIDGETPLAYRATE)GetProcAddress ((HMODULE)HW_DLL, "dVidGetPlayRate");

		if (dxVidGetPlayRate == NULL)
		{
			cout << "Function dxVidGetPlayRate (\"dVidGetPlayRate\") not found in DLL!\n";
		}

		dxVidSetPlayRate = (LPDVIDSETPLAYRATE)GetProcAddress ((HMODULE)HW_DLL, "dVidSetPlayRate");

		if (dxVidSetPlayRate == NULL)
		{
			cout << "Function dxVidSetPlayRate (\"dVidSetPlayRate\") not found in DLL!\n";
		}

		dxDx11Present = (LPDDX11PRESENT)GetProcAddress ((HMODULE)HW_DLL, "dDx11Present");

		if (dxDx11Present == NULL)
		{
			cout << "Function dxDx11Present (\"dDx11Present\") not found in DLL!\n";
		}

		dxBeginScene = (LPDBEGINSCENE)GetProcAddress ((HMODULE)HW_DLL, "dBeginScene");

		if (dxBeginScene == NULL)
		{
			cout << "Function dxBeginScene (\"dBeginScene\") not found in DLL!\n";
		}

		dxEndScene = (LPDENDSCENE)GetProcAddress ((HMODULE)HW_DLL, "dEndScene");

		if (dxEndScene == NULL)
		{
			cout << "Function dxEndScene (\"dEndScene\") not found in DLL!\n";
		}

		dxRenderEntity = (LPDRENDERENTITY)GetProcAddress ((HMODULE)HW_DLL, "dRenderEntity");

		if (dxRenderEntity == NULL)
		{
			cout << "Function dxRenderEntity (\"dRenderEntity\") not found in DLL!\n";
		}

		dxRenderCls = (LPDRENDERCLS)GetProcAddress ((HMODULE)HW_DLL, "dRenderCls");

		if (dxRenderCls == NULL)
		{
			cout << "Function dxRenderCls (\"dRenderCls\") not found in DLL!\n";
		}

		dx11GetMaxFeatureLevel = (LPD11GETMAXFEATURELEVEL)GetProcAddress ((HMODULE)HW_DLL, "d11GetMaxFeatureLevel");

		if (dx11GetMaxFeatureLevel == NULL)
		{
			cout << "Function dx11GetMaxFeatureLevel (\"d11GetMaxFeatureLevel\") not found in DLL!\n";
		}

		dx11SoftwareEmulation = (LPD11SOFTWAREEMULATION)GetProcAddress ((HMODULE)HW_DLL, "d11SoftwareEmulation");

		if (dx11SoftwareEmulation == NULL)
		{
			cout << "Function dx11SoftwareEmulation (\"d11SoftwareEmulation\") not found in DLL!\n";
		}

		dx11NoSoftwareEmulation = (LPD11NOSOFTWAREEMULATION)GetProcAddress ((HMODULE)HW_DLL, "d11NoSoftwareEmulation");

		if (dx11NoSoftwareEmulation == NULL)
		{
			cout << "Function dx11NoSoftwareEmulation (\"d11NoSoftwareEmulation\") not found in DLL!\n";
		}

		dxDebugSilent = (LPDDEBUGSILENT)GetProcAddress ((HMODULE)HW_DLL, "dDebugSilent");

		if (dxDebugSilent == NULL)
		{
			cout << "Function dxDebugSilent (\"dDebugSilent\") not found in DLL!\n";
		}

		dxDebugLoud = (LPDDEBUGLOUD)GetProcAddress ((HMODULE)HW_DLL, "dDebugLoud");

		if (dxDebugLoud == NULL)
		{
			cout << "Function dxDebugLoud (\"dDebugLoud\") not found in DLL!\n";
		}

		dxDebugHarsh = (LPDDEBUGHARSH)GetProcAddress ((HMODULE)HW_DLL, "dDebugHarsh");

		if (dxDebugHarsh == NULL)
		{
			cout << "Function dxDebugHarsh (\"dDebugHarsh\") not found in DLL!\n";
		}

		dxDebugLoudAndHarsh = (LPDDEBUGLOUDANDHARSH)GetProcAddress ((HMODULE)HW_DLL, "dDebugLoudAndHarsh");

		if (dxDebugLoudAndHarsh == NULL)
		{
			cout << "Function dxDebugLoudAndHarsh (\"dDebugLoudAndHarsh\") not found in DLL!\n";
		}

		dxLoadAnimMesh = (LPDLOADANIMMESH)GetProcAddress ((HMODULE)HW_DLL, "dLoadAnimMesh");

		if (dxLoadAnimMesh == NULL)
		{
			cout << "Function dxLoadAnimMesh (\"dLoadAnimMesh\") not found in DLL!\n";
		}

		dxAnimate = (LPDANIMATE)GetProcAddress ((HMODULE)HW_DLL, "dAnimate");

		if (dxAnimate == NULL)
		{
			cout << "Function dxAnimate (\"dAnimate\") not found in DLL!\n";
		}

		dxSetAnimTime = (LPDSETANIMTIME)GetProcAddress ((HMODULE)HW_DLL, "dSetAnimTime");

		if (dxSetAnimTime == NULL)
		{
			cout << "Function dxSetAnimTime (\"dSetAnimTime\") not found in DLL!\n";
		}

		dxAnimTime = (LPDANIMTIME)GetProcAddress ((HMODULE)HW_DLL, "dAnimTime");

		if (dxAnimTime == NULL)
		{
			cout << "Function dxAnimTime (\"dAnimTime\") not found in DLL!\n";
		}

		dxAnimating = (LPDANIMATING)GetProcAddress ((HMODULE)HW_DLL, "dAnimating");

		if (dxAnimating == NULL)
		{
			cout << "Function dxAnimating (\"dAnimating\") not found in DLL!\n";
		}

		dxCountBones = (LPDCOUNTBONES)GetProcAddress ((HMODULE)HW_DLL, "dCountBones");

		if (dxCountBones == NULL)
		{
			cout << "Function dxCountBones (\"dCountBones\") not found in DLL!\n";
		}

		dxBoneName = (LPDBONENAME)GetProcAddress ((HMODULE)HW_DLL, "dBoneName");

		if (dxBoneName == NULL)
		{
			cout << "Function dxBoneName (\"dBoneName\") not found in DLL!\n";
		}

		dxBoneX = (LPDBONEX)GetProcAddress ((HMODULE)HW_DLL, "dBoneX");

		if (dxBoneX == NULL)
		{
			cout << "Function dxBoneX (\"dBoneX\") not found in DLL!\n";
		}

		dxBoneY = (LPDBONEY)GetProcAddress ((HMODULE)HW_DLL, "dBoneY");

		if (dxBoneY == NULL)
		{
			cout << "Function dxBoneY (\"dBoneY\") not found in DLL!\n";
		}

		dxBoneZ = (LPDBONEZ)GetProcAddress ((HMODULE)HW_DLL, "dBoneZ");

		if (dxBoneZ == NULL)
		{
			cout << "Function dxBoneZ (\"dBoneZ\") not found in DLL!\n";
		}

		dxBonePitch = (LPDBONEPITCH)GetProcAddress ((HMODULE)HW_DLL, "dBonePitch");

		if (dxBonePitch == NULL)
		{
			cout << "Function dxBonePitch (\"dBonePitch\") not found in DLL!\n";
		}

		dxBoneYaw = (LPDBONEYAW)GetProcAddress ((HMODULE)HW_DLL, "dBoneYaw");

		if (dxBoneYaw == NULL)
		{
			cout << "Function dxBoneYaw (\"dBoneYaw\") not found in DLL!\n";
		}

		dxBoneRoll = (LPDBONEROLL)GetProcAddress ((HMODULE)HW_DLL, "dBoneRoll");

		if (dxBoneRoll == NULL)
		{
			cout << "Function dxBoneRoll (\"dBoneRoll\") not found in DLL!\n";
		}

		dxMoveBone = (LPDMOVEBONE)GetProcAddress ((HMODULE)HW_DLL, "dMoveBone");

		if (dxMoveBone == NULL)
		{
			cout << "Function dxMoveBone (\"dMoveBone\") not found in DLL!\n";
		}

		dxTurnBone = (LPDTURNBONE)GetProcAddress ((HMODULE)HW_DLL, "dTurnBone");

		if (dxTurnBone == NULL)
		{
			cout << "Function dxTurnBone (\"dTurnBone\") not found in DLL!\n";
		}

		dxGetBoneParent = (LPDGETBONEPARENT)GetProcAddress ((HMODULE)HW_DLL, "dGetBoneParent");

		if (dxGetBoneParent == NULL)
		{
			cout << "Function dxGetBoneParent (\"dGetBoneParent\") not found in DLL!\n";
		}

		dxGetRootBone = (LPDGETROOTBONE)GetProcAddress ((HMODULE)HW_DLL, "dGetRootBone");

		if (dxGetRootBone == NULL)
		{
			cout << "Function dxGetRootBone (\"dGetRootBone\") not found in DLL!\n";
		}

		dxCountBoneChildren = (LPDCOUNTBONECHILDREN)GetProcAddress ((HMODULE)HW_DLL, "dCountBoneChildren");

		if (dxCountBoneChildren == NULL)
		{
			cout << "Function dxCountBoneChildren (\"dCountBoneChildren\") not found in DLL!\n";
		}

		dxGetBoneChild = (LPDGETBONECHILD)GetProcAddress ((HMODULE)HW_DLL, "dGetBoneChild");

		if (dxGetBoneChild == NULL)
		{
			cout << "Function dxGetBoneChild (\"dGetBoneChild\") not found in DLL!\n";
		}

		dxCountBoneSiblings = (LPDCOUNTBONESIBLINGS)GetProcAddress ((HMODULE)HW_DLL, "dCountBoneSiblings");

		if (dxCountBoneSiblings == NULL)
		{
			cout << "Function dxCountBoneSiblings (\"dCountBoneSiblings\") not found in DLL!\n";
		}

		dxGetBoneSibling = (LPDGETBONESIBLING)GetProcAddress ((HMODULE)HW_DLL, "dGetBoneSibling");

		if (dxGetBoneSibling == NULL)
		{
			cout << "Function dxGetBoneSibling (\"dGetBoneSibling\") not found in DLL!\n";
		}

		dxScaleBone = (LPDSCALEBONE)GetProcAddress ((HMODULE)HW_DLL, "dScaleBone");

		if (dxScaleBone == NULL)
		{
			cout << "Function dxScaleBone (\"dScaleBone\") not found in DLL!\n";
		}

		dxBoneScaleX = (LPDBONESCALEX)GetProcAddress ((HMODULE)HW_DLL, "dBoneScaleX");

		if (dxBoneScaleX == NULL)
		{
			cout << "Function dxBoneScaleX (\"dBoneScaleX\") not found in DLL!\n";
		}

		dxBoneScaleY = (LPDBONESCALEY)GetProcAddress ((HMODULE)HW_DLL, "dBoneScaleY");

		if (dxBoneScaleY == NULL)
		{
			cout << "Function dxBoneScaleY (\"dBoneScaleY\") not found in DLL!\n";
		}

		dxBoneScaleZ = (LPDBONESCALEZ)GetProcAddress ((HMODULE)HW_DLL, "dBoneScaleZ");

		if (dxBoneScaleZ == NULL)
		{
			cout << "Function dxBoneScaleZ (\"dBoneScaleZ\") not found in DLL!\n";
		}

		dxCountBoneInfluences = (LPDCOUNTBONEINFLUENCES)GetProcAddress ((HMODULE)HW_DLL, "dCountBoneInfluences");

		if (dxCountBoneInfluences == NULL)
		{
			cout << "Function dxCountBoneInfluences (\"dCountBoneInfluences\") not found in DLL!\n";
		}

		dxGetBoneInfluenceVertex = (LPDGETBONEINFLUENCEVERTEX)GetProcAddress ((HMODULE)HW_DLL, "dGetBoneInfluenceVertex");

		if (dxGetBoneInfluenceVertex == NULL)
		{
			cout << "Function dxGetBoneInfluenceVertex (\"dGetBoneInfluenceVertex\") not found in DLL!\n";
		}

		dxGetBoneInfluenceSurface = (LPDGETBONEINFLUENCESURFACE)GetProcAddress ((HMODULE)HW_DLL, "dGetBoneInfluenceSurface");

		if (dxGetBoneInfluenceSurface == NULL)
		{
			cout << "Function dxGetBoneInfluenceSurface (\"dGetBoneInfluenceSurface\") not found in DLL!\n";
		}

		dxGetBoneInfluenceWeight = (LPDGETBONEINFLUENCEWEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dGetBoneInfluenceWeight");

		if (dxGetBoneInfluenceWeight == NULL)
		{
			cout << "Function dxGetBoneInfluenceWeight (\"dGetBoneInfluenceWeight\") not found in DLL!\n";
		}

		dxFindBone = (LPDFINDBONE)GetProcAddress ((HMODULE)HW_DLL, "dFindBone");

		if (dxFindBone == NULL)
		{
			cout << "Function dxFindBone (\"dFindBone\") not found in DLL!\n";
		}

		dxRenameBone = (LPDRENAMEBONE)GetProcAddress ((HMODULE)HW_DLL, "dRenameBone");

		if (dxRenameBone == NULL)
		{
			cout << "Function dxRenameBone (\"dRenameBone\") not found in DLL!\n";
		}

		dxCountVertexInfluences = (LPDCOUNTVERTEXINFLUENCES)GetProcAddress ((HMODULE)HW_DLL, "dCountVertexInfluences");

		if (dxCountVertexInfluences == NULL)
		{
			cout << "Function dxCountVertexInfluences (\"dCountVertexInfluences\") not found in DLL!\n";
		}

		dxGetVertexInfluenceBone = (LPDGETVERTEXINFLUENCEBONE)GetProcAddress ((HMODULE)HW_DLL, "dGetVertexInfluenceBone");

		if (dxGetVertexInfluenceBone == NULL)
		{
			cout << "Function dxGetVertexInfluenceBone (\"dGetVertexInfluenceBone\") not found in DLL!\n";
		}

		dxGetVertexInfluenceWeight = (LPDGETVERTEXINFLUENCEWEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dGetVertexInfluenceWeight");

		if (dxGetVertexInfluenceWeight == NULL)
		{
			cout << "Function dxGetVertexInfluenceWeight (\"dGetVertexInfluenceWeight\") not found in DLL!\n";
		}

		dxSetBoneInfluenceWeight = (LPDSETBONEINFLUENCEWEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dSetBoneInfluenceWeight");

		if (dxSetBoneInfluenceWeight == NULL)
		{
			cout << "Function dxSetBoneInfluenceWeight (\"dSetBoneInfluenceWeight\") not found in DLL!\n";
		}

		dxFreeBoneInfluence = (LPDFREEBONEINFLUENCE)GetProcAddress ((HMODULE)HW_DLL, "dFreeBoneInfluence");

		if (dxFreeBoneInfluence == NULL)
		{
			cout << "Function dxFreeBoneInfluence (\"dFreeBoneInfluence\") not found in DLL!\n";
		}

		dxBoneParent = (LPDBONEPARENT)GetProcAddress ((HMODULE)HW_DLL, "dBoneParent");

		if (dxBoneParent == NULL)
		{
			cout << "Function dxBoneParent (\"dBoneParent\") not found in DLL!\n";
		}

		dxFreeBone = (LPDFREEBONE)GetProcAddress ((HMODULE)HW_DLL, "dFreeBone");

		if (dxFreeBone == NULL)
		{
			cout << "Function dxFreeBone (\"dFreeBone\") not found in DLL!\n";
		}

		dxCountCaptureDevices = (LPDCOUNTCAPTUREDEVICES)GetProcAddress ((HMODULE)HW_DLL, "dCountCaptureDevices");

		if (dxCountCaptureDevices == NULL)
		{
			cout << "Function dxCountCaptureDevices (\"dCountCaptureDevices\") not found in DLL!\n";
		}

		dxCaptureName = (LPDCAPTURENAME)GetProcAddress ((HMODULE)HW_DLL, "dCaptureName");

		if (dxCaptureName == NULL)
		{
			cout << "Function dxCaptureName (\"dCaptureName\") not found in DLL!\n";
		}

		dxOpenCaptureDevice = (LPDOPENCAPTUREDEVICE)GetProcAddress ((HMODULE)HW_DLL, "dOpenCaptureDevice");

		if (dxOpenCaptureDevice == NULL)
		{
			cout << "Function dxOpenCaptureDevice (\"dOpenCaptureDevice\") not found in DLL!\n";
		}

		dxCaptureWidth = (LPDCAPTUREWIDTH)GetProcAddress ((HMODULE)HW_DLL, "dCaptureWidth");

		if (dxCaptureWidth == NULL)
		{
			cout << "Function dxCaptureWidth (\"dCaptureWidth\") not found in DLL!\n";
		}

		dxCaptureHeight = (LPDCAPTUREHEIGHT)GetProcAddress ((HMODULE)HW_DLL, "dCaptureHeight");

		if (dxCaptureHeight == NULL)
		{
			cout << "Function dxCaptureHeight (\"dCaptureHeight\") not found in DLL!\n";
		}

		dxUpnpSearch = (LPDUPNPSEARCH)GetProcAddress ((HMODULE)HW_DLL, "dUpnpSearch");

		if (dxUpnpSearch == NULL)
		{
			cout << "Function dxUpnpSearch (\"dUpnpSearch\") not found in DLL!\n";
		}

		dxUpnpSearchDone = (LPDUPNPSEARCHDONE)GetProcAddress ((HMODULE)HW_DLL, "dUpnpSearchDone");

		if (dxUpnpSearchDone == NULL)
		{
			cout << "Function dxUpnpSearchDone (\"dUpnpSearchDone\") not found in DLL!\n";
		}

		dxUpnpCount = (LPDUPNPCOUNT)GetProcAddress ((HMODULE)HW_DLL, "dUpnpCount");

		if (dxUpnpCount == NULL)
		{
			cout << "Function dxUpnpCount (\"dUpnpCount\") not found in DLL!\n";
		}

		dxUpnpName = (LPDUPNPNAME)GetProcAddress ((HMODULE)HW_DLL, "dUpnpName");

		if (dxUpnpName == NULL)
		{
			cout << "Function dxUpnpName (\"dUpnpName\") not found in DLL!\n";
		}

		dxSetAnimKey = (LPDSETANIMKEY)GetProcAddress ((HMODULE)HW_DLL, "dSetAnimKey");

		if (dxSetAnimKey == NULL)
		{
			cout << "Function dxSetAnimKey (\"dSetAnimKey\") not found in DLL!\n";
		}

		dxAddAnimSeq = (LPDADDANIMSEQ)GetProcAddress ((HMODULE)HW_DLL, "dAddAnimSeq");

		if (dxAddAnimSeq == NULL)
		{
			cout << "Function dxAddAnimSeq (\"dAddAnimSeq\") not found in DLL!\n";
		}

		dxEntityHWShaders = (LPDENTITYHWSHADERS)GetProcAddress ((HMODULE)HW_DLL, "dEntityHWShaders");

		if (dxEntityHWShaders == NULL)
		{
			cout << "Function dxEntityHWShaders (\"dEntityHWShaders\") not found in DLL!\n";
		}

		dxHWShaders = (LPDHWSHADERS)GetProcAddress ((HMODULE)HW_DLL, "dHWShaders");

		if (dxHWShaders == NULL)
		{
			cout << "Function dxHWShaders (\"dHWShaders\") not found in DLL!\n";
		}

		dxSurfaceHWShaders = (LPDSURFACEHWSHADERS)GetProcAddress ((HMODULE)HW_DLL, "dSurfaceHWShaders");

		if (dxSurfaceHWShaders == NULL)
		{
			cout << "Function dxSurfaceHWShaders (\"dSurfaceHWShaders\") not found in DLL!\n";
		}

		dxEntityNegative = (LPDENTITYNEGATIVE)GetProcAddress ((HMODULE)HW_DLL, "dEntityNegative");

		if (dxEntityNegative == NULL)
		{
			cout << "Function dxEntityNegative (\"dEntityNegative\") not found in DLL!\n";
		}

		dxEntityTextureBoundary = (LPDENTITYTEXTUREBOUNDARY)GetProcAddress ((HMODULE)HW_DLL, "dEntityTextureBoundary");

		if (dxEntityTextureBoundary == NULL)
		{
			cout << "Function dxEntityTextureBoundary (\"dEntityTextureBoundary\") not found in DLL!\n";
		}

		return 1;
	}
}

BBDECL void FreeDLL ()
{
	if (HW_DLL != NULL)
	{
		FreeLibrary (HW_DLL);
	}
}

String::CString<char> NativeCString(const String & S)
{
	return S.ToCString<char>();
}
