
' IMPORTANT! Don't try to run on first go!

' Build for Desktop target, THEN place a copy of Hardwired.dll into the resulting
' hwtest.buildv***\glfw\gcc_winnt\Release folder. (Alternatively, place Hardwired.dll
' in your System32 folder.) NOW you can run it!

' Note: Not compatible with mojo so don't import it -- use the Hardwired functions
' for input, etc.

Import hardwired

Function Main ()

	Local cam:Int
	Local cube:Int
	Local light:Int
	Local texture:Int
	
	If InitDLL ()
	
		dxGraphics3D 640, 480, 0, 2
		
		cam		= dxCreateCamera (0)
		cube	= dxCreateCube (0)
		light	= dxCreateLight (0, 0)
		texture	= dxLoadTexture (NativeCString ("boing.jpg"), 1)
		
		' Print texture -- always zero!
		
		dxEntityTexture cube, texture, 0, 0
		
		dxAmbientLight 48, 64, 90
		dxCameraClsColor cam, 96, 128, 180

		dxMoveEntity cube, 0, 0, 5
		dxMoveEntity light, -10, 5, -5
		
		dxPointEntity light, cube, 0
		
		Repeat
		
			dxCls
			
			dxTurnEntity cube, 0.1, 0.2, 0.4, 0
			
			dxRenderWorld 1.0
			
			dxFlip True
			
		Until dxKeyHit (1)
		
		FreeDLL ()

	Else
		Error "Hardwired.dll not found! You didn't read the instructions at the top, did you?"
	Endif
	
End
